/*
OuDiaSecond Copyright (C) 2017-2019 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
// CDlgOperationTableExport.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "MfcUtil\MfcUtil.h"
#include "str\CsvDocument\CdCsvDocument.h"
#include "str\CsvDocument\CconvCsvDocument.h"
#include "str\strtoint.h"
#include "str\vectorToFile.h"

#include "..\diagramedit.h"
#include "..\resource.h"
#include "CDlgOperationTableCsvExport.h"
#include "..\entDed\CdDedRessyaProperty.h"
#include <algorithm>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

namespace ViewOperationTable {
using namespace std ;

/////////////////////////////////////////////////////////////////////////////
// CDlgOperationTableCsvExport _CAO


CDlgOperationTableCsvExport::CDlgOperationTableCsvExport(
	const CentDedRosen* pCentDedRosen,
	const CentDedDia* pCentDedDia,
	tstring  strOperationNumber,
	int iOutStationIndex,
	bool bDisplaySecondEkiJikoku,
	bool bDisplayColonEkiJikoku,
	bool bDisplayParentSyubetsu,
	bool bDisplayNoboriLeftToRight,
	CWnd* pParent )
	: CDialog(CDlgOperationTableCsvExport::IDD, pParent)
 	, m_pCentDedRosen( pCentDedRosen )
	, m_pCentDedDia(pCentDedDia)
	, m_strOperationNumber(strOperationNumber)
	, m_bDisplaySecondEkiJikoku(bDisplaySecondEkiJikoku)
	, m_bDisplayColonEkiJikoku(bDisplayColonEkiJikoku)
	, m_bDisplayParentSyubetsu(bDisplayParentSyubetsu)
	, m_bDisplayNoboriLeftToRight(bDisplayNoboriLeftToRight)
	, m_iRadio(0)
	, m_strOperationNumberInput(strOperationNumber.c_str())
	, m_iTypeOfSearch(0)
	, m_iStationIndex(iOutStationIndex)
	, m_iInOrOut(0)
	, m_iOperationOrder(0)
	, m_iIncludeOuterTerminal(1)
{
	//{{AFX_DATA_INIT(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_INIT
}

bool CDlgOperationTableCsvExport::CheckSatisfyConditions(
	const tstring& strOperationNumber,
	list< OperationTableContent> ListOperationTableContent,
	//const CentDedRessya* pCentDedRessya,
	const deque<int>& iEkiIndexGroup)
{
	//if (m_iRadio == 0)//\̉^p
	//{
	//	const CentDedRessyaTrack aCentDedRessyaTrack =
	//		pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
	//	if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
	//		aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
	//	{
	//		return false;
	//	}
	//	if (m_strOperationNumber.empty())
	//	{
	//		return false;
	//	}
	//	return aCentDedRessyaTrack.getOperationNumber() == m_strOperationNumber;
	//}
	if (m_iRadio == 1)
	{
		if (m_strOperationNumberInput.IsEmpty())
		{
			return false;
		}

		tstring strOperationNumberInput((LPCTSTR)m_strOperationNumberInput);
		if (strOperationNumber.size() < strOperationNumberInput.size())
		{
			return false;
		}
		if (m_iTypeOfSearch == 0) //v
		{
			return strOperationNumber.find(strOperationNumberInput) != tstring::npos;
		}
		else if (m_iTypeOfSearch == 1)//Sv
		{
			return strOperationNumber == strOperationNumberInput;
		}
		else if (m_iTypeOfSearch == 2)//Ov
		{
			return strOperationNumber.compare(
				0,
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
		else if (m_iTypeOfSearch == 3)//v
		{
			return strOperationNumber.compare(
				strOperationNumber.size()-strOperationNumberInput.size(),
				strOperationNumberInput.size(),
				strOperationNumberInput) == 0;

		}
	}
	else if (m_iRadio == 2)
	{
		if (m_iInOrOut == 0)
		{
			if (ListOperationTableContent.front().iOuterShihatsuekiIndex != INT_MIN)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			else if (ListOperationTableContent.front().aRessyaProperty.getJikoku().isNull())
			{
				return false;
			}
			//const CentDedBeforeOperation* pFirstOperation = ListOperationTableContent.front().BeforeOperation;
			//if (pFirstOperation->getBOperation() == CentDedBeforeOperation::BOperation_Junction)
			//{
			//	return false;
			//}
			//else if (pFirstOperation->getBOperation() == CentDedBeforeOperation::BOperation_Outer)
			//{
			//	if (m_iIncludeOuterTerminal == 0)
			//	{
			//		return false;
			//	}
			//}

			int iSihatsuEkiIndex = m_pCentDedRosen->getCentDedEkiCont()->EkiIndexOfEkiOrder(
				ListOperationTableContent.front().aRessyaProperty.getRessyahoukou(), ListOperationTableContent.front().iSihatsuEkiOrder);
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iSihatsuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}
		}
		else if (m_iInOrOut == 1)
		{
			if (ListOperationTableContent.back().iOuterShuchakuekiIndex != INT_MIN)
			{
				if (m_iIncludeOuterTerminal == 0)
				{
					return false;
				}
			}
			else if (ListOperationTableContent.back().AfterOperation != NULL)
			{
				return false;
			}
			//const CentDedAfterOperation* pLastOperation = ListOperationTableContent.back().AfterOperation;
			//if (pLastOperation->getAOperation() == CentDedAfterOperation::AOperation_Junction)
			//{
			//	return false;
			//}
			//else if (pLastOperation->getAOperation() == CentDedAfterOperation::AOperation_Outer)
			//{
			//	if (m_iIncludeOuterTerminal == 0)
			//	{
			//		return false;
			//	}
			//}

			int iSyuuchakuEkiIndex = m_pCentDedRosen->getCentDedEkiCont()->EkiIndexOfEkiOrder(
				ListOperationTableContent.back().aRessyaProperty.getRessyahoukou(), ListOperationTableContent.back().iSyuuchakuEkiOrder);
			for (int idx = 0; idx < (int)iEkiIndexGroup.size(); idx++)
			{
				if (iSyuuchakuEkiIndex == iEkiIndexGroup[idx])
				{
					return true;
				}
			}
		}
	}
	//else if (m_iRadio == 3)
	//{
	//	const CentDedRessyaTrack aCentDedRessyaTrack =
	//		pCentDedRessya->getCentDedRessyaTrack(pCentDedRessya->getSihatsuEki());
	//	if (aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_None ||
	//		aCentDedRessyaTrack.getOperation() == CentDedRessyaTrack::Operation_Shunt)
	//	{
	//		return false;
	//	}
	//	if (aCentDedRessyaTrack.getOperationNumber().empty())
	//	{
	//		return false;
	//	}
	//	return true;
	//}
	return false;
}

void CDlgOperationTableCsvExport::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_DATA_MAP
	DDX_Radio(pDX, IDC_OperationExport_RADIO1, m_iRadio);
	DDX_Text(pDX, IDC_OperationExport_EDIT_KeyWord, m_strOperationNumberInput);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_TypeOfSearch, m_iTypeOfSearch);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Station, m_iStationIndex);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_OutOrIn, m_iInOrOut);
	DDX_CBIndex(pDX, IDC_OperationExport_COMBO_Order, m_iOperationOrder);
	DDX_Check(pDX, IDC_OperationExport_CHECK_IncludeOuterTerminal, m_iIncludeOuterTerminal);
}


BEGIN_MESSAGE_MAP(CDlgOperationTableCsvExport, CDialog)
	//{{AFX_MSG_MAP(CDlgOuJikokuhyouCsvExport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgOuJikokuhyouCsvExport bZ[W nh

BOOL CDlgOperationTableCsvExport::OnInitDialog()
{
	
	// --------------------------------
	int iRv = 0 ;
	const CentDedDia* pCentDedDia = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_pCentDedDia słB
		}
	}
	if 	( iRv >= 0 )
	{
		const Mu<const CentDedEki*>* pCentDedEkiCont = m_pCentDedRosen->getCentDedEkiCont()->getMuPtr();

		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Station);
		for (int idx = 0; idx < pCentDedEkiCont->size(); idx++ )
		{
			const CentDedEki* pCentDedEki = pCentDedEkiCont->get(idx);
			//tstring strEkimei = stringOf(idx) + ". ";
			//strEkimei = strEkimei + pCentDedEki->getEkimei();
			tstring strEkimei =  pCentDedEki->getEkimei();
			pCComboBox->AddString(strEkimei.c_str());
		}

		//pCComboBox->SetCurSel(m_iStationIndex);
	}

	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_TypeOfSearch);

		tstring strTemp = _T("ƈv");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("܂");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("Ov");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("v");
		pCComboBox->AddString(strTemp.c_str());
		//ƈv;܂;Ov;v;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_OutOrIn);

		tstring strTemp = _T("o");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("");
		pCComboBox->AddString(strTemp.c_str());
		//o;;
	}
	// R{{bNX
	{
		CComboBox*	pCComboBox = (CComboBox*)GetDlgItem(IDC_OperationExport_COMBO_Order);

		tstring strTemp = _T("^pԍɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		strTemp = _T("owɕׂ");
		pCComboBox->AddString(strTemp.c_str());
		//^pԍɕׂ;owɕׂ;
	}

	CDialog::OnInitDialog();

	// --------------------------------
	
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
	              // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CDlgOperationTableCsvExport::OnOK()
{
	int iRv = 0 ;
	UpdateData();
	CString	strError ;
	// --------------------------------
	const CentDedDia* pCentDedDia = NULL ;
	//const Mu<const CentDedRessya*>* pCentDedRessyaContGet = NULL ;
	if ( iRv >= 0 )
	{
		//pCentDedDia = m_pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get( m_iDiaIndex ) ;
		if ( m_pCentDedDia == NULL )
		{
			iRv = -11 ;	//	m_iDiaIndex słB
		}
	}
	//if 	( iRv >= 0 )
	//{
	//	pCentDedRessyaContGet = pCentDedDia->getCentDedRessyaCont( m_eRessyahoukou )->getMuPtr() ;
	//}
	//pCentDedRessyaContGet = ΏۂƂȂԃRei
	
	
	// --------------------------------
	//	͒l̎擾
	// --------------------------------
	CdDedJikoku KitenJikoku = m_pCentDedRosen->getKitenJikoku();
	deque<CdDedRessyaProperty> aRessyaPropertyContTemp2;
	deque<tstring> strOperationNumberContTemp;
	//temp2 ɓĂ͂܂^pԍ̗ԂATɕׂĂ͂B
	//e^ԓłtemp1ڂւƂɁAԒʂɕבւĂB
	//aCdDedRessyaPropertyւ́Ao掞ɈڂւB
	deque<CdDedRessyaProperty> aRessyaPropertyCont;
	deque<tstring> strOperationNumberCont;

	deque<int> iEkiIndexGroup;
	if (m_iRadio == 2)
	{
		m_pCentDedRosen->getCentDedEkiCont()->getEkiIndexBrunchLoop(
			m_iStationIndex,
			iEkiIndexGroup);
	}
	const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCentDedRessyaConts[iRessyahoukou] = m_pCentDedDia->getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
	}
	if (m_iRadio == 0)
	{
		strOperationNumberContTemp.emplace_back(m_strOperationNumber);
	}
	else
	{
		for (auto itr = m_pCentDedDia->getcontOperationTableContent().begin();
			itr != m_pCentDedDia->getcontOperationTableContent().end(); itr++)
		{
			if (itr->second.empty())
			{
				continue;
			}
			//const CentDedRessya* pCentDedRessya =
			//	pCentDedRessyaConts[itr->second.front().aRessyaProperty.getRessyahoukou()]
			//	->get(itr->second.front().aRessyaProperty.getRessyaIndex());
			if (m_iRadio == 3)
			{
				strOperationNumberContTemp.emplace_back(itr->first);
			}
			else if (CheckSatisfyConditions(itr->first, itr->second,/*pCentDedRessya,*/ iEkiIndexGroup))
			{

				strOperationNumberContTemp.emplace_back(itr->first);
			}
		}
	}
	if (strOperationNumberContTemp.empty())
	{
		return;
	}

	if (m_iOperationOrder == 0) //^pԍ~
	{
		sort(strOperationNumberContTemp.begin(), strOperationNumberContTemp.end());
		strOperationNumberCont = strOperationNumberContTemp;
	}
	else//ow
	{
		do {
			int iCurrentEarlyidx = 0;
			CdDedJikoku CurrentEarlyJikoku = 
				m_pCentDedDia->getcontOperationTableContent().at(strOperationNumberContTemp[0]).
				front().aRessyaProperty.getJikoku();
			for (int idx = 1; idx < (int)strOperationNumberContTemp.size(); idx++)
			{
				CdDedJikoku aJikoku = m_pCentDedDia->getcontOperationTableContent().at(strOperationNumberContTemp[idx]).
					front().aRessyaProperty.getJikoku();
				if (aJikoku.isNull())
				{
					continue;
				}
				if (CurrentEarlyJikoku.compare(aJikoku, KitenJikoku) > 0)
				{
					CurrentEarlyJikoku = aJikoku;
					iCurrentEarlyidx = idx;
				}
			}
			strOperationNumberCont.push_back(strOperationNumberContTemp[iCurrentEarlyidx]);
			strOperationNumberContTemp.erase(strOperationNumberContTemp.begin() + iCurrentEarlyidx);
		} while ((int)strOperationNumberContTemp.size() > 0);
	}
	
	// --------------------------------
	//	o̓t@C͒l̎擾
	// --------------------------------
	if ( iRv >= 0 )
	{
		CFileDialog aDlg( 
			FALSE , 
			_T( "csv" ) , 
			m_strCsvFilename , 
			OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
			getCDiagramEditApp()->getCFileDialogFilterCsv(), 
			this );
		if ( aDlg.DoModal() != IDOK )
		{
			iRv = -2 ;	//	Cancel܂B
		}
		else
		{
			m_strCsvFilename = aDlg.GetPathName() ;
		}
	}
	//m_strCsvFilename = w肳ꂽCSVt@C

	// --------------------------------
	//	CSVt@C̏o
	// --------------------------------
	CWaitCursor aCursor ;
	if ( iRv >= 0 )
	{
		CconvOperationTableCsv	aConv( getCDiagramEditApp()->createCconvOperationTableCsv()) ;
		CdCsvDocument	aCdCsvDocument ;
		int iResult = aConv.encode(
			*m_pCentDedRosen , 
			*m_pCentDedDia , 
			aRessyaPropertyCont,
			strOperationNumberCont,
			m_bDisplaySecondEkiJikoku,
			m_bDisplayColonEkiJikoku,
			m_bDisplayParentSyubetsu,
			m_bDisplayNoboriLeftToRight,
			&aCdCsvDocument ) ;
		//iResult = 
		//	-1 ; // iDiaIndex słB
		//	-2 ; // iRessyaIndex słB
		//	-3 ; // iRessyaCount słB 
		if ( iResult < 0 )
		{
			GetDlgItemText( IDC_TEXT_ENCODE_ERROR , strError ) ;
			//strError="CSVւ̕ϊɎs܂B"

			strError.Format( _T( "%s(%d)" ) , CString( strError ), iResult ) ; 
			iRv = iResult - 10 ;
			//	-11 ; // iDiaIndex słB
			//	-12 ; // iRessyaIndex słB
			//	-13 ; // iRessyaCount słB 
		}
		else
		{
			tstring strCsvDocument ;
			CConvCsvDocument	aCConvCsvDocument ;
			strCsvDocument = aCConvCsvDocument.encode( &aCdCsvDocument ) ;
			int iResult = stringToFile( strCsvDocument , (LPCTSTR)m_strCsvFilename ) ;
			if ( iResult < 0 )
			{
				GetDlgItemText( IDC_TEXT_FILE_SAVE_FAILED , strError ) ;
				//strError="t@Cւ̕ۑɎs܂B"

				iRv = -21 ; // t@Cւ̕ۑɎs܂B

			}
		}
	}
	//CDialog::OnOK();
}

} //namespace ViewJikokuhyou
