/*
OuDiaSecond Copyright (C) 2017-2019 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedAfterOperation.cpp
//	$Id: CentDedAfterOperation.cpp  $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"
#include "CentDedRessya.h"
#include "CentDedAfterOperation.h"
#include "CentDedAfterOperationCont.h"
#include "CentDedBeforeOperation.h"
#include <tchar.h>
#include <algorithm>

namespace entDed{


// ****************************************************************
//	CentDedAfterOperation
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
CentDedAfterOperation::CentDedAfterOperation()
{
		set(AOperation_Shunt,
			false,
			INT_MIN,
			INT_MIN,
			CdDedJikoku(),
			CdDedJikoku(),
			vector<tstring>());
};
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation eAOperation,
	bool bBoolData1,
	int iIntData1,
	int iIntData2,
	CdDedJikoku JikokuData1,
	CdDedJikoku JikokuData2)
{
	set(eAOperation,
		bBoolData1,
		iIntData1,
		iIntData2,
		JikokuData1,
		JikokuData2,
		vector<tstring>());

	//set(AOperation_Shunt,
	//	false,
	//	INT_MIN,
	//	INT_MIN,
	//	CdDedJikoku(),
	//	CdDedJikoku());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	int iShuntTrackIndex, 
	CdDedJikoku OperationHatsuJikoku, 
	CdDedJikoku OperationChakuJikoku, 
	bool bIsDisplayHatsuJikoku)
{
	set(EAOperation,
		bIsDisplayHatsuJikoku,
		iShuntTrackIndex,
		INT_MIN,
		OperationHatsuJikoku,
		OperationChakuJikoku,
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	bool bIsConnectToFront, 
	CdDedJikoku ConnectJikoku)
{
	set(EAOperation,
		bIsConnectToFront,
		INT_MIN,
		INT_MIN,
		ConnectJikoku,
		CdDedJikoku(),
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	int iReleasePos, 
	int iReleaseIndexCount, 
	CdDedJikoku ReleaseJikoku)
{
	set(EAOperation,
		false,
		iReleasePos,
		iReleaseIndexCount,
		ReleaseJikoku,
		CdDedJikoku(),
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	CdDedJikoku InJikoku)
{
	set(EAOperation,
		false,
		INT_MIN,
		INT_MIN,
		InJikoku,
		CdDedJikoku(),
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	int iOuterShuchakuekiIndex,
	CdDedJikoku	HatsuJikoku,
	CdDedJikoku	OuterShuchakuJikoku)
{
	set(EAOperation,
		false,
		iOuterShuchakuekiIndex,
		INT_MIN,
		HatsuJikoku,
		OuterShuchakuJikoku,
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	CdDedJikoku TerminalJikoku,
	bool bDisableConnectDisplay)
{
	set(EAOperation,
		bDisableConnectDisplay,
		INT_MIN,
		INT_MIN,
		TerminalJikoku,
		CdDedJikoku(),
		vector<tstring>());
}
CentDedAfterOperation::CentDedAfterOperation(
	EAOperation EAOperation,
	vector<tstring> strOperationNumber)
{
	set(EAOperation,
		false,
		INT_MIN,
		INT_MIN,
		CdDedJikoku(),
		CdDedJikoku(),
		strOperationNumber);
}

CentDedAfterOperation& CentDedAfterOperation::operator=( const CentDedAfterOperation& value )
{
	//CentDedAfterOperationCont* pBeforeOperationCont = dynamic_cast<CentDedAfterOperationCont*>( getParent() ) ;
	//if ( pBeforeOperationCont != NULL )
	//{
	//	int iResult = pBeforeOperationCont->setable( value , pBeforeOperationCont->getIndex( this ) ) ;
	//	if ( iResult < 0 ){
	//		throw( LException() ) ;
	//	}
	//}
	super::operator=( value ) ; 

	// --------------------------------
	m_eAOperation = value.m_eAOperation;
	m_bBoolData1 = value.m_bBoolData1;
	m_iIntData1 = value.m_iIntData1;
	m_iIntData2 = value.m_iIntData2;
	m_JikokuData1 = value.m_JikokuData1;
	m_JikokuData2 = value.m_JikokuData2;
	m_strOperationNumber1 = value.m_strOperationNumber1;

	return *this ;
}

	// ********************************
	//@name CParentBase-
	// ********************************
void CentDedAfterOperation::setParent( CParentBase* pParent )
{
	super::setParent( pParent ) ; 
}


	// ********************************
	//@name CentDedAfterOperation-
	// ********************************

//CentDedAfterOperation& CentDedAfterOperation::setAOperation(const CentDedAfterOperation::EAOperation value)
//{
//	m_eAOperation = value;
//
//	m_bBoolData1 = false;
//	m_bBoolData2 = false;
//	m_iIntData1 = INT_MIN;
//	m_iIntData2 = INT_MIN;
//	m_JikokuData1.setNull();
//	m_JikokuData2.setNull();
//	m_strOperationNumber1.clear();
//	m_strOperationNumber2.clear();
//	m_strOperationNumber3.clear();
//	m_CentDedAfterOperationCont.erase(0, INT_MAX);
//	m_CentDedAfterOperationCont.erase(0, INT_MAX);
//	
//	if (m_eAOperation == AOperation_Connect)
//	{
//		//m_CentDedAfterOperationCont
//	}
//	else if (m_eAOperation == AOperation_Release)
//	{
//		//m_CentDedAfterOperationCont
//	}
//	return *this ; 
//} ;

void CentDedAfterOperation::mergeOperationNumber()
{
	if (m_eAOperation == AOperation_Connect)
	{
		if (m_bBoolData1)
		{
			if (m_strOperationNumber3.empty())
			{
				m_strOperationNumber1.clear();
				m_strOperationNumber1.push_back(_T(""));
			}
			else
			{
				m_strOperationNumber1 = m_strOperationNumber3;
			}

			if (m_strOperationNumber2.empty())
			{
				m_strOperationNumber1.push_back(_T(""));
			}
			else
			{
				m_strOperationNumber1.insert(m_strOperationNumber1.end(),
					m_strOperationNumber2.begin(), m_strOperationNumber2.end());
			}
		}
		else
		{
			if (m_strOperationNumber2.empty())
			{
				m_strOperationNumber1.clear();
				m_strOperationNumber1.push_back(_T(""));
			}
			else
			{
				m_strOperationNumber1 = m_strOperationNumber2;
			}

			if (m_strOperationNumber3.empty())
			{
				m_strOperationNumber1.push_back(_T(""));
			}
			else
			{
				m_strOperationNumber1.insert(m_strOperationNumber1.end(),
					m_strOperationNumber3.begin(), m_strOperationNumber3.end());
			}
		}
	}
}

void CentDedAfterOperation::splitOperationNumber()
{
	if (m_eAOperation == AOperation_Release)
	{
		if (m_strOperationNumber1.empty())
		{
			m_strOperationNumber2.push_back(tstring());
			m_strOperationNumber3.push_back(tstring());
		}
		else if (m_strOperationNumber1.size() == 1)
		{
			m_strOperationNumber2 = m_strOperationNumber1;
			m_strOperationNumber3.push_back(tstring());
		}
		else if (m_iIntData1 == 0)
		{
			int iMainSize = max(1, ((int)m_strOperationNumber1.size() - m_iIntData2));
			m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iMainSize);
			m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin() + iMainSize, m_strOperationNumber1.end());
		}
		else if (m_iIntData1 == 1)
		{
			int iSubSize = min((int)m_strOperationNumber1.size() - 1, m_iIntData2);
			m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iSubSize);
			m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin() + iSubSize, m_strOperationNumber1.end());
		}
		else
		{
			int iMainSize = min((int)m_strOperationNumber1.size() - 1, m_iIntData2);
			m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iMainSize);
			m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin() + iMainSize, m_strOperationNumber1.end());
		}
		//if (m_iIntData1 == 0)
		//{
		//	int iMainSize = max(1, ((int)m_strOperationNumber1.size() - m_iIntData2));
		//	m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iMainSize);
		//	m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin() + iMainSize, m_strOperationNumber1.end());
		//	int iAddSize = m_iIntData2 - m_strOperationNumber1.size() + 1;
		//	if (iAddSize > 0)
		//	{
		//		m_strOperationNumber3.insert(m_strOperationNumber3.end(), iAddSize, tstring());
		//		//m_strOperationNumberSub.insert(m_strOperationNumberSub.end(), vector<tstring>(iAddSize));
		//	}
		//}
		//else if (m_iIntData1 == 1)
		//{
		//	int iSubSize = min((int)m_strOperationNumber1.size(), m_iIntData2);
		//	m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iSubSize);
		//	if ((int)m_strOperationNumber1.size() < m_iIntData2)
		//	{
		//		m_strOperationNumber3.insert(m_strOperationNumber3.end(),
		//			(m_iIntData2 - m_strOperationNumber1.size()), tstring());
		//		//m_strOperationNumberSub.insert(m_strOperationNumberSub.end(), 
		//		   // vector<tstring>(m_iReleaseIndexCount- value.size()));
		//	}
		//	if ((int)m_strOperationNumber1.size() > m_iIntData2)
		//	{
		//		m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin() + iSubSize, m_strOperationNumber1.end());
		//	}
		//	else
		//	{
		//		m_strOperationNumber2 = vector<tstring>(1);
		//	}
		//}
		//else
		//{
		//	int iMainSize = min((int)m_strOperationNumber1.size(), m_iIntData2);
		//	m_strOperationNumber2 = vector<tstring>(m_strOperationNumber1.begin(), m_strOperationNumber1.begin() + iMainSize);
		//	if (iMainSize < (int)m_strOperationNumber1.size())
		//	{
		//		m_strOperationNumber3 = vector<tstring>(m_strOperationNumber1.begin() + iMainSize, m_strOperationNumber1.end());
		//	}
		//	else
		//	{
		//		m_strOperationNumber3 = vector<tstring>(1);
		//	}
		//}
	}
}

void CentDedAfterOperation::modifyOperationJikoku(int iSecond)
{
	if (m_eAOperation == AOperation_Shunt)
	{
		m_JikokuData1.addSeconds(iSecond);
		m_JikokuData2.addSeconds(iSecond);
	}
	else if (m_eAOperation == AOperation_Connect)
	{
		m_JikokuData1.addSeconds(iSecond);
		m_CentDedAfterOperationCont.modifyOperationJikoku(iSecond);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		m_JikokuData1.addSeconds(iSecond);
		m_CentDedAfterOperationCont.modifyOperationJikoku(iSecond);
	}
	else if (m_eAOperation == AOperation_In)
	{
		m_JikokuData1.addSeconds(iSecond);
	}
	else if (m_eAOperation == AOperation_Outer)
	{
		m_JikokuData1.addSeconds(iSecond);
		m_JikokuData2.addSeconds(iSecond);
	}
	else if (m_eAOperation == AOperation_Junction)
	{
		m_JikokuData1.addSeconds(iSecond);
	}
}

bool CentDedAfterOperation::isLastOperation() const
{
	return (m_eAOperation == AOperation_In ||
		m_eAOperation == AOperation_Outer ||
		m_eAOperation == AOperation_Junction);
}

void CentDedAfterOperation::clearOperationNumber()
{
	if (m_eAOperation == AOperation_Connect)
	{
		m_strOperationNumber1.clear();
		m_strOperationNumber2.clear();
		m_strOperationNumber3.clear();
		m_bBoolData2 = false;//Ґ^Ԋ蓖čς݃`FbN
	}
	else if (m_eAOperation == AOperation_Release)
	{
		m_strOperationNumber1.clear();
		m_strOperationNumber2.clear();
		m_strOperationNumber3.clear();
	}
	else if (m_eAOperation == AOperation_In)
	{
		m_strOperationNumber1.clear();
	}
	else if (m_eAOperation == AOperation_Outer)
	{
		m_strOperationNumber1.clear();
	}
	else if (m_eAOperation == AOperation_Junction)
	{
		m_strOperationNumber1.clear();
		m_bBoolData2 = false;//Ԃ (2.00.05ύX)
		m_iIntData1 = -1;//wOrder
		m_JikokuData2.setNull();//OԐڑ(ݐ\)
		m_iIntData2 = 0;//Oԕ(ݐ\)
	}
	else if (m_eAOperation == AOperation_NumberChange)
	{
		m_strOperationNumber2.clear();
	}
}

void CentDedAfterOperation::trimSuffixOperationNumber()
{
	if (m_eAOperation == AOperation_Connect ||
		m_eAOperation == AOperation_Release)
	{
		for (int idx = 0; idx < (int)m_strOperationNumber1.size(); idx++)
		{
			tstring::size_type pos = 0;
			pos = m_strOperationNumber1[idx].find(';');
			if (pos != tstring::npos)
			{
				tstring strTemp = m_strOperationNumber1[idx].substr(0, pos);
				m_strOperationNumber1[idx] = strTemp;
			}
		}
		for (int idx = 0; idx < (int)m_strOperationNumber2.size(); idx++)
		{
			tstring::size_type pos = 0;
			pos = m_strOperationNumber2[idx].find(';');
			if (pos != tstring::npos)
			{
				tstring strTemp = m_strOperationNumber2[idx].substr(0, pos);
				m_strOperationNumber2[idx] = strTemp;
			}
		}
		for (int idx = 0; idx < (int)m_strOperationNumber3.size(); idx++)
		{
			tstring::size_type pos = 0;
			pos = m_strOperationNumber3[idx].find(';');
			if (pos != tstring::npos)
			{
				tstring strTemp = m_strOperationNumber3[idx].substr(0, pos);
				m_strOperationNumber3[idx] = strTemp;
			}
		}
	}
}

void CentDedAfterOperation::adjustOperation()
{
	if (m_eAOperation == AOperation_Connect)
	{
		//CentDedOperationBeforeCont* pOperationCont = getCentDedOperationBeforeCont();
		if (getCentDedBeforeOperationCont()->size() == 0)
		{
			getCentDedBeforeOperationCont()->insert(
				CentDedBeforeOperation(
					CentDedBeforeOperation::BOperation_Junction,
					CdDedJikoku(),
					false,
					vector<tstring>()));
		}
		else
		{
			if (!getCentDedBeforeOperationCont()->get(0).isFirstOperation())
			{
				getCentDedBeforeOperationCont()->insert(
					CentDedBeforeOperation(
						CentDedBeforeOperation::BOperation_Junction,
						CdDedJikoku(),
						false,
						vector<tstring>()), 0);
			}
			for (int idx = getCentDedBeforeOperationCont()->size() - 1; idx > 0; idx--)
			{
				if(getCentDedBeforeOperationCont()->get(idx).getBOperation() == CentDedBeforeOperation::BOperation_Connect ||
					getCentDedBeforeOperationCont()->get(idx).getBOperation() == CentDedBeforeOperation::BOperation_Release)
				{
					getCentDedBeforeOperationCont()->getMuPtr()->get(idx)->adjustOperation();
				}
				else if (getCentDedBeforeOperationCont()->get(idx).isFirstOperation())
				{
					getCentDedBeforeOperationCont()->erase(idx);
				}

			}
		}
	}
	else if (m_eAOperation == AOperation_Release)
	{
		if (getCentDedAfterOperationCont()->size() == 0)
		{
			getCentDedAfterOperationCont()->insert(
				CentDedAfterOperation(
					AOperation_Junction,
					CdDedJikoku(),
					false));
		}
		else
		{

			if (!getCentDedAfterOperationCont()->get(INT_MAX).isLastOperation())
			{
				getCentDedAfterOperationCont()->insert(
					CentDedAfterOperation(
						AOperation_Junction,
						CdDedJikoku(),
						false), INT_MAX);
			}
			for (int idx = getCentDedAfterOperationCont()->size() - 2; idx >= 0; idx--)
			{
				if (getCentDedAfterOperationCont()->get(idx).getAOperation() == AOperation_Connect ||
					getCentDedAfterOperationCont()->get(idx).getAOperation() == AOperation_Release)
				{
					getCentDedAfterOperationCont()->getMuPtr()->get(idx)->adjustOperation();
				}
				else if (getCentDedAfterOperationCont()->get(idx).isLastOperation())
				{
					getCentDedAfterOperationCont()->erase(idx);
				}

			}
		}
	}
}

void CentDedAfterOperation::adjustEkiTrack2(const std::vector<int>& iEkiTrack2Map)
{
	if (m_eAOperation == AOperation_Shunt)
	{
		if (iEkiTrack2Map[m_iIntData1] != m_iIntData1)
		{
			m_iIntData1 = iEkiTrack2Map[m_iIntData1];
		}
	}
	else if (m_eAOperation == AOperation_Connect)
	{
		getCentDedBeforeOperationCont()->adjustEkiTrack2(iEkiTrack2Map);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		getCentDedAfterOperationCont()->adjustEkiTrack2(iEkiTrack2Map);
	}
}

void CentDedAfterOperation::adjustOuterTerminal(const std::vector<int>& iOuterTerminalEkimeiMap)
{
	if (m_eAOperation == AOperation_Connect)
	{
		getCentDedBeforeOperationCont()->adjustOuterTerminal(iOuterTerminalEkimeiMap);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		getCentDedAfterOperationCont()->adjustOuterTerminal(iOuterTerminalEkimeiMap);
	}
	else if (m_eAOperation == AOperation_Outer)
	{
		if (iOuterTerminalEkimeiMap[m_iIntData1] != m_iIntData1)
		{
			m_iIntData1 = iOuterTerminalEkimeiMap[m_iIntData1];
		}
	}
}

void CentDedAfterOperation::fixOperation(
	const int iEkiTrackCount, 
	const int iOuterTerminalCount)
{
	if (m_eAOperation == AOperation_Shunt)
	{
		if (m_iIntData1 >= iEkiTrackCount)
		{
			m_iIntData1 = 0;
		}
	}
	else if (m_eAOperation == AOperation_Connect)
	{
		getCentDedBeforeOperationCont()->fixOperation(iEkiTrackCount, iOuterTerminalCount);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		getCentDedAfterOperationCont()->fixOperation(iEkiTrackCount, iOuterTerminalCount);
	}
	else if (m_eAOperation == AOperation_Outer)
	{
		if (iOuterTerminalCount == 0)
		{
			set(CentDedAfterOperation::AOperation_In,
				false,
				INT_MIN,
				INT_MIN,
				m_JikokuData1,
				CdDedJikoku(),
				vector<tstring>());

		}
		else if (m_iIntData1 >= iOuterTerminalCount)
		{
			m_iIntData1 = 0;
		}
	}
}

int CentDedAfterOperation::isExistRessyaOfEkiTrack2(int iEkiTrack2Index)
{
	if (m_eAOperation == AOperation_Shunt)
	{
		if (iEkiTrack2Index == m_iIntData1)
		{
			return 1;
		}
	}
	else if (m_eAOperation == AOperation_Connect)
	{
		return getCentDedBeforeOperationCont()->isExistRessyaOfEkiTrack2(iEkiTrack2Index);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		return getCentDedAfterOperationCont()->isExistRessyaOfEkiTrack2(iEkiTrack2Index);
	}
	return 0;
}

int CentDedAfterOperation::isExistRessyaOfOuterTerminal(int iOuterTerminalIndex)
{
	if (m_eAOperation == AOperation_Connect)
	{
		return getCentDedBeforeOperationCont()->isExistRessyaOfOuterTerminal(iOuterTerminalIndex);
	}
	else if (m_eAOperation == AOperation_Release)
	{
		return getCentDedAfterOperationCont()->isExistRessyaOfOuterTerminal(iOuterTerminalIndex);
	}
	else if (m_eAOperation == AOperation_Outer)
	{
		if (iOuterTerminalIndex == m_iIntData1)
		{
			return 1;
		}
	}
	return 0;
}

CentDedAfterOperation& CentDedAfterOperation::set(
	EAOperation eAOperation,
	bool bBoolData1,
	int iIntData1,
	int iIntData2,
	CdDedJikoku JikokuData1,
	CdDedJikoku JikokuData2,
	vector<tstring> strOperationNumber1)
{
	m_eAOperation = eAOperation;
	m_bBoolData1 = bBoolData1;
	m_bBoolData2 = false;
	m_iIntData1 = iIntData1;
	m_iIntData2 = iIntData2;
	m_JikokuData1 = JikokuData1;
	m_JikokuData2 = JikokuData2;
	m_strOperationNumber1 = strOperationNumber1;
	m_strOperationNumber2.clear();
	m_strOperationNumber3.clear();
	
	m_CentDedBeforeOperationCont.erase(0, INT_MAX);
	if (m_eAOperation == AOperation_Connect)
	{
		m_CentDedBeforeOperationCont.insert(
			CentDedBeforeOperation(
				CentDedBeforeOperation::BOperation_Junction,
				CdDedJikoku(),
				false,
				vector<tstring>()));

	}
	m_CentDedAfterOperationCont.erase(0, INT_MAX);
	if (m_eAOperation == AOperation_Release)
	{
		m_CentDedAfterOperationCont.insert(
			CentDedAfterOperation(
				AOperation_Junction,
				CdDedJikoku(),
				false));

	}
	return ( *this ) ;
};

} //namespace entDed
