/*
OuDiaSecond Copyright (C) 2017-2019 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CWndDcdGridOperationTable.cpp
//	$Id: CWndDcdGridOperationTable.cpp  $
// ****************************************************************
*/
/** @file */
#include "stdafx.h"

#include "logmsg\LogMsg.h"
#include "NsOu\OuNew.h"
#include "NsOu\dynamic_castOu.h"
#include "str\strtoint.h"
#include "DcDraw\CDcdTargetGetDC.h"
#include "DcDraw\CConverter_WinGdi.h"

#include "..\resource.h"
#include "..\entDed\CentDedRosen.h"
#include "..\DiagramEdit.h"
#include "..\CRfEditCmdHolder.h"
#include "..\DedRosenFileData\EditCmd\EditCmd.h"
#include "CWndDcdGridOperationTable.h"
#include "OperationTableColSpec\OperationTableColSpec.h"
#include "CDlgOperationTableCsvExport.h"


// ****************************************************************
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
// ****************************************************************

namespace ViewOperationTable {
using namespace std ;

// --------------------------------
///@name	Xԍ
// --------------------------------
///@{
/**
XԍFԔԍ
*/
//const int XCOLUMNNNO_RESSYANUM = 0 ;
/**
XԍF
*/
//const int XCOLUMNNNO_SYUBETSU = 1 ;
/**
XԍFԖ
*/
//const int XCOLUMNNNO_RESSYAMEI = 2 ;
/**
XԍFN_nIw
*/
//const int XCOLUMNNNO_OSEKIMEI = 3 ;
/**
XԍFN_w
*/
//const int XCOLUMNNNO_OSEKIJIKOKU = 4;
/**
XԍFԕ()
*/
//const int XCOLUMNNNO_RESSYAHOUKOU = 5;
/**
XԍFI_nIw
*/
//const int XCOLUMNNNO_TSEKIMEI = 6;
/**
XԍFI_w
*/
//const int XCOLUMNNNO_TSEKIJIKOKU = 7;
/**
XԍFX
*/
//const int XCOLUMNNCOUNT = 8 ;
///@}


// --------------------------------
///@name	Yԍ
// --------------------------------
///@{
/**
YԍFwb_
*/
const int YCOLUMNNNO_HEADER = 0 ;
/**
YԍFԂ0Ԗ
*/
const int YCOLUMNNNO_RESSYA_0 = 1 ;
/**
YԍFԐ̗̌
*/
//const int YCOLUMNNCOUNT_BLANK = 1 ;
///@}

/**
@return
	Ԏʃr[̃tHg̑Ԃ܂B
*/
static CdFontProp createFontProp()
{
	CdDedDispProp aCdDedDispProp = getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp();
	return aCdDedDispProp.getJikokuhyouFont(0);
	//return ( CConverter_WinGdi().CdFontPropOf( DEFAULT_GUI_FONT ) ) ;
}

	// --------------------------------
	//@name	֐
	// --------------------------------
CdOperationTableXColSpecCont
CWndDcdGridOperationTable::createXColSpecCont()
{
	bool a =getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei();
	CdOperationTableXColSpecCont aSpecCont(
		getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei());
	return aSpecCont ;
}

CdOperationTableYColSpecCont
CWndDcdGridOperationTable::createYColSpecCont()
{
	CdOperationTableYColSpecCont aSpecCont(
		m_ListOperationTableContent);
	return aSpecCont ;
}

CdOperationTableXColSpec
CWndDcdGridOperationTable::getXColSpecOfFocus()
{
	CdOperationTableXColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdOperationTableXColSpecCont aSpecCont(
			getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getDisplayRessyamei());
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getX() ) ;
	}
	return aSpec ;
}

CdOperationTableYColSpec
CWndDcdGridOperationTable::getYColSpecOfFocus()
{
	CdOperationTableYColSpec aSpec ;
	CdDcdPosXy aPos = getCFocus()->getFocusCellColumnNumber() ;
	if ( aPos != getCFocus()->ColumnNumberPosXy_NULL() )
	{
		CdOperationTableYColSpecCont aSpecCont(
			m_ListOperationTableContent);
		aSpec = aSpecCont.ColumnNumberToSpec( aPos.getY() ) ;
	}
	return aSpec ;
}
	
	// --------------------------------
	//@name OnUpdate ̉֐
	// --------------------------------

const CdDedJikoku::CConv&
CWndDcdGridOperationTable::getCdDedJikokuConv()const
{
	if (m_bDisplaySecondEkiJikoku)
	{
		if (m_bDisplayColonEkiJikoku)
		{
			static CdDedJikoku::CConv aConv(
				false,		//	RL
							//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
				CdDedJikoku::CConv::EHour_ZeroToSpace,
				CdDedJikoku::CConv::ESecond_Output 	// b\܂
			);
			return aConv;
		}
		else
		{
			static CdDedJikoku::CConv aConv(
				true,		//	R
							//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
				CdDedJikoku::CConv::EHour_ZeroToSpace,
				CdDedJikoku::CConv::ESecond_Output 	// b\܂
			);
			return aConv;
		}
	}
	else
	{
		if (m_bDisplayColonEkiJikoku)
		{
			static CdDedJikoku::CConv aConv(
				false,		//	RL
							//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
				CdDedJikoku::CConv::EHour_ZeroToSpace,
				CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B
			);
			return aConv;
		}
		else
		{
			static CdDedJikoku::CConv aConv(
				true,		//	R
							//  00  09 ̏ꍇA10̈ʂ "0" Xy[Xɂ܂B
				CdDedJikoku::CConv::EHour_ZeroToSpace,
				CdDedJikoku::CConv::ESecond_NoSecond 	// bɏo͂܂B
			);
			return aConv;
		}
	}
}

void CWndDcdGridOperationTable::OnUpdate_setCentDedRessya_To_Column(
	int iYColumnNumber ,
	const CentDedRessya& aCentDedRessya,
	const OperationTableContent& aOperationTableContent)
{
	bool bIsNull = aCentDedRessya.isNull() ;

	CdFontProp fontpropDefault = createFontProp() ;
	CdOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();

	// --------------------------------
	//	sYTCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget( NULL ) ;

		CdDcdSizeXy	sizeRessyamei ;
		CDcdTextbox	aCDcdTextbox(_T("sss") ,
			fontpropDefault , 
			_T("") , 1 , 2 , 2 ) ;
		aCDcdTextbox.getItemSize( &aCDcdTarget , &sizeRessyamei) ;

		getCXDcdGrid()->getYColumn( iYColumnNumber )->setColumnSize(sizeRessyamei.getY() ) ;
	}


	// --------------------------------
	//	ݒ
	// --------------------------------
	const Mu<CentDedEkiCont::CdDedEki>* pCdDedEkiCont =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getCentDedEkiCont()->getMuPtr(aCentDedRessya.getRessyahoukou());

	const CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen()->getCentDedRessyasyubetsuCont();
	const CentDedRessyasyubetsu* pCentDedRessyasyubetsu = pCentDedRessyasyubetsuCont
		->getMuPtr()->get(aCentDedRessya.getRessyasyubetsuIndex());
	if (m_bDisplayParentSyubetsu && pCentDedRessyasyubetsu->getParentSyubetsuIndex() >= 0)
	{
		pCentDedRessyasyubetsu = pCentDedRessyasyubetsuCont
			->getMuPtr()->get(pCentDedRessyasyubetsu->getParentSyubetsuIndex());
	}

	{
		//	Ԕԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyabangou));
		Ou<CDcdTextbox> pCDcdTextbox = 
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber )->getIfDcDraw() ;
		pCDcdTextbox->
			setText(aCentDedRessya.getRessyabangou() )  ;

		//	tHg
		CdDrawTextProp	aCdDrawTextProp = 
				pCDcdTextbox->getCdDrawTextProp() ;
		aCdDrawTextProp.setCdFontProp( fontpropDefault ) ;
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp )  ;	
		
		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber ) ;
	}
	{
		//	
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyasyubetsu));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();
		
		//ʂ̃eLXg
		//pCDcdTextbox->setText(
		//	pCentDedRessyasyubetsuCont->get(aCentDedRessya.getRessyasyubetsuIndex()).getRyakusyou());
		pCDcdTextbox->setText(pCentDedRessyasyubetsu->getSyubetsumei());
		
		//ʂ̃tHg
		CdDrawTextProp	aCdDrawTextProp = 
				pCDcdTextbox->getCdDrawTextProp() ;
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		{
			aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsu->getJikokuhyouMojiColor() ) ;

			int idxFont = pCentDedRessyasyubetsu->getJikokuhyouFontIndex();
			aCdDrawTextProp.setCdFontProp( 
				getCDiagramEditDoc()->getCDedRosenFileData()
					->getCdDedDispProp().getJikokuhyouFont( idxFont ) ) ;
		}
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp( aCdDrawTextProp )  ;	

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber ) ;
	}
	if(getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei())
	{
		//	Ԗ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyamei));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

		//Ԗ̃eLXg
		tstring strRessyamei = aCentDedRessya.getRessyamei();
		if (!aCentDedRessya.getGousuu().empty())
		{
			strRessyamei += _T(" ");
			strRessyamei += aCentDedRessya.getGousuu();
			strRessyamei += _T("");
		}
		pCDcdTextbox->setText(strRessyamei);

		//Ԗ̃tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		{
			aCdDrawTextProp.setTextColor(pCentDedRessyasyubetsu->getJikokuhyouMojiColor());

			int idxFont = pCentDedRessyasyubetsu->getJikokuhyouFontIndex();
			aCdDrawTextProp.setCdFontProp(
				getCDiagramEditDoc()->getCDedRosenFileData()
				->getCdDedDispProp().getJikokuhyouFont(idxFont));
		}
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber);
	}
	/**
		nIw̉wƎ擾ɂ
		EHOn̏ꍇ́Aقڏ]ʂB
			Before,AfterOperationHOn/IwIndex擾AwOrderƍ킹āAw擾
		EoEOԐڑ̏ꍇ
			iEkiOrderƂɁẢw̔/擾邪AisRunBetweenNextEki悤ɂ
	*/
	{
		//	N_nIw&N_w
		int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_OriginSideEkimei));
		int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku));
		Ou<CDcdTextbox> pCDcdTextbox1 =
			getCXDcdGrid()->getCell(iXColumnNumber1, iYColumnNumber)->getIfDcDraw();
		Ou<CDcdTextbox> pCDcdTextbox2 =
			getCXDcdGrid()->getCell(iXColumnNumber2, iYColumnNumber)->getIfDcDraw();

		tstring strEkimei;
		CdDedJikoku aCdDedJikoku;
		if (aCentDedRessya.getRessyahoukou() == Ressyahoukou_Kudari ||
			getDisplayNoboriLeftToRight())
		{
			if (aOperationTableContent.iOuterShihatsuekiIndex != INT_MIN)
			{
				int iOuterTerminalIndex = aOperationTableContent.iOuterShihatsuekiIndex;
				strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSihatsuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
				aCdDedJikoku = aOperationTableContent.OuterShihatsuJikoku;
			}
			//if (aOperationTableContent.BeforeOperation->getBOperation()
			//	== CentDedBeforeOperation::BOperation_Outer)
			//{
			//	int iOuterTerminalIndex = aOperationTableContent.BeforeOperation->getOuterShihatsuekiIndex();
			//	strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSihatsuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			//	aCdDedJikoku = aOperationTableContent.BeforeOperation->getOuterShihatsuJikoku();
			//}
			else
			{
				int iSihatsuEkiOrder = aOperationTableContent.iSihatsuEkiOrder;
				if (!aCentDedRessya.isRunBetweenNextEki(iSihatsuEkiOrder))
				{
					iSihatsuEkiOrder = aCentDedRessya.getRunBetweenEkiForward(iSihatsuEkiOrder);
				}

				strEkimei = pCdDedEkiCont->get(iSihatsuEkiOrder).getEkimei();
				aCdDedJikoku = aCentDedRessya.getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
			}
		}
		else
		{
			if (aOperationTableContent.iOuterShuchakuekiIndex != INT_MIN)
			{
				int iOuterTerminalIndex = aOperationTableContent.iOuterShuchakuekiIndex;
				strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSyuuchakuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
				aCdDedJikoku = aOperationTableContent.OuterShuchakuJikoku;
			}
			//if (aOperationTableContent.AfterOperation->getAOperation()
			//	== CentDedAfterOperation::AOperation_Outer)
			//{
			//	int iOuterTerminalIndex = aOperationTableContent.AfterOperation->getOuterShuchakuekiIndex();
			//	strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSyuuchakuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			//	aCdDedJikoku = aOperationTableContent.AfterOperation->getOuterShuchakuJikoku();
			//}
			else
			{
				int iSyuuchakuEkiOrder = aOperationTableContent.iSyuuchakuEkiOrder;
				if (!aCentDedRessya.isRunBetweenNextEki(iSyuuchakuEkiOrder-1))
				{
					iSyuuchakuEkiOrder = aCentDedRessya.getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
				}

				strEkimei = pCdDedEkiCont->get(iSyuuchakuEkiOrder).getEkimei();
				aCdDedJikoku = aCentDedRessya.getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
			}
		}
		pCDcdTextbox1->setText(strEkimei);
		pCDcdTextbox2->
			setText(getCdDedJikokuConv().encode(aCdDedJikoku));

		//	tHg
		CdDrawTextProp	aCdDrawTextProp1 =
			pCDcdTextbox1->getCdDrawTextProp();
		aCdDrawTextProp1.setCdFontProp(fontpropDefault);
		aCdDrawTextProp1.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp1);

		CdDrawTextProp	aCdDrawTextProp2 =
			pCDcdTextbox2->getCdDrawTextProp();
		aCdDrawTextProp2.setCdFontProp(fontpropDefault);
		aCdDrawTextProp2.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp2);

		//	Z𖳌
		InvalidateCell(iXColumnNumber1, iYColumnNumber);
		InvalidateCell(iXColumnNumber2, iYColumnNumber);
	}
	{
		//	ԕ()
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyahoukou));
		Ou<CDcdTextbox> pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, iYColumnNumber)->getIfDcDraw();

		tstring strArrow = _T("");
		if (aCentDedRessya.getRessyahoukou() == Ressyahoukou_Nobori &&
			!getDisplayNoboriLeftToRight())
		{
			strArrow = _T("");
		}
		pCDcdTextbox->setText(strArrow);

		//	tHg
		CdDrawTextProp	aCdDrawTextProp =
			pCDcdTextbox->getCdDrawTextProp();
		aCdDrawTextProp.setCdFontProp(fontpropDefault);
		aCdDrawTextProp.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);

		//	Z𖳌
		InvalidateCell(iXColumnNumber, iYColumnNumber);
	}
	{
		//	I_nIw&I_w
		int iXColumnNumber1 = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_TerminalSideEkimei));
		int iXColumnNumber2 = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku));
		Ou<CDcdTextbox> pCDcdTextbox1 =
			getCXDcdGrid()->getCell(iXColumnNumber1, iYColumnNumber)->getIfDcDraw();
		Ou<CDcdTextbox> pCDcdTextbox2 =
			getCXDcdGrid()->getCell(iXColumnNumber2, iYColumnNumber)->getIfDcDraw();

		tstring strEkimei;
		CdDedJikoku aCdDedJikoku;
		if (aCentDedRessya.getRessyahoukou() == Ressyahoukou_Kudari ||
			getDisplayNoboriLeftToRight())
		{
			if (aOperationTableContent.iOuterShuchakuekiIndex != INT_MIN)
			{
				int iOuterTerminalIndex = aOperationTableContent.iOuterShuchakuekiIndex;
				strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSyuuchakuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
				aCdDedJikoku = aOperationTableContent.OuterShuchakuJikoku;
			}
			//if (aOperationTableContent.AfterOperation->getAOperation()
			//	== CentDedAfterOperation::AOperation_Outer)
			//{
			//	int iOuterTerminalIndex = aOperationTableContent.AfterOperation->getOuterShuchakuekiIndex();
			//	strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSyuuchakuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			//	aCdDedJikoku = aOperationTableContent.AfterOperation->getOuterShuchakuJikoku();
			//}
			else
			{
				int iSyuuchakuEkiOrder = aOperationTableContent.iSyuuchakuEkiOrder;
				if (!aCentDedRessya.isRunBetweenNextEki(iSyuuchakuEkiOrder - 1))
				{
					iSyuuchakuEkiOrder = aCentDedRessya.getRunBetweenEkiBackward(iSyuuchakuEkiOrder);
				}

				strEkimei = pCdDedEkiCont->get(iSyuuchakuEkiOrder).getEkimei();
				aCdDedJikoku = aCentDedRessya.getCentDedEkiJikoku(iSyuuchakuEkiOrder).getChakujikoku();
			}
		}
		else
		{
			if (aOperationTableContent.iOuterShihatsuekiIndex != INT_MIN)
			{
				int iOuterTerminalIndex = aOperationTableContent.iOuterShihatsuekiIndex;
				strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSihatsuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
				aCdDedJikoku = aOperationTableContent.OuterShihatsuJikoku;
			}
			//if (aOperationTableContent.BeforeOperation->getBOperation()
			//	== CentDedBeforeOperation::BOperation_Outer)
			//{
			//	int iOuterTerminalIndex = aOperationTableContent.BeforeOperation->getOuterShihatsuekiIndex();
			//	strEkimei = pCdDedEkiCont->get(aOperationTableContent.iSihatsuEkiOrder).getOuterTerminalEkimei(iOuterTerminalIndex);
			//	aCdDedJikoku = aOperationTableContent.BeforeOperation->getOuterShihatsuJikoku();
			//}
			else
			{
				int iSihatsuEkiOrder = aOperationTableContent.iSihatsuEkiOrder;
				if (!aCentDedRessya.isRunBetweenNextEki(iSihatsuEkiOrder))
				{
					iSihatsuEkiOrder = aCentDedRessya.getRunBetweenEkiForward(iSihatsuEkiOrder);
				}

				strEkimei = pCdDedEkiCont->get(iSihatsuEkiOrder).getEkimei();
				aCdDedJikoku = aCentDedRessya.getCentDedEkiJikoku(iSihatsuEkiOrder).getHatsujikoku();
			}
		}
		pCDcdTextbox1->setText(strEkimei);
		pCDcdTextbox2->
			setText(getCdDedJikokuConv().encode(aCdDedJikoku));

		//	tHg
		CdDrawTextProp	aCdDrawTextProp1 =
			pCDcdTextbox1->getCdDrawTextProp();
		aCdDrawTextProp1.setCdFontProp(fontpropDefault);
		aCdDrawTextProp1.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox1->setCdDrawTextProp(aCdDrawTextProp1);

		CdDrawTextProp	aCdDrawTextProp2 =
			pCDcdTextbox2->getCdDrawTextProp();
		aCdDrawTextProp2.setCdFontProp(fontpropDefault);
		aCdDrawTextProp2.setCdDrawTextFormat(CdDrawTextFormat(CdDrawTextFormat::H_CENTER));
		pCDcdTextbox2->setCdDrawTextProp(aCdDrawTextProp2);

		//	Z𖳌
		InvalidateCell(iXColumnNumber1, iYColumnNumber);
		InvalidateCell(iXColumnNumber2, iYColumnNumber);
	}
}


void  CWndDcdGridOperationTable::OnUpdate_All()
{
	CWaitCursor	aCWaitCursor ;	

	//CentDedDiaY^pԍ̗Ԃ𔲏oB
	//deque<RessyaProperty> sRessyaProperty;

	//int iRv = SearchOperationNumberRessya();
	//{

	//	int iYColumnBegin = createYColSpecCont().ColumnNumberFromSpec(
	//		CdOperationTableYColSpec(CdOperationTableYColSpec::ColumnType_Ressya, 0));

	//	getCSelect()->setColumnNumberSelectLimit(
	//		CdDcdZoneXy(
	//			CdDcdZone( 0 , INT_MAX ) ,
	//			//CdDcdZone(0, 1),
	//			//CdDcdZone(1, INT_MAX)
	//			CdDcdZone(iYColumnBegin, m_aRessyaProperty.size())
	//		));
	//}
	//if (iRv < 0)
	//{
	//	//COperationTableDoc*	pLDocument = GetDocument();
	//	GetDocument()->OnCloseDocument();
	//	return;
	//	//CDocument*	pLDocument = GetDocument();
	//	//pLDocument = NULL;
	//}

	const Mu<const CentDedRessya*>* pCentDedRessyaConts[2];
	for (int iRessyahoukou = Ressyahoukou_Kudari;
		iRessyahoukou <= Ressyahoukou_Nobori; iRessyahoukou++)
	{
		pCentDedRessyaConts[iRessyahoukou] = getCentDedRessyaCont((ERessyahoukou)iRessyahoukou)->getMuPtr();
	}

	{
		//	R}hIuWFNgsɂZړŃZIɂȂȂ悤ɁA
		//	ZIAZI@\ꎞIɒ~܂B
		clearSelect() ;
		CPropStack aPropStack( this ) ;
		aPropStack
			.CBoxSelect_setIsEnable( false )
			.CRandomSelect_setIsEnable( false )  ;

		// --------------------------------		
		//	SvfXV
		// --------------------------------
		//	X񐔂𑝌
		CdOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();
		int iXCount = getCXDcdGrid()->getXColumnCount();
		if (iXCount != aXColSpecCont.size())
		{
			OnCreate_Header();
		}

		
		//COperationTableDoc* pCOperationTableDoc = (COperationTableDoc*)GetDocument();

		//const list<OperationTableContent>& ListOperationTableContent = getCentDedDia()->getcontOperationTableContent().at(pCOperationTableDoc->getOperationNumber());
		//	Y񐔂𑝌
		if (m_ListOperationTableContent != NULL)
		{
			getCXDcdGrid()->setYColumnCount(
				m_ListOperationTableContent->size() + YCOLUMNNNO_RESSYA_0);

			//	eZɁAf[^ݒ
			int idxRessya = 0;
			for (auto itr = m_ListOperationTableContent->begin();
				itr != m_ListOperationTableContent->end(); itr++, idxRessya++)
			{
				const CentDedRessya* pCentDedRessya =
					pCentDedRessyaConts[itr->aRessyaProperty.getRessyahoukou()]
					->get(itr->aRessyaProperty.getRessyaIndex());

				OnUpdate_setCentDedRessya_To_Column(
					idxRessya + YCOLUMNNNO_RESSYA_0, *pCentDedRessya,
					*itr);

			}
		}
		//int idxRessya;
		//for (idxRessya = 0 ;
		//	idxRessya < (int)m_aRessyaProperty.size();
		//	idxRessya++ )
		//{
		//	const CentDedRessya* pCentDedRessya = 
		//		pCentDedRessyaConts[m_aRessyaProperty[idxRessya].getRessyahoukou()]
		//		->get(m_aRessyaProperty[idxRessya].getRessyaIndex());

		//	OnUpdate_setCentDedRessya_To_Column(
		//		idxRessya + YCOLUMNNNO_RESSYA_0, *pCentDedRessya) ;
		//} 
	}
	m_bUpdate_All_Requested = false ;
	//
}

void CWndDcdGridOperationTable::OnCreate_Header()
{
	// --------------------------------
	//	^p\r[ɎgptHg
	// --------------------------------
	CdFontProp fontpropDefault = createFontProp();

	CdOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();
	// --------------------------------
	//	̐w
	// --------------------------------

	getCXDcdGrid()->setXColumnCount(aXColSpecCont.size());

	// --------------------------------
	//	̃TCYݒ
	// --------------------------------
	{
		CDcdTargetGetDC	aCDcdTarget(NULL);
		// --------------------------------
		//	X
		// --------------------------------
		tstring strCellRessyaBangouWidth(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getJikokuhyouRessyaWidth(), '0');
		if (strCellRessyaBangouWidth.length() < 8)
		{
			strCellRessyaBangouWidth = tstring(8, '0');
		}
		tstring strCellEkijikokuWidth(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getJikokuhyouRessyaWidth(), '0');
		if (strCellEkijikokuWidth.length() < 6)
		{
			strCellEkijikokuWidth = tstring(6, '0');
		}
		tstring strCellEkimeiLength(
			getCDiagramEditDoc()->getCDedRosenFileData()->getCdDedDispProp().getEkimeiLength() * 2, '0');
		const CentDedRessyasyubetsuCont* pRessyasyubetsuCont = getCDiagramEditDoc()->getCDedRosenFileData()
			->getCentDedRosen()->getCentDedRessyasyubetsuCont();
		tstring strCellRessyasyubetsuWidth = _T("sss");
		for (int idxSyubetsu = 0; idxSyubetsu < pRessyasyubetsuCont->size(); idxSyubetsu++)
		{
			if (strCellRessyasyubetsuWidth.length() < pRessyasyubetsuCont->get(idxSyubetsu).getSyubetsumei().length())
			{
				strCellRessyasyubetsuWidth = pRessyasyubetsuCont->get(idxSyubetsu).getSyubetsumei();
			}
		}
		{
			//	Ԕԍ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_Ressyabangou));
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				strCellRessyaBangouWidth,
				//"0" ,
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_Ressyasyubetsu));
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				strCellRessyasyubetsuWidth,
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);
			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		if (getCDiagramEditDoc()->getCDedRosenFileData()
			->getCdDedDispProp().getDisplayRessyamei())
		{
			//	Ԗ
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_Ressyamei));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				_T("ssssss"),
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	N_nIw
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_OriginSideEkimei));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkimeiLength,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	N_w
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkijikokuWidth,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	ԕ()
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_Ressyahoukou));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				_T("s"),
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	I_nIw
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_TerminalSideEkimei));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkimeiLength,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		{
			//	I_w
			int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
				CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku));
			CdDcdSizeXy	sizeOperationTable;

			CDcdTextbox	aCDcdTextbox(
				strCellEkijikokuWidth,
				//"sss",
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getXColumn(iXColumnNumber)->setColumnSize(sizeOperationTable.getX());
		}
		// --------------------------------
		//	Y
		// --------------------------------
		{
			CdDcdSizeXy	sizeOperationTable;
			CDcdTextbox	aCDcdTextbox(
				_T("ssssss"),
				fontpropDefault,
				_T(""), 1, 2, 2);
			aCDcdTextbox.getItemSize(&aCDcdTarget, &sizeOperationTable);

			getCXDcdGrid()->getYColumn(YCOLUMNNNO_HEADER)->setColumnSize(sizeOperationTable.getY());
			/*
																									getCXDcdGrid()->getYColumn(YCOLUMNNNO_RESSYA_0)->setColumnSize(sizeOperationTable.getY() ) ;*/
		}
	}
	// --------------------------------
	//	ŏɑƃeLXgݒ
	// --------------------------------
	{
		// Ԕԍ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyabangou));
		CString	aString;
		aString = _T("Ԕԍ");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// ʖ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyasyubetsu));
		CString	aString;
		aString = _T("");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	if (getCDiagramEditDoc()->getCDedRosenFileData()
		->getCdDedDispProp().getDisplayRessyamei())
	{
		// Ԗ
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyamei));
		CString	aString;
		aString = _T("Ԗ");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// w
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_OriginSideEkimei));
		CString	aString;
		aString = _T("w");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// w
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku));
		CString	aString;
		aString = _T("w");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// ԕ()
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_Ressyahoukou));
		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
	}
	{
		// w
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_TerminalSideEkimei));
		CString	aString;
		aString = _T("w");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
	{
		// w
		int iXColumnNumber = aXColSpecCont.ColumnNumberFromSpec(CdOperationTableXColSpec(
			CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku));
		CString	aString;
		aString = _T("w");

		Ou<CDcdTextbox>	pCDcdTextbox =
			getCXDcdGrid()->getCell(iXColumnNumber, YCOLUMNNNO_HEADER)->getIfDcDraw();

		CConverter_WinGdi aCConverter_WinGdi;

		CdDrawTextProp	aCdDrawTextProp(
			fontpropDefault,
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENUTEXT));
		CdBrushProp	aCdBrushProp(
			aCConverter_WinGdi.CdColorPropOfSysColor(COLOR_MENU));

		pCDcdTextbox->setCdDrawTextProp(aCdDrawTextProp);
		pCDcdTextbox->setCdBrushProp(aCdBrushProp);
		pCDcdTextbox->setText((LPCTSTR)aString);
	}
}

	// --------------------------------
	//@name j[R}h̉֐
	// --------------------------------

	//	[ҏW]-[Rs[]	
int CWndDcdGridOperationTable::OnEditCopy_Process( BOOL bQueryEnable )
{
	int iRv = 0 ;
	//iRv = -1;
	//Ou<CRfEditCmd_EkiTrack2> pCmd ;
	//Ou<CRfEditCmd_EkiTrack2>* ppCmd = NULL ;
	//if ( !bQueryEnable ){	ppCmd = &pCmd ;}

	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************

	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	if (iRv >= 0)
	{
		if (m_ListOperationTableContent->size() == 0)
		{
			iRv = -2;	//Ԃ\Ă܂
		}
	}
	// ****************************************************************
	if ( !bQueryEnable && iRv >= 0 )
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		// -------------------------------- 
		//	Nbv{[hɓ]
		// --------------------------------	
		const CentDedRosen*	pCentDedRosen =
			getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
		int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
			GetDocument()->getDiaName());

		getCDiagramEditDoc()->CentDedOperationTable_To_Cliboard(
			iDiaIndex,
			m_ListOperationTableContent,
			m_bDisplaySecondEkiJikoku,
			m_bDisplayColonEkiJikoku) ;

	//	// -------------------------------- 
	//	//	tH[JXZAIvfōő̔ԐIndex̎ʂɈړ
	//	// --------------------------------
	//	{
	//		//	ZINAA
	//		//	tH[JXZ̈ړɂZI𖳌܂B
	//		clearSelect() ;
	//		CPropStack	aPropStack( this ) ;
	//		aPropStack
	//			.CBoxSelect_setIsEnable( false )
	//			.CRandomSelect_setIsEnable( false )  ;
	//	
	//		//	Ivfōő̔ԐIndex ߂
	//		int iEkiTrack2IndexMax = -1 ;
	//		{
	//			CaMuiSelect<CentDedEkiTrack2>* pCaMuiSelect = pCmd->getCaMuiSelect() ;
	//			for ( int iIndex = pCaMuiSelect->getAdapteeMu()->size() - 1  ; 
	//				iEkiTrack2IndexMax == -1 && iIndex >= 0 ; iIndex -- )
	//			{
	//				if ( pCaMuiSelect->getSelect( iIndex ) )
	//				{
	//					iEkiTrack2IndexMax = iIndex + pCmd->getIndexDst() ;
	//				}
	//			}
	//		}
	//		//iEkiTrack2IndexMax = IĂԐ̂AőIndex

	//		//	ړ̃tH[JXZʒu
	//		int iYColumnNmber = -1 ;
	//		{
	//			CdEkiTrack2YColSpecCont aCdYColSpecCont = createYColSpecCont() ;
	//			iYColumnNmber = aCdYColSpecCont.ColumnNumberFromSpec( 
	//				CdEkiTrack2YColSpec( CdEkiTrack2YColSpec::ColumnType_EkiTrack2, iEkiTrack2IndexMax ) ) + 1 ;
	//		}
	//		//	tH[JXړ
	//		{
	//			CdDcdPosXy posxyFocusCellColumnNumber 
	//				= getCFocus()->getFocusCellColumnNumber() ;
	//			if ( iYColumnNmber >= 0 
	//				&& posxyFocusCellColumnNumber != getCFocus()->ColumnNumberPosXy_NULL() )
	//			{
	//				posxyFocusCellColumnNumber.setY( iYColumnNmber ) ;
	//				getCFocus()->setFocusCellColumnNumber( posxyFocusCellColumnNumber ) ;
	//			}
	//		}
	//	}
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv ;


}

int CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyou_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	if (iRv >= 0)
	{
		if (m_ListOperationTableContent->size() == 0)
		{
			iRv = -2;	//Ԃ\Ă܂
		}
	}
	CdOperationTableYColSpec aCdOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdOperationTableYColSpec.getColumnType() !=
				CdOperationTableYColSpec::ColumnType_Ressya)
			{
				iRv = -3;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -4; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		auto itr = m_ListOperationTableContent->begin();
		for (int idx = 0; idx < aCdOperationTableYColSpec.getOperationTableContentIndex(); idx++)
		{
			itr++;
		}
		ERessyahoukou eRessyahoukou = itr->aRessyaProperty.getRessyahoukou();
		int iRessyaidx = itr->aRessyaProperty.getRessyaIndex();
		// --------------------------------
		//	\r[J
		// --------------------------------
		CJikokuhyouView* pCJikokuhyouView = NULL;
		if (iRv >= 0)
		{
			CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
			if (iRv >= 0)
			{
				pCJikokuhyouDoc =
					getCDiagramEditApp()->openCJikokuhyouDoc(
						getCentDedDia(),
						eRessyahoukou,
						false,
						&pCJikokuhyouView);
				if (pCJikokuhyouView == NULL)
				{
					iRv = -5;	//	\r[̃I[vɎs܂
				}
			}
			//pCJikokuhyouDoc = \hLg
			//pCJikokuhyouView = \r[
		}

		if (iRv >= 0)
		{
			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
			pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getSihatsuEki());
			iRv = 1;	//	\r[ֈړ܂
		}

	}
	return iRv;
}

int CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyouOpenDlg_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	if (iRv >= 0)
	{
		if (m_ListOperationTableContent->size() == 0)
		{
			iRv = -2;	//Ԃ\Ă܂
		}
	}

	CdOperationTableYColSpec aCdOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdOperationTableYColSpec.getColumnType() !=
				CdOperationTableYColSpec::ColumnType_Ressya)
			{
				iRv = -3;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -4; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		auto itr = m_ListOperationTableContent->begin();
		for (int idx = 0; idx < aCdOperationTableYColSpec.getOperationTableContentIndex(); idx++)
		{
			itr++;
		}
		ERessyahoukou eRessyahoukou = itr->aRessyaProperty.getRessyahoukou();
		int iRessyaidx = itr->aRessyaProperty.getRessyaIndex();
		// --------------------------------
		//	\r[J
		// --------------------------------
		CJikokuhyouView* pCJikokuhyouView = NULL;
		if (iRv >= 0)
		{
			CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
			if (iRv >= 0)
			{
				pCJikokuhyouDoc =
					getCDiagramEditApp()->openCJikokuhyouDoc(
						getCentDedDia(),
						eRessyahoukou,
						false,
						&pCJikokuhyouView);
				if (pCJikokuhyouView == NULL)
				{
					iRv = -5;	//	\r[̃I[vɎs܂
				}
			}
			//pCJikokuhyouDoc = \hLg
			//pCJikokuhyouView = \r[
		}

		if (iRv >= 0)
		{

			CdOperationTableXColSpec aCdOperationTableXColSpec = getXColSpecOfFocus();
			if (aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_Ressyabangou)
			{
				pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 1);
			}
			else if (aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_Ressyasyubetsu)
			{
				pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 2);
			}
			else if (aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_Ressyamei)
			{
				pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 3);
			}
			else if (aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_OriginSideEkimei ||
				aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku)
			{
				CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
				if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
					getDisplayNoboriLeftToRight())
				{
					pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true);
				}
				else
				{
					pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false);
				}
			}
			else if (aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_TerminalSideEkimei ||
				aCdOperationTableXColSpec.getColumnType() ==
				CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku)
			{
				CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
				if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
					getDisplayNoboriLeftToRight())
				{
					pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false);
				}
				else
				{
					pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true);
				}
			}
			else
			{
				CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
				pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getValidSihatsuEki());
			}
			iRv = 1;	//	\r[ֈړ܂
		}

	}
	return iRv;
}

int CWndDcdGridOperationTable::OnOperationtableMovetodiagram_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -5;	//^pXV}~Ԃł
		}
	}
	CdOperationTableYColSpec aCdOperationTableYColSpec = getYColSpecOfFocus();
	if (iRv >= 0)
	{
		if (getCSelect()->getSelectedCellCount() == 0)
		{
			if (aCdOperationTableYColSpec.getColumnType() !=
				CdOperationTableYColSpec::ColumnType_Ressya)
			{
				iRv = -2;	//tH[JXԈʒuȊOȂs
			}
		}
		else
		{
			iRv = -1; //I͕s
		}

	}
	if (!bQueryEnable && iRv >= 0)
	{
		auto itr = m_ListOperationTableContent->begin();
		for (int idx = 0; idx < aCdOperationTableYColSpec.getOperationTableContentIndex(); idx++)
		{
			itr++;
		}
		ERessyahoukou eRessyahoukou = itr->aRessyaProperty.getRessyahoukou();
		int iRessyaidx = itr->aRessyaProperty.getRessyaIndex();
		// --------------------------------
		//	_COr[J
		// --------------------------------
		CDedDiagramView* pCDedDiagramView = NULL;
		if (iRv >= 0) {

			const CDedDiagramDoc* pCDedDiagramDoc = NULL;
			if (iRv >= 0) {
				pCDedDiagramDoc =
					getCDiagramEditApp()->openCDedDiagramDoc(
						getCentDedDia());
				if (pCDedDiagramDoc == NULL) {
					iRv = -3;	//	_COr[̃I[vɎs܂
				}
			}
			//pCJikokuhyouDoc = _COhLg
			//	r[ANeBuɂȂĂ܂B

			if (iRv >= 0) {
				POSITION aPOSITION = pCDedDiagramDoc->GetFirstViewPosition();
				if (aPOSITION != NULL) {
					pCDedDiagramView = (CDedDiagramView*)pCDedDiagramDoc->GetNextView(aPOSITION);
				}
				if (pCDedDiagramView == NULL) {
					iRv = -4;	//	_COr[̃I[vɎs܂
				}
			}
		}
		//pCDedDiagramView = _COr[
		if (iRv >= 0) {
			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
			pCDedDiagramView->setZone_Dgr(aCentDedRessya.getCentDedEkiJikoku(aCentDedRessya.getSihatsuEki()).getHatsujikoku(true),
				aCentDedRessya.EkiIndexOfEkiOrder(aCentDedRessya.getSihatsuEki()),
				aCentDedRessya.getRessyahoukou() == Ressyahoukou_Nobori);
		}
	}
	return iRv;
}

int CWndDcdGridOperationTable::OnFileExportOperationTableCsv_Process(BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (iRv >= 0)
	{
		if (getCentDedDia()->getWaitOperationUpdate())
		{
			iRv = -1;	//^pXV}~Ԃł
		}
	}
	if (iRv >= 0)
	{
		if (m_ListOperationTableContent->size() == 0)
		{
			iRv = -2;	//Ԃ\Ă܂
		}
	}

	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}h̎s
		// ****************************************************************
		COperationTableDoc* pCOperationTableDoc = (COperationTableDoc*)GetDocument();

		const CDedRosenFileData* pCDedRosenFileData =
			getCDiagramEditDoc()->getCDedRosenFileData();
		const CentDedRessya* pCentDedRessya = getCentDedRessyaCont(m_ListOperationTableContent->begin()->aRessyaProperty.getRessyahoukou())
			->getMuPtr()->get(m_ListOperationTableContent->begin()->aRessyaProperty.getRessyaIndex());
		
		CDlgOperationTableCsvExport	aDlg(
			pCDedRosenFileData->getCentDedRosen(),
			getCentDedDia(),
			pCOperationTableDoc->getOperationNumber(),
			getCentDedRessyaCont(m_ListOperationTableContent->begin()->aRessyaProperty.getRessyahoukou())
				->EkiIndexOfEkiOrder(m_ListOperationTableContent->begin()->iSihatsuEkiOrder),
			//pCentDedRessya->EkiIndexOfEkiOrder(m_ListOperationTableContent.begin()->iSihatsuEkiOrder),
			getDisplaySecondEkiJikoku(),
			getDisplayColonEkiJikoku(),
			getDisplayParentSyubetsu(),
			getDisplayNoboriLeftToRight(),
			this);
		aDlg.DoModal();

		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

// ****************************************************************
//	CWndDcdGridEkiTrack2
// ****************************************************************


// ********************************
//	RXgN^
// ********************************
CWndDcdGridOperationTable::CWndDcdGridOperationTable()
	: m_bUpdate_All_Requested( false )
	, m_bInitialUpdateComplete(false)
	, m_bDisplaySecondEkiJikoku(false)
	, m_bDisplayColonEkiJikoku(false)
	, m_bDisplayParentSyubetsu(false)
	, m_bDisplayNoboriLeftToRight(false)
{
	//getCSelect()->setSelectMode( CSelect::SelectMode_YColumn ) ;
	getCSelect()->setSelectMode(CSelect::SelectMode_NONE);
}
CWndDcdGridOperationTable::~CWndDcdGridOperationTable()
{
}

// ********************************
//@name	CDcdGrid
// ********************************

// ********************************
//@name	CWndDcdGrid
// ********************************

	// ********************************
	//@name CWndDcdGridRessyasyubetsu-
	// ********************************

COperationTableDoc * CWndDcdGridOperationTable::GetDocument()
{
	CView* pCView = (CView*)GetParent();
	return (COperationTableDoc*)pCView->GetDocument();
}

const CentDedDia*	CWndDcdGridOperationTable::getCentDedDia()
{
	const CentDedRosen*	pCentDedRosen =
		getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
	int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
		GetDocument()->getDiaName());
	if (iDiaIndex < 0) {
		return (NULL);
	}
	const CentDedDia* pCentDedDia = pCentDedRosen->getCentDedDiaCont()->getMuPtr()->get(iDiaIndex);
	return (pCentDedDia);
};

const CentDedRessyaCont*	CWndDcdGridOperationTable::getCentDedRessyaCont(
	ERessyahoukou eRessyahoukou)
{
	const CentDedDia* pCentDedDia = getCentDedDia();
	if (pCentDedDia == NULL) {
		return (NULL);
	}
	return (pCentDedDia->getCentDedRessyaCont(eRessyahoukou));
};


int CWndDcdGridOperationTable::OnViewDisplaySecondEkijikoku_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplaySecondEkiJikoku())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplaySecondEkiJikoku(!getDisplaySecondEkiJikoku());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridOperationTable::OnViewDisplayColonEkijikoku_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayColonEkiJikoku())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayColonEkiJikoku(!getDisplayColonEkiJikoku());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridOperationTable::OnViewDisplayParentSyubetsu_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayParentSyubetsu())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayParentSyubetsu(!getDisplayParentSyubetsu());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}

int CWndDcdGridOperationTable::OnViewDisplayNoboriLeftToRight_Process(
	BOOL bQueryEnable)
{
	int iRv = 0;
	// ****************************************************************
	//	R}h̗LE
	// ****************************************************************
	if (getDisplayNoboriLeftToRight())
	{
		iRv = 1;	//(bQueryEnable==TRUȄꍇ)[bPʂ̎\]LłB
	}
	// ****************************************************************
	if (!bQueryEnable && iRv >= 0)
	{
		// ****************************************************************
		//	R}hs
		// ****************************************************************
		setDisplayNoboriLeftToRight(!getDisplayNoboriLeftToRight());
		// ****************************************************************
		//	G[bZ[W
		// ****************************************************************

		// ****************************************************************
	}
	return iRv;
}


bool CWndDcdGridOperationTable::getDisplaySecondEkiJikoku()const
{
	return m_bDisplaySecondEkiJikoku;
}
int CWndDcdGridOperationTable::setDisplaySecondEkiJikoku(bool value)
{
	int iRv = 0;
	if (m_bDisplaySecondEkiJikoku != value)
	{
		m_bDisplaySecondEkiJikoku = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridOperationTable::getDisplayColonEkiJikoku()const
{
	return m_bDisplayColonEkiJikoku;
}
int CWndDcdGridOperationTable::setDisplayColonEkiJikoku(bool value)
{
	int iRv = 0;
	if (m_bDisplayColonEkiJikoku != value)
	{
		m_bDisplayColonEkiJikoku = value;

		//	bPʂ̕\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂

		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridOperationTable::getDisplayParentSyubetsu()const
{
	return m_bDisplayParentSyubetsu;
}
int CWndDcdGridOperationTable::setDisplayParentSyubetsu(bool value)
{
	int iRv = 0;
	if (m_bDisplayParentSyubetsu != value)
	{
		m_bDisplayParentSyubetsu = value;

		//	eʋ@\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂
		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridOperationTableViewProp(this);
	}
	return (iRv);
}

bool CWndDcdGridOperationTable::getDisplayNoboriLeftToRight()const
{
	return m_bDisplayNoboriLeftToRight;
}
int CWndDcdGridOperationTable::setDisplayNoboriLeftToRight(bool value)
{
	int iRv = 0;
	if (m_bDisplayNoboriLeftToRight != value)
	{
		m_bDisplayNoboriLeftToRight = value;

		//	eʋ@\̗Lωꍇ́A
		//	r[XV܂B
		//	A^pXV}~Ԃ̏ꍇ́Ar[̍XV͍s܂
		if (!getCentDedDia()->getWaitOperationUpdate())
		{
			OnUpdate_All();
			InvalidateGrid();
		}

		//	bPʂ̕\̗LA
		//	.ini t@Cɕۑ
		getCDiagramEditApp()->writeCWndDcdGridOperationTableViewProp(this);
	}
	return (iRv);
}


// ----------------------------------------------------------------
//	MFC
// ----------------------------------------------------------------
BEGIN_MESSAGE_MAP(CWndDcdGridOperationTable,CWndDcdGridOperationTable::super)
	//{{AFX_MSG_MAP(CWndDcdGridOperationTable)
	ON_WM_CREATE()
	ON_WM_KEYUP()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_OperationTable_MoveToJikokuhyou, &CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyou)
	ON_UPDATE_COMMAND_UI(ID_OperationTable_MoveToJikokuhyou, &CWndDcdGridOperationTable::OnUpdateOperationtableMovetojikokuhyou)
	ON_COMMAND(ID_OperationTable_MoveToJikokuhyouOpenDlg, &CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyouOpenDlg)
	ON_UPDATE_COMMAND_UI(ID_OperationTable_MoveToJikokuhyouOpenDlg, &CWndDcdGridOperationTable::OnUpdateOperationtableMovetojikokuhyouOpenDlg)
	ON_COMMAND(ID_OperationTable_MoveToDiagram, &CWndDcdGridOperationTable::OnOperationtableMovetodiagram)
	ON_UPDATE_COMMAND_UI(ID_OperationTable_MoveToDiagram, &CWndDcdGridOperationTable::OnUpdateOperationtableMovetodiagram)
	ON_COMMAND(ID_VIEW_DisplaySecondEkiJikoku, &CWndDcdGridOperationTable::OnViewDisplaySecondEkijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplaySecondEkiJikoku, &CWndDcdGridOperationTable::OnUpdateViewDisplaySecondEkijikoku)
	ON_COMMAND(ID_VIEW_DisplayColonEkiJikoku, &CWndDcdGridOperationTable::OnViewDisplayColonEkijikoku)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayColonEkiJikoku, &CWndDcdGridOperationTable::OnUpdateViewDisplayColonEkijikoku)
	ON_COMMAND(ID_VIEW_DisplayParentSyubetsu, &CWndDcdGridOperationTable::OnViewDisplayParentSyubetsu)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayParentSyubetsu, &CWndDcdGridOperationTable::OnUpdateViewDisplayParentSyubetsu)
	ON_COMMAND(ID_VIEW_DisplayNoboriLeftToRight, &CWndDcdGridOperationTable::OnViewDisplayNoboriLeftToRight)
	ON_UPDATE_COMMAND_UI(ID_VIEW_DisplayNoboriLeftToRight, &CWndDcdGridOperationTable::OnUpdateViewDisplayNoboriLeftToRight)
	ON_COMMAND(ID_FILE_EXPORT_OPERATIONTABLECSV, &CWndDcdGridOperationTable::OnFileExportOperationtablecsv)
END_MESSAGE_MAP()

int CWndDcdGridOperationTable::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (super::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	//// --------------------------------
	////	Ԏʃr[ɎgptHg
	//// --------------------------------
	//CdFontProp fontpropDefault = createFontProp() ;

	//CdOperationTableXColSpecCont aXColSpecCont = createXColSpecCont();
	//// --------------------------------
	////	̐w
	//// --------------------------------

	//getCXDcdGrid()->setXColumnCount(aXColSpecCont.size()) ;
	getCXDcdGrid()->setYColumnCount(YCOLUMNNNO_RESSYA_0);
	getCXDcdGrid()->setYFixColumnCount(YCOLUMNNNO_RESSYA_0);
	OnCreate_Header();


	// --------------------------------
	//	tH[JXZ̏ʒuݒ
	// --------------------------------
	getCFocus()->setFocusCell( getCXDcdGrid()->getCell( 0 , YCOLUMNNNO_RESSYA_0) ) ;
	// --------------------------------
	//	\XV
	// --------------------------------
	InvalidateGrid() ;

	
	return 0;
}




void CWndDcdGridOperationTable::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
	if (lHint == LHINT_SUBVIEW_TO_ROOTDOC)
	{
		return;
	}
	// --------------------------------

	// --------------------------------
	//	OnUpdate()
	//	.init@CvpeBǂݍ
	// --------------------------------
	if (!m_bInitialUpdateComplete)
	{
		getCDiagramEditApp()->readCWndDcdGridOperationTableViewProp(this);
		// --------------------------------
		m_bInitialUpdateComplete = true;
	}

	//pHint= 
	//	pHint CRfEditCmdHolder IuWFNgȂA
	//	ΉҏWR}h CRfEditCmd ێĂ܂B
	//	̏ꍇAthis  CRfEditCmd ̓eɍœK
	//	XVs܂B
	//	NULLȂASXVvĂ܂B
	if (m_bUpdate_All_Requested)
	{
		//	SXVۗĂꍇ́A
		//	̌̓R}hɂœKꂽP̂̂ȂXVvɑ΂ĂASXVs܂B
		pHint = NULL;
	}


	Ou<CRfEditCmd> pCmd;
	if (pHint != NULL && pHint->IsKindOf(RUNTIME_CLASS(CRfEditCmdHolder)))
	{

		CRfEditCmdHolder* pHolder =
			(CRfEditCmdHolder*)pHint;
		pCmd = pHolder->getCmd();
	}

	//
	//	
	//	
	if ( pCmd != NULL )
	{
		if ( dynamic_castOu<CRfEditCmd_Comment>( pCmd ) || 
			dynamic_castOu<CRfEditCmd_Dia>(pCmd) ||
			dynamic_castOu<CRfEditCmd_DiaProp>(pCmd) ||
			dynamic_castOu<CRfEditCmd_RessyasyubetsuSwap>( pCmd ))
		{
			//	̃r[́A
			//		Rg̕ύX
			//		_C̕ύX
			//		_C̑̕ύX
			//		wԐ̕ύX
			//		wԐ̓
			//		Ԏʂ̓
			//	̏ꍇ́AXVs܂B
		}
		else if (dynamic_castOu<CRfEditCmd_Ressya>(pCmd))
		{
			const CentDedRosen*	pCentDedRosen =
				getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
			int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
				GetDocument()->getDiaName());
			Ou<CRfEditCmd_Ressya>	pCommand =
				dynamic_castOu<CRfEditCmd_Ressya>(pCmd);
			if (pCommand->getDiaIndex() == iDiaIndex && !pCommand->getWaitOperationConnect())
			{
				pHint = NULL;
			}
		}
		else if (dynamic_castOu<CRfEditCmd_Operation>(pCmd))
		{
			const CentDedRosen*	pCentDedRosen =
				getCDiagramEditDoc()->getCDedRosenFileData()->getCentDedRosen();
			int iDiaIndex = pCentDedRosen->getCentDedDiaCont()->findCentDedDiaByName(
				GetDocument()->getDiaName());
			Ou<CRfEditCmd_Operation>	pCommand =
				dynamic_castOu<CRfEditCmd_Operation>(pCmd);
			if (pCommand->getDiaIndex() == iDiaIndex)
			{
				pHint = NULL;
			}
		}
		else
		{
			//CRfEditCmd_DedRosenFileDataProp
			//	  Ht@C̃vpeB̕ύX́A
			//	tHg̕ω𔺂߁ASXVKvłB
			//CRfEditCmd_Eki
			//CRfEditCmd_RessyaSyubetsu
			//CRfEditCmd_Rosen
			//CRfEditCmd_RosenFileData
			//	Ԏʂ܂IuWFNgłBꂪXVꂽꍇ́A
			//	SXVKvłB
			pHint = NULL ;
		}
	}
	if ( pHint == NULL )
	{
		// --------------------------------		
		//	SvfXV
		// --------------------------------
		CView *pView = getCDiagramEditApp()->getCMainFrame()->
			getMDIChildActiveView() ;
		//SearchOperationNumberRessya();

		COperationTableDoc* pCOperationTableDoc = (COperationTableDoc*)GetDocument();

		tstring strOperationNumber = pCOperationTableDoc->getOperationNumber();
		//const unordered_map<tstring, list<OperationTableContent>>& MapListOperationTableContent =
		//	getCentDedDia()->getcontOperationTableContent();
		//list<OperationTableContent> ListOperationTableContent = MapListOperationTableContent.at(strOperationNumber);
		//m_ListOperationTableContent = &ListOperationTableContent;
		if (getCentDedDia()->getcontOperationTableContent().find(strOperationNumber) !=
			getCentDedDia()->getcontOperationTableContent().end())
		{
			m_ListOperationTableContent =
				&getCentDedDia()->getcontOperationTableContent().at(strOperationNumber);
		}
		if ( GetParent() == pView )
		{
			OnUpdate_All() ;
		}
		else
		{
			LogMsg(_T("CWndDcdGridOperationTable::OnUpdate()")
				_T("m_bUpdate_All_Requested=true") ) ;
			m_bUpdate_All_Requested = true ;
		}
	}
	
	int iYColumnBegin = createYColSpecCont().ColumnNumberFromSpec( 
		CdOperationTableYColSpec(CdOperationTableYColSpec::ColumnType_Ressya, 0 ) ) ;

	getCSelect()->setColumnNumberSelectLimit(
		CdDcdZoneXy( 
			CdDcdZone( 0 , INT_MAX ) ,
			CdDcdZone( iYColumnBegin , m_ListOperationTableContent->size()   )
		) );

}

void CWndDcdGridOperationTable::OnEditCopy()
{
	OnEditCopy_Process( FALSE );
}

void CWndDcdGridOperationTable::OnUpdateEditCopy(CCmdUI* pCmdUI)
{
	pCmdUI->Enable( OnEditCopy_Process( TRUE ) >= 0 ) ;
}


void CWndDcdGridOperationTable::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView)
{
	LogMsg(_T("CWndDcdGridOperationTable::OnActivateView(%d,,)") , bActivate ) ;
	
	if ( bActivate && m_bUpdate_All_Requested )
	{
		OnUpdate_All() ;
	}
}

void CWndDcdGridOperationTable::OnContextMenu(CWnd* pWnd, CPoint point)
{
	CMenu	aMenu ;
	aMenu.LoadMenu( IDR_MENU_OPERATIONTABLE_CONTEXT ) ;
	CMenu* pContextMenu = aMenu.GetSubMenu( 0 ) ;

	//	ReLXgj[}EXȊOŌĂяoꂽꍇ́A
	//	ReLXgj[̕\ʒúAtH[JXZ̒̈ʒuƂ܂B
	if ( point.x ==-1 || point.y == -1 )
	{
		//	ReLXgj[}EXȊOŌĂяo܂
		CdDcdPosXy posxyFocusCellColumnNumber = getCFocus()->getFocusCellColumnNumber() ;
		if ( posxyFocusCellColumnNumber !=  
				CFocus::ColumnNumberPosXy_NULL() )
		{
			CdDcdZoneXy	zonexyFocusCell = getCellZone( 
				posxyFocusCellColumnNumber.getX() , 
				posxyFocusCellColumnNumber.getY() ) ;
			point.x = zonexyFocusCell.getX().getPos() + zonexyFocusCell.getX().getSize() / 2 ;
			point.y = zonexyFocusCell.getY().getPos() + zonexyFocusCell.getY().getSize() / 2 ;
			ClientToScreen( &point ) ;
		}
	}
	//point = ReLXgj[̕\ʒuB
	//	-1̏ꍇ́AReLXgj[͕\ł܂B

	if ( point.x >= 0 &&  point.y >= 0 )
	{
		pContextMenu->TrackPopupMenu( 
			TPM_LEFTALIGN | TPM_RIGHTBUTTON ,
			point.x , point.y , 
			AfxGetMainWnd() ) ;	//	this w肷ƁAAppDocView 
								//R}h`F[삵܂B
	}
	else
	{
		super::OnContextMenu(pWnd, point);
	}
}

void CWndDcdGridOperationTable::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	int iRv = 0;
	iRv = OnOperationtableMovetojikokuhyouOpenDlg_Process(FALSE);
	//if (iRv >= 0)
	//{
	//	if (getCentDedDia()->getWaitOperationUpdate())
	//	{
	//		iRv = -1;	//^pXV}~Ԃł
	//	}
	//}
	//CdOperationTableYColSpec aCdOperationTableYColSpec = getYColSpecOfFocus();
	//if (iRv >= 0)
	//{
	//	if (getCSelect()->getSelectedCellCount() == 0)
	//	{
	//		if (aCdOperationTableYColSpec.getColumnType() !=
	//			CdOperationTableYColSpec::ColumnType_Ressya)
	//		{
	//			iRv = -2;	//tH[JXԈʒuȊOȂs
	//		}
	//	}
	//	else
	//	{
	//		iRv = -1; //I͕s
	//	}

	//}
	//if (iRv >= 0)
	//{
	//	ERessyahoukou eRessyahoukou = m_aRessyaProperty[aCdOperationTableYColSpec.getRessyaPropertyIndex()].getRessyahoukou();
	//	int iRessyaidx = m_aRessyaProperty[aCdOperationTableYColSpec.getRessyaPropertyIndex()].getRessyaIndex();
	//	// --------------------------------
	//	//	\r[J
	//	// --------------------------------
	//	CJikokuhyouView* pCJikokuhyouView = NULL;
	//	if (iRv >= 0)
	//	{
	//		CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
	//		if (iRv >= 0)
	//		{
	//			pCJikokuhyouDoc =
	//				getCDiagramEditApp()->openCJikokuhyouDoc(
	//					getCentDedDia(),
	//					eRessyahoukou,
	//					&pCJikokuhyouView);
	//			if (pCJikokuhyouView == NULL)
	//			{
	//				iRv = -3;	//	\r[̃I[vɎs܂
	//			}
	//		}
	//		//pCJikokuhyouDoc = \hLg
	//		//pCJikokuhyouView = \r[
	//	}

	//	if (iRv >= 0)
	//	{

	//		CdOperationTableXColSpec aCdOperationTableXColSpec = getXColSpecOfFocus();
	//		if (aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_Ressyabangou)
	//		{
	//			pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 1);
	//		}
	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_Ressyasyubetsu)
	//		{
	//			pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 2);
	//		}
	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_Ressyamei)
	//		{
	//			pCJikokuhyouView->openCDlgRessyaProp(iRessyaidx, 3);
	//		}
	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_OriginSideEkimei ||
	//			aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku)
	//		{
	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//			if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari)
	//			{
	//				pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getSihatsuEki(),true);
	//			}
	//			else
	//			{
	//				pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getSyuuchakuEki(), false);
	//			}
	//		}
	//		else if (aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_TerminalSideEkimei ||
	//			aCdOperationTableXColSpec.getColumnType() ==
	//			CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku)
	//		{
	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//			if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari)
	//			{
	//				pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getSyuuchakuEki(),false);
	//			}
	//			else
	//			{
	//				pCJikokuhyouView->openCDlgEkijikokuProp(iRessyaidx, aCentDedRessya.getSihatsuEki(), true);
	//			}
	//		}
	//		else
	//		{
	//			CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
	//			pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getSihatsuEki());
	//		}
	//		iRv = 1;	//	\r[ֈړ܂
	//	}

	//}
}

void CWndDcdGridOperationTable::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	int iRv = 0;

	if (iRv >= 0 && CKeyinputSenderToModalDlg::AnyLetterOrDigitKeyIsDown())
	{

		if (iRv >= 0)
		{
			if (getCentDedDia()->getWaitOperationUpdate())
			{
				iRv = -1;	//^pXV}~Ԃł
			}
		}
		CdOperationTableYColSpec aCdOperationTableYColSpec = getYColSpecOfFocus();
		if (iRv >= 0)
		{
			if (getCSelect()->getSelectedCellCount() == 0)
			{
				if (aCdOperationTableYColSpec.getColumnType() !=
					CdOperationTableYColSpec::ColumnType_Ressya)
				{
					iRv = -2;	//tH[JXԈʒuȊOȂs
				}
			}
			else
			{
				iRv = -1; //I͕s
			}
		}

		if (iRv >= 0)
		{
			auto itr = m_ListOperationTableContent->begin();
			for (int idx = 0; idx < aCdOperationTableYColSpec.getOperationTableContentIndex(); idx++)
			{
				itr++;
			}
			ERessyahoukou eRessyahoukou = itr->aRessyaProperty.getRessyahoukou();
			int iRessyaidx = itr->aRessyaProperty.getRessyaIndex();
			// --------------------------------
			//	\r[J
			// --------------------------------
			CJikokuhyouView* pCJikokuhyouView = NULL;
			if (iRv >= 0)
			{
				CJikokuhyouDoc* pCJikokuhyouDoc = NULL;
				if (iRv >= 0)
				{
					pCJikokuhyouDoc =
						getCDiagramEditApp()->openCJikokuhyouDoc(
							getCentDedDia(),
							eRessyahoukou,
							false,
							&pCJikokuhyouView);
					if (pCJikokuhyouView == NULL)
					{
						iRv = -3;	//	\r[̃I[vɎs܂
					}
				}
				//pCJikokuhyouDoc = \hLg
				//pCJikokuhyouView = \r[
			}

			if (iRv >= 0)
			{

				CdOperationTableXColSpec aCdOperationTableXColSpec = getXColSpecOfFocus();
				if (aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_Ressyabangou)
				{
					pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 1, nChar, nRepCnt, nFlags);
				}
				else if (aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_Ressyasyubetsu)
				{
					pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 2, nChar, nRepCnt, nFlags);
				}
				else if (aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_Ressyamei)
				{
					pCJikokuhyouView->openCDlgRessyaPropKeyDown(iRessyaidx, 3, nChar, nRepCnt, nFlags);
				}
				else if (aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_OriginSideEkimei ||
					aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_OriginSideEkijikoku)
				{
					CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
					if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
						getDisplayNoboriLeftToRight())
					{
						pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true, nChar, nRepCnt, nFlags);
					}
					else
					{
						pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false, nChar, nRepCnt, nFlags);
					}
				}
				else if (aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_TerminalSideEkimei ||
					aCdOperationTableXColSpec.getColumnType() ==
					CdOperationTableXColSpec::ColumnType_TerminalSideEkijikoku)
				{
					CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
					if (eRessyahoukou == ERessyahoukou::Ressyahoukou_Kudari ||
						getDisplayNoboriLeftToRight())
					{
						pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSyuuchakuEki(), false, nChar, nRepCnt, nFlags);
					}
					else
					{
						pCJikokuhyouView->openCDlgEkijikokuPropKeyDown(iRessyaidx, aCentDedRessya.getValidSihatsuEki(), true, nChar, nRepCnt, nFlags);
					}
				}
				else
				{
					CentDedRessya aCentDedRessya = getCentDedRessyaCont(eRessyahoukou)->get(iRessyaidx);
					pCJikokuhyouView->setFocusToRessyaIndex(iRessyaidx, aCentDedRessya.getValidSihatsuEki());
				}
				iRv = 1;	//	\r[ֈړ܂
			}
		}

	}
	else
	{
		//if (!m_CKeyinputSenderToModalDlg.OnKeyDown(nChar, nRepCnt, nFlags))
		//{
		super::OnKeyDown(nChar, nRepCnt, nFlags);
		//}
	}
}
} //namespace ViewEkiTrack2


void ViewOperationTable::CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyou()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnOperationtableMovetojikokuhyou_Process(FALSE);
}


void ViewOperationTable::CWndDcdGridOperationTable::OnUpdateOperationtableMovetojikokuhyou(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnOperationtableMovetojikokuhyou_Process(TRUE) >= 0);
}


void ViewOperationTable::CWndDcdGridOperationTable::OnOperationtableMovetojikokuhyouOpenDlg()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnOperationtableMovetojikokuhyouOpenDlg_Process(FALSE);
}


void ViewOperationTable::CWndDcdGridOperationTable::OnUpdateOperationtableMovetojikokuhyouOpenDlg(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnOperationtableMovetojikokuhyouOpenDlg_Process(TRUE) >= 0);
}


void ViewOperationTable::CWndDcdGridOperationTable::OnOperationtableMovetodiagram()
{
	// TODO: ɃR}h nh[ R[hǉ܂B
	OnOperationtableMovetodiagram_Process(FALSE);
}


void ViewOperationTable::CWndDcdGridOperationTable::OnUpdateOperationtableMovetodiagram(CCmdUI *pCmdUI)
{
	// TODO:ɃR}hXV UI nh[ R[hǉ܂B
	pCmdUI->Enable(OnOperationtableMovetodiagram_Process(TRUE) >= 0);
}

void CWndDcdGridOperationTable::OnViewDisplaySecondEkijikoku()
{
	OnViewDisplaySecondEkijikoku_Process(FALSE);
}

void CWndDcdGridOperationTable::OnUpdateViewDisplaySecondEkijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplaySecondEkijikoku_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridOperationTable::OnViewDisplayColonEkijikoku()
{
	OnViewDisplayColonEkijikoku_Process(FALSE);
}

void CWndDcdGridOperationTable::OnUpdateViewDisplayColonEkijikoku(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplayColonEkijikoku_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridOperationTable::OnViewDisplayParentSyubetsu()
{
	OnViewDisplayParentSyubetsu_Process(FALSE);
}

void CWndDcdGridOperationTable::OnUpdateViewDisplayParentSyubetsu(CCmdUI *pCmdUI)
{
	int iResult = OnViewDisplayParentSyubetsu_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}

void CWndDcdGridOperationTable::OnViewDisplayNoboriLeftToRight()
{
	OnViewDisplayNoboriLeftToRight_Process(FALSE);
}

void CWndDcdGridOperationTable::OnUpdateViewDisplayNoboriLeftToRight(CCmdUI* pCmdUI)
{
	int iResult = OnViewDisplayNoboriLeftToRight_Process(TRUE);
	pCmdUI->Enable(iResult >= 0);
	pCmdUI->SetCheck(iResult >= 1);
}



void ViewOperationTable::CWndDcdGridOperationTable::OnFileExportOperationtablecsv()
{
	OnFileExportOperationTableCsv_Process(FALSE);
}
