/*
	OuDiaSecond Copyright (C) 2017-2019 diagram_mania

̃vÓAtake-okm쐬OuDia\tgEFAłB
̃vOpɂẮAtake-okmLڂ̉Lɏ܂B
*/
/*
	OuDia - Win32 Application Software to draw a "Train Service Planning
 Diagram" based on a "Train Timetable".

Copyright (C) 2006-2017 take-okm

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your option) 
any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
more details. 

You should have received a copy of the GNU General Public License along with
 this program. If not, see <http://www.gnu.org/licenses/>.

  In addition, as a special exception, take-okm
  gives permission to link the code of this program with
  the "MFC(Microsoft Foundation Class library) Version 9.0" 
  (or with modified versions of "MFC Version 9.0" that use the same license as 
  "MFC Version 9.0" ), and distribute linked combinations including
  the two.  You must obey the GNU General Public License in all
  respects for all of the code used other than  "MFC".  If you modify
  this file, you may extend this exception to your version of the
  file, but you are not obligated to do so.  If you do not wish to
  do so, delete this exception statement from your version.


(: 

	OuDia - Ԏ\ƂɁA_CO`悷Win32AvP[V
B

Copyright (C) 2006-2017 take-okm 

̃vO̓t[\tgEFAłBȂ͂At[\tgEFA
cɂĔsꂽGNU ʌOp(o[W3Aȍ~̃o[W
̂ǂꂩ)߂̉ōĔЕz܂͉ 邱Ƃł܂B

̃vO͗Lpł邱ƂĔЕz܂A*S̖ۏ *łB
Ɖ\̕ۏ؂ړIւ̓ḰAOɎꂽ̂ ܂߁AS
܂BڂGNU ʌOpB

Ȃ͂̃vOƋɁAGNU ʌOp̃Rs[ꕔ 󂯎
Ă͂łB󂯎ĂȂ΁A<http://www.gnu.org/licenses/> 
B

)

  āAʂȗOƂāAtake-okm ͂̃vÕR[h 
  "MFC(Microsoft Foundation Class library) Version 9.0" 
  (  邢 "MFC Version 9.0" ƓCZXKpꂽ
  "MFC Version 9.0" ̉ςꂽo[W)ƃNA
  Nꂽ҂܂ތ앨Еz鋖^܂B
  Ȃ "MFC" ȊOŎgĂ邷ׂ
  ̃R[hɊւĂ͑SʓIGNUʌOp_񏑂ɏ]Ȃ
  Ȃ܂BȂ̃t@CςȂ΁AȂ̗͂O
  Ȃ̃o[W̃t@CɈ݂邱Ƃł܂A
  `͂܂BO݂Ȃ΁A̗O
  Ȃ̃o[W͍폜ĂB)
*/
/*
// ****************************************************************
//	CentDedRosen.cpp
// ****************************************************************
*/
#include "stdafx.h"
#include <assert.h>
#include <vector>
#include <algorithm>

#include "NsMu/CaMui.h" 
#include "CentDedRosen.h"
//#include "../entDgr/CDedOperationConnecter.h"
#include "CDedOperationConnecter.h"
#include "NsOu/dynamic_castOu.h"
#include "NsOu/OuNew.h"

using namespace std ;


#ifdef _MFC_VER 
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
#endif

namespace entDed{

const TCHAR nameRessyasyubetsuDefault[] = _T("") ; 

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedEkiCont
// ----------------------------------------------------------------
	// ********************************
	//	RXgN^
	// ********************************

	// ********************************
	//	Mui
	// ********************************

int CentDedRosen::CXCentDedEkiCont::insert( const CentDedEki& element , int iIndex )
{
	int iRv = 0 ;
	if ( iRv >= 0 ){
		if ( iIndex == INT_MAX ){
			iIndex = size() ;
		}
		if ( !( 0 <= iIndex && iIndex <= size() ) ){
			iRv = -1 ;
		}
	}	
	if ( iRv >= 0 ){
		iRv = super::insert( element , iIndex ) ;
	}
	return ( iRv ) ;
}
int CentDedRosen::CXCentDedEkiCont::erase( int iIndex  , int iSize ) 
{
	int iRv = 0 ;
	
	if ( iRv >= 0 ){
		if ( iIndex == INT_MAX && iSize == INT_MAX ){
			iRv = -1 ;
		}	else if ( iIndex == INT_MAX ){
			iIndex = size() - iSize ;
		}	else if ( iSize == INT_MAX ){
			iSize = size() - iIndex ;
		}
		if ( !( 0 <= iIndex && iIndex + iSize <= size() ) ){
			iRv = -1 ;
		}
	}	
	
	if ( iRv >= 0 ){
		iRv = super::erase( iIndex , iSize ) ;
	}

	return ( iRv ) ;
};
		// ********************************
		//@name CentDedEkiCont-֘A
		// ********************************
CentDedRosen*  CentDedRosen::CXCentDedEkiCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedEkiCont ) ) ;
	return pOuter ;
}
const CentDedRosen*  CentDedRosen::CXCentDedEkiCont::getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedEkiCont ) ) ;
	return pOuter ;
}

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedRessyasyubetsuCont
// ----------------------------------------------------------------
	// ********************************
	//	RXgN^
	// ********************************
CentDedRosen::CXCentDedRessyasyubetsuCont::	CXCentDedRessyasyubetsuCont() 
{
	//̗Ԏʂ̒ǉ́ACentDedRosen::CentDedRosen ōs܂B
}
	// ********************************
	//	Mui
	// ********************************


		// ********************************
		//@name CentDedEkiCont-֘A
		// ********************************
CentDedRosen* CentDedRosen::CXCentDedRessyasyubetsuCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedRessyasyubetsuCont ) ) ;
	return pOuter ;
}
const CentDedRosen* CentDedRosen::CXCentDedRessyasyubetsuCont:: getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedRessyasyubetsuCont ) ) ;
	return pOuter ;
}

// ----------------------------------------------------------------
//	CentDedRosen::CXCentDedDiaCont
// ----------------------------------------------------------------
		// ********************************
		//	RXgN^
		// ********************************

		// ********************************
		//@name CentDedDiaCont-֘A
		// ********************************
CentDedRosen* CentDedRosen::CXCentDedDiaCont::getRosen()
{
	CentDedRosen* pOuter = (CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedDiaCont ) ) ;
	return pOuter ;
}
const CentDedRosen* CentDedRosen::CXCentDedDiaCont::getRosen()const 
{
	const CentDedRosen* pOuter = (const CentDedRosen*)( ((char*)this) - offsetof( CentDedRosen , m_CentDedDiaCont ) ) ;
	return pOuter ;
}
		

// ****************************************************************
//	CentDedRosen
// ****************************************************************

// ********************************
//	RXgN^
// ********************************
CentDedRosen::CentDedRosen() 
	: m_jikokuKitenJikoku( 0 , 0 , 0 ) 
	, m_iDiagramDgrYZahyouKyoriDefault( 60 )
	, m_iEnableOperation(0)
	, m_bOperationNumberReverse(false)
{
	//	ftHǵwԎʁx̖Oݒ肵܂B
	m_CentDedRessyasyubetsuCont.insert( 
		CentDedRessyasyubetsu( nameRessyasyubetsuDefault , _T("")  ) , 
		INT_MAX ) ;
}
	

CentDedRosen::CentDedRosen( const CentDedRosen& value )
	: m_CentDedRessyasyubetsuCont( value.m_CentDedRessyasyubetsuCont ) 
{
	m_strName = value.m_strName ;
	m_jikokuKitenJikoku = value.m_jikokuKitenJikoku ;
	m_iDiagramDgrYZahyouKyoriDefault = value.m_iDiagramDgrYZahyouKyoriDefault ;
	m_strComment = value.m_strComment ;
	m_iEnableOperation = value.m_iEnableOperation;
	m_strKudariDiaAlias = value.m_strKudariDiaAlias;
	m_strNoboriDiaAlias = value.m_strNoboriDiaAlias;
	m_bOperationNumberReverse = value.m_bOperationNumberReverse;

	CaMui<CentDedEki>( &m_CentDedEkiCont ).insert( &value.m_CentDedEkiCont , 0 , INT_MAX , 0 ) ;
	m_CentDedDiaCont = value.m_CentDedDiaCont ;
}
	
CentDedRosen& CentDedRosen::operator=( const CentDedRosen& value )
{
	// --------------------------------
	//	܂ł̒lj
	// --------------------------------

	m_CentDedDiaCont.erase( 0 , INT_MAX ) ;

	//	ftHgԂ݂̂ɂ܂B
	m_CentDedRessyasyubetsuCont.erase( 1 , INT_MAX ) ;
	m_CentDedRessyasyubetsuCont.set( 
		CentDedRessyasyubetsu( nameRessyasyubetsuDefault , _T("")  ) , 
		INT_MAX ) ;

	m_CentDedEkiCont.erase( 0 , INT_MAX ) ;

	// --------------------------------
	//	lRs[
	// --------------------------------
	
	m_strName = value.m_strName ;
	m_jikokuKitenJikoku = value.m_jikokuKitenJikoku ;
	m_iDiagramDgrYZahyouKyoriDefault = value.m_iDiagramDgrYZahyouKyoriDefault ;
	m_strComment = value.m_strComment ;
	m_iEnableOperation = value.m_iEnableOperation;
	m_CentDedEkiCont = value.m_CentDedEkiCont ;
	m_CentDedEkiCont.adjustBrunchLoopCont();
	m_CentDedRessyasyubetsuCont = value.m_CentDedRessyasyubetsuCont ;
	m_strKudariDiaAlias = value.m_strKudariDiaAlias;
	m_strNoboriDiaAlias = value.m_strNoboriDiaAlias;
	m_bOperationNumberReverse = value.m_bOperationNumberReverse;

	m_CentDedDiaCont = value.m_CentDedDiaCont ;

	return ( *this ) ;
}

	
// ********************************
//	CentDedRosen
// ********************************
	// ********************************
	//@name 
	// ********************************
	// ********************************
	//@name -CentDedEki
	// ********************************
	
	// ********************************
	//@name -CentDedRessyasyubetsu
	// ********************************

	
	// ********************************
	//@name -CentDedDia
	// ********************************

	// ********************************
	//@name 
	// ********************************
void CentDedRosen::insert( 
	const CentDedRosen& rosenToAdd_enter ,
	int iEkiIndexToInsert ) 
{
	CentDedRosen rosenToAdd = rosenToAdd_enter ;
	//gwIndex(N_)EgIndex(I_)
	//	[g悪nw]
	//@@	gwIndex=-1
	//@@	gwIndex=͂ꂽg̉wIndex
	//	[g悪ԉw]
	//@@	gwIndex=͂ꂽg̉wIndex
	//@@	gwIndex=͂ꂽg̉wIndex
	//	[g悪Iw]
	//@@	gwIndex=w-1
	//@@	gwIndex=w
	int iEkiIndexToInsertMin = -1 ;
	int iEkiIndexToInsertMax = -1 ;
	{
		//[g悪nw]
		if ( iEkiIndexToInsert == 0 )
		{
			iEkiIndexToInsertMin = -1 ;
			iEkiIndexToInsertMax = iEkiIndexToInsert ;
		}
		//[g悪ԉw]
		//	gwIndex=͂ꂽg̉wIndex
		//	gwIndex=͂ꂽg̉wIndex
		else if ( 0 < iEkiIndexToInsert &&
			iEkiIndexToInsert < getCentDedEkiCont()->size() - 1 )
		{
			iEkiIndexToInsertMin = iEkiIndexToInsert ;
			iEkiIndexToInsertMax = iEkiIndexToInsert ;
		}
		//[g悪Iw]
		//	gwIndex=w-1
		//	gwIndex=w
		else
		{
			iEkiIndexToInsertMin = getCentDedEkiCont()->size() - 1 ;
			iEkiIndexToInsertMax = getCentDedEkiCont()->size() ;
		}
	}
	//[g悪ԉw]ȂẢw𕪊
	if ( 0 < iEkiIndexToInsertMin &&
			iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		//@gwIndex=͂ꂽg̉wIndex
		//@gwIndex=͂ꂽg̉wIndex+1
		iEkiIndexToInsertMax = iEkiIndexToInsertMin + 1 ;

		//@gwIndexƓwAgwIndex+1̈ʒuɒǉ
		//@gwIndex̉w͉蒅
		//@gwIndex̉w͏蒅
		{
			CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont();

			//gݓwAhw̏ꍇ@E蒅or蒅
			//	wݒ
			//w̏ꍇ@E
			//	핪wݒ
			//N_w̏ꍇ@E蒅or
			//	I_̐ݒAǉꂽ()ɐݒύXB
			//I_w̏ꍇ@E蒅or
			//	ǉꂽ()́Aݒ͉
			//wN_w̏ꍇ@E
			//	핪wݒAI_̐ݒAǉꂽ()ɐݒύXB
			//N_wI_w̏ꍇ@E
			//	ǉꂽ()́Aݒ͉AI_̐ݒAǉꂽ()ɐݒύXB
			//I_ww̏ꍇ@E
			//	핪wݒAǉꂽ()́Aݒ͉

			//܂AwݒE핪wݒ͉
			//ǉÅݒ͉
			//㑤̉wN_wƂI_ẘݒẢwɂ炷B

			//gݓwwƂhwLAwݒB
			CentDedEki*	pDedEkiInsertMin = pCentDedEkiCont->getMuPtr()->get(iEkiIndexToInsertMin);
			if (pDedEkiInsertMin->getBrunchCoreEkiIndex() >= 0)
			{
				pDedEkiInsertMin->setBrunchCoreEkiIndex(-1);
			}
			else if (pDedEkiInsertMin->getEkikibo() == CentDedEki::Ekikibo_Syuyou &&
				pDedEkiInsertMin->getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_Hatsuchaku)
			{
				for (int idx = 0; idx < pCentDedEkiCont->size(); idx++)
				{
					CentDedEki*	pCentDedEkiSearch = pCentDedEkiCont->getMuPtr()->get(idx);
					if (pCentDedEkiSearch->getBrunchCoreEkiIndex() == iEkiIndexToInsertMin)
					{
						pCentDedEkiSearch->setBrunchCoreEkiIndex(-1);
					}
				}
			}

			pCentDedEkiCont->insert(*pDedEkiInsertMin, iEkiIndexToInsertMax);
			CentDedEki*	pDedEkiInsertMax = pCentDedEkiCont->getMuPtr()->get(iEkiIndexToInsertMax);
			pDedEkiInsertMin->setEkijikokukeisiki(CentDedEki::Jikokukeisiki_KudariChaku);
			pDedEkiInsertMax->setEkijikokukeisiki(CentDedEki::Jikokukeisiki_NoboriChaku);

			if (pDedEkiInsertMax->getLoopOriginEkiIndex() >= 0)
			{
				pDedEkiInsertMax->setLoopOriginEkiIndex(-1);
			}
			for (int idx = iEkiIndexToInsertMax + 1; idx < pCentDedEkiCont->size(); idx++)
			{
				CentDedEki*	pCentDedEkiSearch = pCentDedEkiCont->getMuPtr()->get(idx);
				if (pCentDedEkiSearch->getLoopOriginEkiIndex() == iEkiIndexToInsertMin)
				{
					pCentDedEkiSearch->setLoopOriginEkiIndex(iEkiIndexToInsertMax);
				}
			}

			//gwIndex̉ẃAwgݓꂽwɂȂ̂ŁAw܂ł̋ĂB
			pDedEkiInsertMin->setNextEkiDistance(0);
		}

		//S_C̃[v
		CentDedDiaCont* pCentDedDiaCont = &m_CentDedDiaCont ;
		int idxDia ;
		for ( idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
			//ԑSԂ̃[v
			//@gwOrderEgwOrder߂
			{
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( Ressyahoukou_Kudari ) ;
				int iEkiOrderToInsertMin = -1 ;
				int iEkiOrderToInsertMax = -1 ;
				{
					int iEkiOrder1 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrder2 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					iEkiOrderToInsertMin = min( iEkiOrder1 , iEkiOrder2 ) ;
					iEkiOrderToInsertMax = max( iEkiOrder1 , iEkiOrder2 ) ;
				}

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;
					CentDedEkiJikoku aEkiJikokuToInserMin = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin ) ;
					CentDedEkiJikoku aEkiJikokuToInserMax = pCentDedRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax ) ;

					//@[gwOrdernw̗]
					//@gwOrderɁAgOrderRs[
					//@gwOrdeŕA^sȂƂB
					if ( pCentDedRessya->getSihatsuEki() == iEkiOrderToInsertMin )
					{
						aEkiJikokuToInserMax = aEkiJikokuToInserMin ;
						aEkiJikokuToInserMin.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}
					//@[gwIndexԉw̗]
					//@@gwOrderɁAgwOrder̉wRs[
					//			(1.04.06ǉ)Index̔ƁAIndex̒폜
					else if ( pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMin && 
						iEkiOrderToInsertMin < pCentDedRessya->getSyuuchakuEki() ) 
					{
						aEkiJikokuToInserMax = aEkiJikokuToInserMin ;
						if (!aEkiJikokuToInserMin.getChakujikoku().isNull())
						{
							aEkiJikokuToInserMin.setHatsujikoku(CdDedJikoku());
						}
						if (!aEkiJikokuToInserMax.getHatsujikoku().isNull())
						{
							aEkiJikokuToInserMax.setChakujikoku(CdDedJikoku());
						}
					}
					//@[gwOrderIw̗]
					//@@gwOrdeŕÂ܂܂ƂB
					//@@gwOrdeŕA^sȂƂB
					else if ( pCentDedRessya->getSyuuchakuEki() == iEkiOrderToInsertMin )
					{
						aEkiJikokuToInserMax.setEkiatsukai( CentDedEkiJikoku::Ekiatsukai_None ) ;
					}

					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMin , aEkiJikokuToInserMin ) ;
					pCentDedRessya->setCentDedEkiJikoku( iEkiOrderToInsertMax , aEkiJikokuToInserMax ) ;
				}
			}

			//ԑSԂ̃[v
			//  @gwOrderEgwOrder߂
			{
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont(Ressyahoukou_Nobori);
				int iEkiOrderToInsertMin = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndexToInsertMax);
				int iEkiOrderToInsertMax = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndexToInsertMin);

				for (int idxRessya = 0; idxRessya < pCentDedRessyaCont->size(); idxRessya++)
				{
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get(idxRessya);

					CentDedEkiJikoku aEkiJikokuToInserMin = pCentDedRessya->getCentDedEkiJikoku(iEkiOrderToInsertMin);
					CentDedEkiJikoku aEkiJikokuToInserMax = pCentDedRessya->getCentDedEkiJikoku(iEkiOrderToInsertMax);

					//[gwOrder傪nw̗]
					//gwOrdeŕÂ܂܂ƂB
					//gwOrdeŕA^sȂƂB
					if (pCentDedRessya->getSihatsuEki() == iEkiOrderToInsertMax)
					{
						aEkiJikokuToInserMin.setEkiatsukai(CentDedEkiJikoku::Ekiatsukai_None);
					}
					//[gwIndex傪ԉw̗]
					//@gwIndexɁAgwIndex̉wRs[
					//@gwIndex̉ww`(̂)ɍ킹ĕ␳
					//@(gwIndex̔NULLɕύX)
					//@gwIndex̉ww`(̂)ɍ킹ĕ␳
					//@(gwIndex̒NULLɕύX)
					//			(1.04.06ǉ)Index̔ƁAIndex̒tō폜
					else if (pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMax &&
						iEkiOrderToInsertMax < pCentDedRessya->getSyuuchakuEki())
					{
						aEkiJikokuToInserMin = aEkiJikokuToInserMax;
						//aRessyaTrackToInserMin = aRessyaTrackToInserMax;
						if (!aEkiJikokuToInserMin.getChakujikoku().isNull())
						{
							aEkiJikokuToInserMin.setHatsujikoku(CdDedJikoku());
						}
						if (!aEkiJikokuToInserMax.getHatsujikoku().isNull())
						{
							aEkiJikokuToInserMax.setChakujikoku(CdDedJikoku());
						}
					}
					//[gwIndex傪Iw̗]
					//gwIndexɁAwRs[
					//gwIndex́A^sȂƂB
					else if (pCentDedRessya->getSyuuchakuEki() == iEkiOrderToInsertMax)
					{
						aEkiJikokuToInserMin = aEkiJikokuToInserMax;
						aEkiJikokuToInserMax.setEkiatsukai(CentDedEkiJikoku::Ekiatsukai_None);
					}

					pCentDedRessya->setCentDedEkiJikoku(iEkiOrderToInsertMin, aEkiJikokuToInserMin);
					pCentDedRessya->setCentDedEkiJikoku(iEkiOrderToInsertMax, aEkiJikokuToInserMax);
				}

			}
		}
		//gwIndex̉ww`ɍ킹ĕ␳
		//@ww`ɍ킹ĕ␳
		//@@@[w`ɒEȂA
		//@  @wɒȂA]
		//@  @ɂ͔Rs[ANULLB
		//@  @[w`ɒȂE
		//@  @wɒAȂ]
		//@  @ɂ͒Rs[ANULLB
		//@  @[wnwE
		//@  @w`ɒEA
		//@  @wɒAȂ]
		//@  @ɂ͒Rs[ANULLB
		//@  @[wIwE
		//@  @@w`ɒE
		//@  @@wɒȂA]
		//@  @@ɂ͔Rs[ANULLB
		//gwIndex̉ww`ɍ킹ĕ␳
		adjustByEkijikokukeisiki( iEkiIndexToInsertMin ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMax ) ;
	}
	//[g悪N_w]ȂẢw̉w`[蒅]Ƃ
	//@@[gwIndex=-1,gwIndex=0]
	//@@@@gwIndex蒅Ƃ
	//  @gwIndex̉ww`ɍ킹ĕ␳
	else if ( iEkiIndexToInsertMin == -1 &&
			iEkiIndexToInsertMax == 0 )
	{
		CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont() ;
		CentDedEki*	pDedEkiInsert = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMax ) ;
		pDedEkiInsert->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMax ) ;
	}
	//[g悪I_w]ȂẢw̉w`[蒅]Ƃ
	//@@[g悪Index=w-1 AND gwIndex=w]
	//@@@@gwIndex蒅Ƃ
	//  @gwIndex̉ww`ɍ킹ĕ␳
	//w܂ł̋ĂB
	else if ( iEkiIndexToInsertMin == getCentDedEkiCont()->size() - 1 &&
			iEkiIndexToInsertMax == getCentDedEkiCont()->size() ) 
	{
		CentDedEkiCont* pCentDedEkiCont = getCentDedEkiCont() ;
		CentDedEki*	pDedEkiInsert = pCentDedEkiCont->getMuPtr()->get( iEkiIndexToInsertMin ) ;
		pDedEkiInsert->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
		adjustByEkijikokukeisiki( iEkiIndexToInsertMin ) ;
		pDedEkiInsert->setNextEkiDistance(0);
	}




	//wǉ
	//@@gHt@C̉wׂĒǉB
	//@@@ǉwIndex́AgwIndex+1B
	//		[gHt@C̋N_w̉w`ȊO]
	//		  ̉w̉w`[蒅]Ƃ
	//		[gHt@C̏I_w̉w`ȊO]
	//		  ̉w̉w`[蒅]Ƃ
	//@@gwIndexɁAǉwZ
	//	gݓI_ẃuw܂ł̋v
	{
		CentDedEkiCont* pCentDedEkiCont = &m_CentDedEkiCont ;
		const CentDedEkiCont* pCentDedEkiContToAdd = rosenToAdd.getCentDedEkiCont() ;
		for ( int idxEki = 0 ; idxEki < pCentDedEkiContToAdd->size() ; idxEki ++ )
		{
			CentDedEki aEki = *pCentDedEkiContToAdd->getMuPtr()->get( idxEki ) ;
			if ( idxEki == 0 && aEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku )
			{
				aEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_NoboriChaku ) ;
			}
			else if ( idxEki == pCentDedEkiContToAdd->size() - 1 && 
				aEki.getEkijikokukeisiki() != CentDedEki::Jikokukeisiki_Hatsuchaku )
			{
				aEki.setEkijikokukeisiki( CentDedEki::Jikokukeisiki_KudariChaku ) ;
			}
			/*if (aEki.getBrunchCoreEkiIndex() >= 0 &&
				aEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku)
			{
				aEki.setBrunchCoreEkiIndex(
					aEki.getBrunchCoreEkiIndex()+ iEkiIndexToInsertMin+1 -
				(pCentDedEkiContToAdd->size()- idxEki));
			}
			else */if (aEki.getBrunchCoreEkiIndex() >= 0 &&
				aEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_NoboriChaku)
			{
				aEki.setBrunchCoreEkiIndex(aEki.getBrunchCoreEkiIndex() + iEkiIndexToInsertMin + 1);
			}
			if (aEki.getLoopOriginEkiIndex() >= 0)
			{
				aEki.setLoopOriginEkiIndex(aEki.getLoopOriginEkiIndex() + iEkiIndexToInsertMin+1);
			}
			if (idxEki == pCentDedEkiContToAdd->size() - 1)
			{
				aEki.setNextEkiDistance(0);
			}

			pCentDedEkiCont->insert( 
				aEki ,
				iEkiIndexToInsertMin + 1 + idxEki ) ;


			iEkiIndexToInsertMax ++ ;

		}
		/**
			gݓH̒ɁA蒅̔hw(wI_ɂ)ꍇ́A
			BrunchCoreEkiIndexC܂B
			́ACentDedEkionEkiInsertŁA{svȃCNg邩łB
			(onEkiInsertł́ABrunchCoreEkiIndexƉẘ֌WɂACNg}dg݂邪A
			gݓ̏ꍇ́AgݓwɁẢw邽߁Aւ̑gݓȊOł͕ssɂȂB)

		*/
		for (int idxEki = 0; idxEki < pCentDedEkiContToAdd->size(); idxEki++)
		{
			CentDedEki aEki = *pCentDedEkiContToAdd->getMuPtr()->get(idxEki);
			if (aEki.getBrunchCoreEkiIndex() >= 0 &&
				aEki.getEkijikokukeisiki() == CentDedEki::Jikokukeisiki_KudariChaku)
			{
				CentDedEki aEkiNew = *pCentDedEkiCont->getMuPtr()->get(iEkiIndexToInsertMin + 1 + idxEki);
				aEkiNew.setBrunchCoreEkiIndex(aEki.getBrunchCoreEkiIndex() + iEkiIndexToInsertMin + 1);

				pCentDedEkiCont->set(
					aEkiNew,
					iEkiIndexToInsertMin + 1 + idxEki);
			}
		}
	}

	//[g悪ԉw]ȂAgwIndexrwƂȂԂ́A
	//@@@@@@@@@@ǉꂽw̉woRȂɂB
	if ( 0 < iEkiIndexToInsertMin &&
			iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		//@@SԂ̃[v
		//@@@@Ẽ[v
		//@@@@  @gwOrderEgwOrder߂
		//@@@@@@[nwgwOrderO AND 
		//@@@@@@@IwgwOrder]
		//@@@@@@@gwOrder+1`gwOrder-1̉w
		//@@@@@@@oRȂɂB
		CentDedDiaCont* pCentDedDiaCont = &m_CentDedDiaCont ;
		int idxDia ;
		for ( idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
			//ԑSԂ̃[v
			//@gwOrderEgwOrder߂
			for ( int iRessyahoukou = Ressyahoukou_Kudari ;
				iRessyahoukou <= Ressyahoukou_Nobori ;
				iRessyahoukou ++ )
			{
				ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;

				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;
				int iEkiOrderToInsertMin = -1 ;
				int iEkiOrderToInsertMax = -1 ;
				{
					int iEkiOrder1 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrder2 = pCentDedRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					iEkiOrderToInsertMin = min( iEkiOrder1 , iEkiOrder2 ) ;
					iEkiOrderToInsertMax = max( iEkiOrder1 , iEkiOrder2 ) ;
				}

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					//@@@@@@[nwgwOrderO AND 
					//@@@@@@@IwgwOrder]
					//@@@@@@@gwOrder+1`gwOrder-1̉w
					//@@@@@@@^sȂɂB
					CentDedRessya* pCentDedRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;
					if ( pCentDedRessya->getSihatsuEki() < iEkiOrderToInsertMin && 
						iEkiOrderToInsertMax < pCentDedRessya->getSyuuchakuEki() )
					{

						CentDedEkiJikoku aEkijikokuNone( 
							CentDedEkiJikoku::Ekiatsukai_None ,
							CdDedJikoku() , CdDedJikoku() ) ;
						for ( int iEkiOrder = iEkiOrderToInsertMin + 1 ;
							iEkiOrder <= iEkiOrderToInsertMax - 1 ;
							iEkiOrder ++ )
						{
							pCentDedRessya->setCentDedEkiJikoku( iEkiOrder ,aEkijikokuNone ) ; 
						}
					}
				}
			}
		}
	}
	//Ԏʂ̃}[W
	//@@gHt@C̗Ԏʂɂ郋[v
	//@@@@[̗ԎʂҏW̘Ht@Cɑ݂Ȃ]Ԏʂ
	//@@@@@ҏW̘Ht@Cɒǉ
	//@@@@ԎʑΏƕ\(gHt@C̗ԎIndex
	//@@@@@gHt@C̗ԎIndex ̑Ώƕ\쐬
	deque<int>	arRessyasyubetsuIdx_AddedToThis ;
	{
		CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont = this->getCentDedRessyasyubetsuCont() ;
		const CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuContToAdd = rosenToAdd.getCentDedRessyasyubetsuCont() ;
		

		const Mu<const CentDedRessyasyubetsu*>* muCentDedRessyasyubetsuToAdd =
				pCentDedRessyasyubetsuContToAdd->getMuPtr() ;
		Mu<CentDedRessyasyubetsu*>* muCentDedRessyasyubetsuThis =
			pCentDedRessyasyubetsuCont->getMuPtr();
		int iSizeThis = muCentDedRessyasyubetsuThis->size();
		for ( int idxToAdd = 0 ; idxToAdd < muCentDedRessyasyubetsuToAdd->size() ; idxToAdd ++ )
		{
			const CentDedRessyasyubetsu* pCentDedRessyasyubetsuToAdd = 
				muCentDedRessyasyubetsuToAdd->get( idxToAdd ) ;

			int idxThis = 0 ;
			for ( idxThis = 0 ; idxThis < muCentDedRessyasyubetsuThis->size() ; idxThis ++ )
			{
				const CentDedRessyasyubetsu* pCentDedRessyasyubetsuThis = muCentDedRessyasyubetsuThis->get( idxThis ) ;
				if ( pCentDedRessyasyubetsuThis->getSyubetsumei() == 
					pCentDedRessyasyubetsuToAdd->getSyubetsumei() )
				{
					break ;
				}
			}
			//idxThis = wǉHt@Cx̗Ԏ[idxToAdd] Ɠ
			//	this̗Ԏʂ̃CfNXB
			//	Ȃ΁A  muCentDedRessyasyubetsuThis->size()

			if ( idxThis == muCentDedRessyasyubetsuThis->size() )
			{
				//	̎ʂȂꍇ́A
				//	this ɒǉ܂B
				pCentDedRessyasyubetsuCont->insert( *pCentDedRessyasyubetsuToAdd ) ;
			}
			arRessyasyubetsuIdx_AddedToThis.push_back( idxThis ) ;
		}

		/**
			eʂ̏C
			pCentDedRessyasyubetsuContɒǉꂽʂɐeʂݒ肳ĂꍇA
			̐eʂApCentDedRessyasyubetsuCont̂ǂɂ邩AarRessyasyubetsuIdx_AddedToThisƂɒ܂B
		*/
		for (int idxAdded = iSizeThis; idxAdded < muCentDedRessyasyubetsuThis->size(); idxAdded++)
		{
			CentDedRessyasyubetsu* pCentDedRessyasyubetsuAdded =
				muCentDedRessyasyubetsuThis->get(idxAdded);
			if (pCentDedRessyasyubetsuAdded->getParentSyubetsuIndex() >= 0 &&
				pCentDedRessyasyubetsuAdded->getParentSyubetsuIndex() < (int)arRessyasyubetsuIdx_AddedToThis.size())
			{
				pCentDedRessyasyubetsuAdded->setParentSyubetsuIndex(
					arRessyasyubetsuIdx_AddedToThis[pCentDedRessyasyubetsuAdded->getParentSyubetsuIndex()]);
			}
		}
	}
	//arRessyasyubetsuIdx_AddedToThis[ǉHt@Cx̗ԎʃCfNX] = 
	//	this̗ԎʃCfNX

	//_C̃}[W
	//@@gHt@C̃_Cɂ郋[v
	//@@@@[̃_CҏW̘Ht@Cɑ݂Ȃ]̃_C
	//@@@@@ҏW̘Ht@Cɒǉ
	//@@@@_CΏƕ\(gHt@C̃_CIndex
	//@@@@@gHt@C̃_CIndex ̑Ώƕ\쐬

	deque<int>	arDiaIdx_AddedToThis ;
	{
		CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
		const CentDedDiaCont* pCentDedDiaContToAdd = rosenToAdd.getCentDedDiaCont() ;
		
		const Mu<const CentDedDia*>* muCentDedDiaToAdd =
				pCentDedDiaContToAdd->getMuPtr() ;
		for ( int idxToAdd = 0 ; idxToAdd < muCentDedDiaToAdd->size() ; idxToAdd ++ )
		{
			const CentDedDia* pCentDedDiaToAdd = 
				muCentDedDiaToAdd->get( idxToAdd ) ;

			Mu<CentDedDia*>* muCentDedDiaThis =
				pCentDedDiaCont->getMuPtr() ;
			int idxThis = 0 ;
			for ( idxThis = 0 ; idxThis < muCentDedDiaThis->size() ; idxThis ++ )
			{
				const CentDedDia* pCentDedDiaThis = muCentDedDiaThis->get( idxThis ) ;
				if ( pCentDedDiaThis->getName() == 
					pCentDedDiaToAdd->getName() )
				{
					break ;
				}
			}
			//idxThis = wǉHt@Cx̃_CƓ
			//	this̃_C̃CfNXB
			//	Ȃ΁A  muCentDedDiaThis->size()

			if ( idxThis == muCentDedDiaThis->size() )
			{
				//	̃_CȂꍇ́A
				//	this 
				//	Ԃ̃_Cǉ܂B
				//	i_CIuWFNg𒼐ڒǉƁAԂǉ邽߁A
				//	܂܂) 
				CentDedEkiCont* pCentDedEkiCont = this->getCentDedEkiCont() ;
				CentDedRessyasyubetsuCont* pCentDedRessyasyubetsuCont = this->getCentDedRessyasyubetsuCont() ;
				CentDedDia	diaNew( pCentDedEkiCont->size() ) ;
				diaNew.setName( pCentDedDiaToAdd->getName() ) ;
				pCentDedDiaCont->insert( diaNew ) ;
			}
			arDiaIdx_AddedToThis.push_back( idxThis ) ;
		}

	}
	//arDiaIdx_AddedToThis[ǉHt@Cx̃_CCfNX] = 
	//	this̃_CCfNX

	//gHt@C̗ԂAҏW̘Ht@Cɒǉ
	//@@gHt@C̃_Cɂ郋[v
	//@@@@SԂ̃[v
	//@@@@@@ԂǉB
	//@@@@@@@ǉ_ĆA_CΏƕ\ɂĕϊ
	//@@@@@@@ԎIndex́AԎʑΏƕ\ɏ]ĕϊ
	//
	{
		const Mu<const CentDedDia*>* muCentDedDiaToAdd =
			((const CentDedDiaCont*)rosenToAdd.getCentDedDiaCont())->getMuPtr() ;

		for ( int idxDiaToAdd = 0 ; idxDiaToAdd < muCentDedDiaToAdd->size() ; idxDiaToAdd ++ )
		{
			const CentDedDia* pCentDedDiaToAdd = muCentDedDiaToAdd->get( idxDiaToAdd ) ;

			Mu<CentDedDia*>* muCentDedDiaThis =	this->getCentDedDiaCont()->getMuPtr() ;
			CentDedDia* pCentDedDiaThis = muCentDedDiaThis->get( arDiaIdx_AddedToThis[idxDiaToAdd] ) ;
			//pCentDedDiaThis = Ԃ̃Rs[ƂȂ CentDedDia ;

			//ԁ
			for ( int idxRessyahoukou = (int)Ressyahoukou_Kudari ;
				idxRessyahoukou <= (int)Ressyahoukou_Nobori ;
				idxRessyahoukou ++ )
			{

				ERessyahoukou eRessyahoukou = (ERessyahoukou)idxRessyahoukou ;
				const CentDedRessyaCont* pCentDedRessyaContToAdd = pCentDedDiaToAdd->getCentDedRessyaCont( eRessyahoukou ) ;
				const Mu<const CentDedRessya*>* muCentDedRessyaToAdd = pCentDedRessyaContToAdd->getMuPtr() ;
				CentDedRessyaCont* pCentDedRessyaContThis = pCentDedDiaThis->getCentDedRessyaCont( eRessyahoukou ) ;

				int iEkiOrderToInsert = -1 ;
				if ( eRessyahoukou == Ressyahoukou_Kudari )
				{
					iEkiOrderToInsert = pCentDedRessyaContThis->EkiOrderOfEkiIndex( iEkiIndexToInsertMin + 1 ) ;
				}
				else
				{
					iEkiOrderToInsert = pCentDedRessyaContThis->EkiOrderOfEkiIndex( iEkiIndexToInsertMax - 1 ) ;
				}
				//iEkiOrderToInsert = gHt@C̉wOrder0̗Ԃ}A
				//	this̉wOrder

				for ( int idxRessyaToAdd = 0 ; idxRessyaToAdd < muCentDedRessyaToAdd->size() ; idxRessyaToAdd ++ )
				{
					//	ݕҏW̘Ht@CɁAgHt@C̗Ԃ}
					//	ԎʁEẃÂƂɏC
					const CentDedRessya* pRessyaToAdd = muCentDedRessyaToAdd->get( idxRessyaToAdd ) ;
					pCentDedRessyaContThis->insert( *pRessyaToAdd ) ;
					CentDedRessya* pRessyaAdded = pCentDedRessyaContThis->getMuPtr()->get( INT_MAX ) ;
					//pRessyaAdded = gHt@Cɒǉꂽ
					//	ԎʁEẃÂƂɏC

					//	ԎʃCfNXA
					//	ݕҏW̘Ht@Cɍ킹čXVB
					pRessyaAdded->setRessyasyubetsuIndex( 
						arRessyasyubetsuIdx_AddedToThis[ pRessyaToAdd->getRessyasyubetsuIndex() ] ) ;

					//	wC
					for ( int iEkiOrder = 0 ; iEkiOrder < pCentDedRessyaContThis->getEkiCount() ; iEkiOrder ++ )
					{
						int iEkiOrderToAdd = iEkiOrder - iEkiOrderToInsert ;
						//iEkiOrderToAdd = thisiEkiOrderɑΉA
						//	gHt@C̉wOrder

						if ( 0 <= iEkiOrderToAdd && iEkiOrderToAdd < pCentDedRessyaContToAdd->getEkiCount() )
						{
							//	gHt@C̉wOrderɑΉꍇ́A
							//	gHt@C̉wRs[
							CentDedEkiJikoku aEkiJikokuToAdd = pRessyaToAdd->getCentDedEkiJikoku( iEkiOrderToAdd ) ; 
							pRessyaAdded->setCentDedEkiJikoku( iEkiOrder , aEkiJikokuToAdd ) ;

						}
						else
						{
							//	gHt@C̉wOrderɑΉȂwɑ΂ẮA
							//	^sȂݒ
							pRessyaAdded->setCentDedEkiJikoku( iEkiOrder , CentDedEkiJikoku() ) ;
						}
					}


				}
			}	
		}
	}


	/**
		HOnIw̒ɂ
		gwIndexƑgwIndex+1ɂāAgwIndex+1̉wA̒猟āA
		ꍇ͏ɒǉASĊmFA+1̉wƂ̒s
		gwIndexƑgwIndex-1ɂĂl
		adjustBrunchLoopŝAmergeOuterTerminals
	*/
	//[gwIndexƑgwIndex+1ŁAw]w𕹍
	if ( 0 <= iEkiIndexToInsertMin )
	{
		CentDedEkiCont* pCentDedEkiContThis = getCentDedEkiCont() ;
		CentDedEki*	pEkiToInsertMin = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMin ) ;
		CentDedEki*	pEkiToInsertMin_1 = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMin + 1 ) ;
		if ( pEkiToInsertMin->getEkimei() == pEkiToInsertMin_1->getEkimei() )
		{
			//@@gwIndex̉w`𔭒ɕύX w`ɈˑlύX
			pEkiToInsertMin->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_Hatsuchaku ) ;

			pEkiToInsertMin->setBrunchCoreEkiIndex(-1);
			pEkiToInsertMin->setBrunchOpposite(false);
			pEkiToInsertMin->setJikokuhyouTrackOmit(false);


			//wԐ̒sBgwIndexgwIndex+1̔Ԑꍇ
			//߂镪AgwIndexɒǉB

			//if (pEkiToInsertMin->getEkiTrack2Cont()->size() < pEkiToInsertMin_1->getEkiTrack2Cont()->size())
			//{//ifU̎́AforɓȂ̂ŁAȗ
			for (int iEkiTrack2Index = pEkiToInsertMin->getEkiTrack2Cont()->size();
				iEkiTrack2Index < pEkiToInsertMin_1->getEkiTrack2Cont()->size();
				iEkiTrack2Index++)
			{
				pEkiToInsertMin->getEkiTrack2Cont()->insert(
					pEkiToInsertMin_1->getEkiTrack2Cont()->get(iEkiTrack2Index), INT_MAX);
			}

			//HOw̒
			vector<int> iOuterTerminalMap;
			//iOuterTerminalMapCont̏
			for (int idxot = 0; idxot < pEkiToInsertMin_1->getOuterTerminalEkimeiCount(); idxot++)
			{
				iOuterTerminalMap.push_back(idxot);
			}
			int iCompareResultOuterTerminal = pEkiToInsertMin_1->compareOuterTerminal(pEkiToInsertMin);
			//rʂ-1,2,3ꍇ́ACoreɂȂTargetɂ̂ACoreɒǉĂ
			for (int idxot = 0; idxot < pEkiToInsertMin_1->getOuterTerminalEkimeiCount() &&
				(iCompareResultOuterTerminal >= 2 || iCompareResultOuterTerminal <= -1); idxot++)
			{
				OuterTerminal sOuterTerminal = pEkiToInsertMin_1->getOuterTerminal(idxot);
				int iOuterTerminalExsit = pEkiToInsertMin->searchOuterTerminalEkimei(sOuterTerminal.OuterTerminalEkimei);
				if (iOuterTerminalExsit < 0)
				{
					iOuterTerminalMap[idxot] = pEkiToInsertMin->addOuterTerminalEkimei(sOuterTerminal);
					//pEkiToInsertMin->insertOuterTerminalEkimei(sOuterTerminal, INT_MAX);
					//iOuterTerminalMap[idxot] = pEkiToInsertMin->getOuterTerminalEkimeiCount() - 1;
				}
				else
				{
					iOuterTerminalMap[idxot] = iOuterTerminalExsit;
				}
			}

			m_CentDedDiaCont.adjustBrunchLoopOuterTerminal(
				{ iEkiIndexToInsertMin + 1 },
				iOuterTerminalMap);

			//gwIndex+1̎w܂ł̋AgwIndexɏ
			pEkiToInsertMin->setNextEkiDistance(pEkiToInsertMin_1->getNextEkiDistance());

			//wḰAgwIndex+1vwŁAgwIndexʉwȂAgwIndexvw
			if (pEkiToInsertMin->getEkikibo() == CentDedEki::Ekikibo_Ippan &&
				pEkiToInsertMin_1->getEkikibo() == CentDedEki::Ekikibo_Syuyou)
			{
				pEkiToInsertMin->setEkikibo(CentDedEki::Ekikibo_Syuyou);
			}

			//Ɨ̕ύX gwIndex+1ƑgwIndex̑傫ݒ
			pEkiToInsertMin->setJikokuhyouOperationOrigin(
				max(pEkiToInsertMin->getJikokuhyouOperationOrigin(),
					pEkiToInsertMin_1->getJikokuhyouOperationOrigin()));
			pEkiToInsertMin->setJikokuhyouOperationTerminal(
				max(pEkiToInsertMin->getJikokuhyouOperationTerminal(),
					pEkiToInsertMin_1->getJikokuhyouOperationTerminal()));

			//w gwIndex+1ɐݒ肪AgwIndex̏ꍇ́AɃRs[
			if (pEkiToInsertMin->getEkimeiJikokuhyouRyaku().empty() &&
				!pEkiToInsertMin_1->getEkimeiJikokuhyouRyaku().empty())
			{
				pEkiToInsertMin->setEkimeiJikokuhyouRyaku(pEkiToInsertMin_1->getEkimeiJikokuhyouRyaku());
			}

			/**
				JX^}CY\\ݒ EԐƂAǂ炩̉wŗLȂA\LɂB
				ʕύX݂́AKvȂ(gwIndex+1̘͌H̎nwȂ̂ŁA{\ȂȂ̂)
			*/
			if (!pEkiToInsertMin->getJikokuhyouChakuJikokuDisplayKudari() &&
				pEkiToInsertMin_1->getJikokuhyouChakuJikokuDisplayKudari())
			{
				pEkiToInsertMin->setJikokuhyouChakuJikokuDisplayKudari(true);
			}
			if (!pEkiToInsertMin->getJikokuhyouHatsuJikokuDisplayKudari() &&
				pEkiToInsertMin_1->getJikokuhyouHatsuJikokuDisplayKudari())
			{
				pEkiToInsertMin->setJikokuhyouHatsuJikokuDisplayKudari(true);
			}

			if (!pEkiToInsertMin->getJikokuhyouChakuJikokuDisplayNobori() &&
				pEkiToInsertMin_1->getJikokuhyouChakuJikokuDisplayNobori())
			{
				pEkiToInsertMin->setJikokuhyouChakuJikokuDisplayNobori(true);
			}
			if (!pEkiToInsertMin->getJikokuhyouHatsuJikokuDisplayNobori() &&
				pEkiToInsertMin_1->getJikokuhyouHatsuJikokuDisplayNobori())
			{
				pEkiToInsertMin->setJikokuhyouHatsuJikokuDisplayNobori(true);
			}



			//@@S_C̃[v
			//        SԂ̃[v
			//@@@@@@[gwIndex^sȂ]
			//@@@@@@@gwIndex+1̉wgwIndexɃRs[
			//@@@@SԂ̃[v
			//@@@@@@[gwIndex^sȂ]
			//@@@@@@@gwIndex+1̉wgwIndexɃRs[
			//gwIndexƑgwIndex+1̎{قȂꍇɁA
			//gwIndex+1̉wgwIndexɃRs[ꍇ́A
			CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
			for ( int idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
			{
				CentDedDia* pDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
				for ( int iRessyahoukou = Ressyahoukou_Kudari ;
					iRessyahoukou <= Ressyahoukou_Nobori ;
					iRessyahoukou ++ )
				{
					ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
					
					CentDedRessyaCont* pRessyaCont = pDia->getCentDedRessyaCont( eRessyahoukou ) ;
					int iEkiOrderToInsertMin = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin ) ;
					int iEkiOrderToInsertMin_1 = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMin + 1 ) ;
					for ( int idxRessya = 0 ; idxRessya < pRessyaCont->size() ; idxRessya ++ )
					{
						CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( idxRessya ) ;
						
						CentDedEkiJikoku aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin ) ;
						if ( aEkijikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None )
						{
							aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMin_1 ) ;
							pRessya->setCentDedEkiJikoku( iEkiOrderToInsertMin ,aEkijikoku ) ;
						}
					}
				}
			}
			//Eݒ̏C
			for (int idx = iEkiIndexToInsertMin + 2; idx < pCentDedEkiContThis->size(); idx++)
			{
				CentDedEki* pEki = pCentDedEkiContThis->getMuPtr()->get(idx);
				if (pEki->getBrunchCoreEkiIndex() == iEkiIndexToInsertMin + 1)
				{
					pEki->setBrunchCoreEkiIndex(iEkiIndexToInsertMin);
				}
				if (pEki->getLoopOriginEkiIndex() == iEkiIndexToInsertMin + 1)
				{
					pEki->setLoopOriginEkiIndex(iEkiIndexToInsertMin);
				}
			}
			
			//@@gwIndex+1̉w폜
			pCentDedEkiContThis->erase( iEkiIndexToInsertMin + 1 ) ;
			iEkiIndexToInsertMax -- ;
		}
	}

	//[gwIndexƑgwIndex-1ŁAw]w𕹍
	if ( iEkiIndexToInsertMax < getCentDedEkiCont()->size() - 1 )
	{
		CentDedEkiCont* pCentDedEkiContThis = getCentDedEkiCont() ;
		CentDedEki*	pEkiToInsertMax = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMax ) ;
		CentDedEki*	pEkiToInsertMax_1 = pCentDedEkiContThis->getMuPtr()->get( iEkiIndexToInsertMax - 1 ) ;
		if ( pEkiToInsertMax->getEkimei() == pEkiToInsertMax_1->getEkimei() )
		{
			//gwIndex̉w`𔭒ɕύX w`ɈˑlύX
			pEkiToInsertMax->setEkijikokukeisiki( CentDedEki::Jikokukeisiki_Hatsuchaku ) ;

			pEkiToInsertMax->setBrunchCoreEkiIndex(-1);
			pEkiToInsertMax->setBrunchOpposite(false);
			pEkiToInsertMax->setJikokuhyouTrackOmit(false);

			//wԐ̒sBgwIndexgwIndex-1̔Ԑꍇ
			//߂镪AgwIndexɒǉB
			for (int iEkiTrack2Index = pEkiToInsertMax->getEkiTrack2Cont()->size();
				iEkiTrack2Index < pEkiToInsertMax_1->getEkiTrack2Cont()->size();
				iEkiTrack2Index++)
			{
				pEkiToInsertMax->getEkiTrack2Cont()->insert(
					pEkiToInsertMax_1->getEkiTrack2Cont()->get(iEkiTrack2Index), INT_MAX);
			}

			//HOw̒
			vector<int> iOuterTerminalMap;
			//iOuterTerminalMapCont̏
			for (int idxot = 0; idxot < pEkiToInsertMax_1->getOuterTerminalEkimeiCount(); idxot++)
			{
				iOuterTerminalMap.push_back(idxot);
			}
			int iCompareResultOuterTerminal = pEkiToInsertMax_1->compareOuterTerminal(pEkiToInsertMax);
			//rʂ-1,2,3ꍇ́ACoreɂȂTargetɂ̂ACoreɒǉĂ
			for (int idxot = 0; idxot < pEkiToInsertMax_1->getOuterTerminalEkimeiCount() &&
				(iCompareResultOuterTerminal >= 2 || iCompareResultOuterTerminal <= -1); idxot++)
			{
				OuterTerminal sOuterTerminal = pEkiToInsertMax_1->getOuterTerminal(idxot);
				int iOuterTerminalExsit = pEkiToInsertMax->searchOuterTerminalEkimei(sOuterTerminal.OuterTerminalEkimei);
				if (iOuterTerminalExsit < 0)
				{
					iOuterTerminalMap[idxot] = pEkiToInsertMax->addOuterTerminalEkimei(sOuterTerminal);
					//pEkiToInsertMin->insertOuterTerminalEkimei(sOuterTerminal, INT_MAX);
					//iOuterTerminalMap[idxot] = pEkiToInsertMin->getOuterTerminalEkimeiCount() - 1;
				}
				else
				{
					iOuterTerminalMap[idxot] = iOuterTerminalExsit;
				}
			}

			m_CentDedDiaCont.adjustBrunchLoopOuterTerminal(
				{ iEkiIndexToInsertMax - 1 },
				iOuterTerminalMap);

			//wḰAgwIndex-1vwŁAgwIndex傪ʉwȂAgwIndexvw
			if (pEkiToInsertMax->getEkikibo() == CentDedEki::Ekikibo_Ippan &&
				pEkiToInsertMax_1->getEkikibo() == CentDedEki::Ekikibo_Syuyou)
			{
				pEkiToInsertMax->setEkikibo(CentDedEki::Ekikibo_Syuyou);
			}

			//Ɨ̕ύX gwIndex-1ƑgwIndex̑傫ݒ
			pEkiToInsertMax->setJikokuhyouOperationOrigin(
				max(pEkiToInsertMax->getJikokuhyouOperationOrigin(),
					pEkiToInsertMax_1->getJikokuhyouOperationOrigin()));
			pEkiToInsertMax->setJikokuhyouOperationTerminal(
				max(pEkiToInsertMax->getJikokuhyouOperationTerminal(),
					pEkiToInsertMax_1->getJikokuhyouOperationTerminal()));

			//w gwIndex-1ɐݒ肪AgwIndex傪̏ꍇ́AɃRs[
			if (pEkiToInsertMax->getEkimeiJikokuhyouRyaku().empty() &&
				!pEkiToInsertMax_1->getEkimeiJikokuhyouRyaku().empty())
			{
				pEkiToInsertMax->setEkimeiJikokuhyouRyaku(pEkiToInsertMax_1->getEkimeiJikokuhyouRyaku());
			}

			/**
				JX^}CY\\ݒ EԐƂAǂ炩̉wŗLȂA\LɂB
				ʕύX݂́AKvȂ(gwIndex-1̘͌H̎nwȂ̂ŁA{\ȂȂ̂)
			*/
			if (!pEkiToInsertMax->getJikokuhyouChakuJikokuDisplayKudari() &&
				pEkiToInsertMax_1->getJikokuhyouChakuJikokuDisplayKudari())
			{
				pEkiToInsertMax->setJikokuhyouChakuJikokuDisplayKudari(true);
			}
			if (!pEkiToInsertMax->getJikokuhyouHatsuJikokuDisplayKudari() &&
				pEkiToInsertMax_1->getJikokuhyouHatsuJikokuDisplayKudari())
			{
				pEkiToInsertMax->setJikokuhyouHatsuJikokuDisplayKudari(true);
			}

			if (!pEkiToInsertMax->getJikokuhyouChakuJikokuDisplayNobori() &&
				pEkiToInsertMax_1->getJikokuhyouChakuJikokuDisplayNobori())
			{
				pEkiToInsertMax->setJikokuhyouChakuJikokuDisplayNobori(true);
			}
			if (!pEkiToInsertMax->getJikokuhyouHatsuJikokuDisplayNobori() &&
				pEkiToInsertMax_1->getJikokuhyouHatsuJikokuDisplayNobori())
			{
				pEkiToInsertMax->setJikokuhyouHatsuJikokuDisplayNobori(true);
			}


			//S_C̃[v
			//@@SԂ̃[v
			//@@@@[gwIndex傪^sȂ]
			//@@@@@gwIndex-1̉wgwIndexɃRs[
			//@@SԂ̃[v
			//@@@@[gwIndex傪^sȂ]
			//@@@@@gwIndex-1̉wgwIndexɃRs[
			//gwIndexƑgwIndex+1̎{قȂꍇɁA
			//gwIndex-1̉wgwIndexɃRs[ꍇ́A
			//gwIndexł̗ԔԐugwIndex-1ł̎{ʎwvɕύX
			CentDedDiaCont* pCentDedDiaCont = this->getCentDedDiaCont() ;
			for ( int idxDia = 0 ; idxDia < pCentDedDiaCont->size() ; idxDia ++ )
			{
				CentDedDia* pDia = pCentDedDiaCont->getMuPtr()->get( idxDia ) ;
				for ( int iRessyahoukou = Ressyahoukou_Kudari ;
					iRessyahoukou <= Ressyahoukou_Nobori ;
					iRessyahoukou ++ )
				{
					ERessyahoukou eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
					
					CentDedRessyaCont* pRessyaCont = pDia->getCentDedRessyaCont( eRessyahoukou ) ;
					int iEkiOrderToInsertMax = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax ) ;
					int iEkiOrderToInsertMax_1 = pRessyaCont->EkiOrderOfEkiIndex( iEkiIndexToInsertMax - 1 ) ;
					for ( int idxRessya = 0 ; idxRessya < pRessyaCont->size() ; idxRessya ++ )
					{
						CentDedRessya* pRessya = pRessyaCont->getMuPtr()->get( idxRessya ) ;
						
						CentDedEkiJikoku aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax ) ;
						if ( aEkijikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_None )
						{
							aEkijikoku = pRessya->getCentDedEkiJikoku( iEkiOrderToInsertMax_1 ) ;
							pRessya->setCentDedEkiJikoku( iEkiOrderToInsertMax ,aEkijikoku ) ;
						}
					}
				}
			}
			//@@gwIndex-1̉w폜
			pCentDedEkiContThis->erase( iEkiIndexToInsertMax - 1 ) ;
			iEkiIndexToInsertMax -- ;
		}
	}

	//HOwmerges
	{
		m_CentDedEkiCont.adjustBrunchLoopCont();

		this->mergeOuterTerminal();
	}
	//AwǉHt@Cx̃RgAwݕҏWĂHt@Cx̃Rg̖ɒǉB
	{
		tstring strComment = this->getComment() ;
		strComment += _T("\n\n") ;
		strComment += rosenToAdd.getComment() ;
		this->setComment( strComment ) ;
	}
}

CentDedRosen CentDedRosen::createSubRosen( 
		int iEkiIndex , int iEkiCount ,bool bEnableOuter)const 
{
	CentDedRosen rosenNew = *this ;
	/*
	(0) HO̐ݒ
		wIndex0iEkiIndex-1iEkiIndex + iEkiCountw-1̊ԂɎnIwꍇẢwHOƂ܂B
	
	*/
	if(bEnableOuter)
	{
		Mu<CentDedDia*>* muCentDedDia = rosenNew.getCentDedDiaCont()->getMuPtr();

		for (int idxDia = 0; idxDia < muCentDedDia->size(); idxDia++)
		{
			CentDedDia* pCentDedDia = muCentDedDia->get(idxDia);
			//pCentDedDia = ΏۂƂȂ_C

			//ԁ
			for (int idxRessyahoukou = (int)Ressyahoukou_Kudari;
				idxRessyahoukou <= (int)Ressyahoukou_Nobori;
				idxRessyahoukou++)
			{
				ERessyahoukou eRessyahoukou = (ERessyahoukou)idxRessyahoukou;
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont(eRessyahoukou);
				int iEkiOrderO;	//VH̋N_(ԕɈ˂)
				int iEkiOrderT;	//VH̏I_(ԕɈ˂)
				if (eRessyahoukou == Ressyahoukou_Kudari)
				{
					iEkiOrderO = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndex);
					iEkiOrderT = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndex + iEkiCount - 1);
				}
				else
				{
					iEkiOrderO = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndex + iEkiCount - 1);
					iEkiOrderT = pCentDedRessyaCont->EkiOrderOfEkiIndex(iEkiIndex);
				}
				for (int idxRessya = 0; idxRessya < pCentDedRessyaCont->size(); idxRessya++)
				{
					CentDedRessya* pRessya = pCentDedRessyaCont->getMuPtr()->get(idxRessya);
					if (pRessya->isNull())
					{
						continue;
					}
					int iValidSihatsuEki = pRessya->getValidSihatsuEki();
					int iValidSyuuchakuEki = pRessya->getValidSyuuchakuEki();
					if (iValidSihatsuEki == -1 ||
						iValidSyuuchakuEki == -1)
					{
						continue;
					}
					if (iValidSyuuchakuEki <= iEkiOrderO)
					{
						//̗Ԃ̉^sĂԂAiEkiOrderO܂łȂAΏۂł͂܂B
						continue;
					}
					if (iValidSihatsuEki >= iEkiOrderT)
					{
						//̗Ԃ̉^sĂԂAiEkiOrderTȉȂAΏۂł͂܂B
						continue;
					}

					if (iValidSihatsuEki < iEkiOrderO)
					{
						//̗Ԃ̎nwiEkiOrderOȌꍇ
						for (int ord = iEkiOrderO; ord < iEkiOrderT; ord++)
						{
							if(pRessya->isRunBetweenNextEki(ord) &&
								!pRessya->getCentDedEkiJikoku(ord).getHatsujikoku().isNull())
							//if (pRessya->getCentDedEkiJikoku(ord).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
							//	pRessya->getCentDedEkiJikoku(ord).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
							{
								/**
									Ver2.0 
									iEkiOrderOOɗLnwAordVȗLnwɂȂꍇ́A
									Lnword̊Ԃ́A^sȂioRȂjŖߐsĂ킯ł͂Ȃ̂ŁA
									ĂƐAHOɐݒ肷B
								*/
								//if (getCentDedEkiCont()->isSameBrunchLoopGroup(
								//		pRessya->getSihatsuEki(),
								//		ord,
								//		eRessyahoukou))
								//{
								//	//̗Ԃ̎nwƁA؂oԓł̍ŏ̒ԁEʉ߉wEœO[vȂA
								//	//HOݒ͍s܂B
								//	break;
								//}
								//؂oԓ̍ŏ̒Ԃ܂͒ʉ߉wVȎnwɂ܂B
								CentDedEkiJikoku aCentDedEkiJikokuOld = pRessya->getCentDedEkiJikoku(iValidSihatsuEki);
								//nw̉w擾ANULLł͂Ȃꍇ̂݁Ȁs܂B
								//́AHOnɂꍇAnwݒ肷Kv邩łB
								//Ver2.0LnwȂ̂ŁA͕K݂
								//if (!aCentDedEkiJikokuOld.getHatsujikoku(true).isNull())
								//{
									const CentDedBeforeOperation aFirstOperation = pRessya->getFirstOperation();

									vector<tstring> strOperationNumber;
									//tstring strOuterEkimei = _T("");
									OuterTerminal aOuterTerminal;
									CdDedJikoku aJikoku;
									//̗Ԃ̎nwƂHOn̏ꍇ́A̍ƂHOnwAHOnwA^pԍp܂B
									//ȊȌꍇ́Anw̉wAA^pԍ擾܂B
									if (aFirstOperation.getBOperation()== CentDedBeforeOperation::BOperation_Outer)
									{
										int iEkiIndexSihatsu = getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, iValidSihatsuEki);
										//strOuterEkimei = getCentDedEkiCont()->get(iEkiIndexSihatsu).getOuterTerminalEkimei(
										//	aFirstOperation.getOuterShihatsuekiIndex());
										aOuterTerminal = getCentDedEkiCont()->get(iEkiIndexSihatsu).getOuterTerminal(
											aFirstOperation.getOuterShihatsuekiIndex());
										aJikoku = aFirstOperation.getOuterShihatsuJikoku();
										strOperationNumber = aFirstOperation.getOperationNumber();
									}
									else
									{
										int iEkiIndexSihatsu = getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, iValidSihatsuEki);
										aOuterTerminal.OuterTerminalEkimei = getCentDedEkiCont()->get(iEkiIndexSihatsu).getEkimei();
										aOuterTerminal.OuterTerminalJikokuRyaku = getCentDedEkiCont()->get(iEkiIndexSihatsu).getEkimeiJikokuhyouRyaku();
										//strOuterEkimei = getCentDedEkiCont()->get(iEkiIndexSihatsu).getEkimei();
										aJikoku = aCentDedEkiJikokuOld.getHatsujikoku(true);
										if (aFirstOperation.getBOperation() == CentDedBeforeOperation::BOperation_Out)
										{
											strOperationNumber = aFirstOperation.getOperationNumber();
										}
										else
										{
											strOperationNumber = aFirstOperation.getOperationNumberTemp();
										}
									}

									//擾nwAVnwɓo^Ă邩𒲂ׂ܂B
									//Ȃꍇ͓o^܂B
									CentDedEki* pCentDedEki = rosenNew.getCentDedEkiCont()->getMuPtr()->get(
										getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, ord));
									int iOuterTerminalIndex = pCentDedEki->searchOuterTerminalEkimei(aOuterTerminal.OuterTerminalEkimei);
									if (iOuterTerminalIndex == -1)
									{
										//OuterTerminal sOuterTerminal;
										//sOuterTerminal.OuterTerminalEkimei = strOuterEkimei;
										//iOuterTerminalIndex = pCentDedEki->addOuterTerminalEkimei(aOuterTerminal);
										deque<int> iEkiIndexBrunchLoop;
										int iSize = getCentDedEkiCont()->getEkiIndexBrunchLoop(
											getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, ord), iEkiIndexBrunchLoop);
										for (int idx = 0; idx < iSize; idx++)
										{
											CentDedEki* pCentDedEkiTarget = rosenNew.getCentDedEkiCont()->getMuPtr()->get(
												iEkiIndexBrunchLoop[idx]);
											iOuterTerminalIndex = pCentDedEkiTarget->addOuterTerminalEkimei(aOuterTerminal);
										}
									}

									//aCentDedRessyaTrackNewɍƂݒA
									//Ԃ̎nwVARessyaTrackset܂

									CentDedBeforeOperation	aOperationNewOuter(
										CentDedBeforeOperation::BOperation_Outer,
										iOuterTerminalIndex,
										aJikoku,
										pRessya->getCentDedEkiJikoku(ord).getChakujikoku(true),
										strOperationNumber);
									pRessya->setSihatsuEki(ord);
									CentDedBeforeOperationCont* pBeforeOperationCont = pRessya->getCentDedEkiJikokuCont()
										->getMuPtr()->get(ord)->getCentDedBeforeOperationCont();
									if (pRessya->getFirstOperation().isFirstOperation())
									{
										pBeforeOperationCont->set(aOperationNewOuter, 0);
									}
									else
									{
										pBeforeOperationCont->insert(aOperationNewOuter, 0);
									}
								//}
								break;
							}
						}
					}

					if (iValidSyuuchakuEki > iEkiOrderT)
					{
						//̗Ԃ̏IwiEkiOrderT̏ꍇ
						for (int ord = iEkiOrderT; ord > iEkiOrderO; ord--)
						{
							if (pRessya->isRunBetweenNextEki(ord-1) &&
								!pRessya->getCentDedEkiJikoku(ord).getChakujikoku().isNull())
							//if (pRessya->getCentDedEkiJikoku(ord).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya ||
							//	pRessya->getCentDedEkiJikoku(ord).getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka)
							{
								/**
									Ver2.0
									iEkiOrderTɗLIwAordVȗLnwɂȂꍇ́A
									LIword̊Ԃ́A^sȂioRȂjŖߐsĂ킯ł͂Ȃ̂ŁA
									ĂƐAHOɐݒ肷B
								*/
								//if (getCentDedEkiCont()->isSameBrunchLoopGroup(
								//	pRessya->getSyuuchakuEki(),
								//	ord,
								//	eRessyahoukou))
								//{
								//	//̗Ԃ̏IwƁA؂oԓł̍Ō̒ԁEʉ߉wEœO[vȂA
								//	//HOݒ͍s܂B
								//	break;
								//}
								//؂oԓ̍Ō̒Ԃ܂͒ʉ߉wVȏIwɂ܂B
								CentDedEkiJikoku aCentDedEkiJikokuOld = pRessya->getCentDedEkiJikoku(iValidSyuuchakuEki);
								//Iw̉w擾ANULLł͂Ȃꍇ̂݁Ȁs܂B
								//́AHOIɂꍇAIwݒ肷Kv邩łB
								//Ver2.0LIwȂ̂ŁA͕K݂
								//if (!aCentDedEkiJikokuOld.getChakujikoku(true).isNull())
								//{
									const CentDedAfterOperation aLastOperation = pRessya->getLastOperation();

									//tstring strOuterEkimei = _T("");
									OuterTerminal aOuterTerminal;
									CdDedJikoku aJikoku;
									//̗Ԃ̏IwƂHOȈꍇ́A̍ƂHOIwAHOIwp܂B
									//ȊȌꍇ́AIw̉wA擾܂B
									if (aLastOperation.getAOperation() == CentDedAfterOperation::AOperation_Outer)
									{
										int iEkiIndexSyuuchaku = getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, iValidSyuuchakuEki);
										//strOuterEkimei = getCentDedEkiCont()->get(iEkiIndexSyuuchaku).getOuterTerminalEkimei(
										//	aLastOperation.getOuterShuchakuekiIndex());
										aOuterTerminal = getCentDedEkiCont()->get(iEkiIndexSyuuchaku).getOuterTerminal(
											aLastOperation.getOuterShuchakuekiIndex());
										aJikoku = aLastOperation.getOuterShuchakuJikoku();
									}
									else
									{
										int iEkiIndexSyuuchaku = getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, iValidSyuuchakuEki);
										//strOuterEkimei = getCentDedEkiCont()->get(iEkiIndexSyuuchaku).getEkimei();
										aOuterTerminal.OuterTerminalEkimei = getCentDedEkiCont()->get(iEkiIndexSyuuchaku).getEkimei();
										aOuterTerminal.OuterTerminalJikokuRyaku = getCentDedEkiCont()->get(iEkiIndexSyuuchaku).getEkimeiJikokuhyouRyaku();
										aJikoku = aCentDedEkiJikokuOld.getChakujikoku(true);
									}

									//擾IwAVIwɓo^Ă邩𒲂ׂ܂B
									//Ȃꍇ͓o^܂B
									CentDedEki* pCentDedEki = rosenNew.getCentDedEkiCont()->getMuPtr()->get(
										getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, ord));
									int iOuterTerminalIndex = pCentDedEki->searchOuterTerminalEkimei(aOuterTerminal.OuterTerminalEkimei);
									if (iOuterTerminalIndex == -1)
									{
										//OuterTerminal sOuterTerminal;
										//sOuterTerminal.OuterTerminalEkimei = strOuterEkimei;
										//iOuterTerminalIndex = pCentDedEki->addOuterTerminalEkimei(sOuterTerminal);
										deque<int> iEkiIndexBrunchLoop;
										int iSize = getCentDedEkiCont()->getEkiIndexBrunchLoop(
											getCentDedEkiCont()->EkiIndexOfEkiOrder(eRessyahoukou, ord), iEkiIndexBrunchLoop);
										for (int idx = 0; idx < iSize; idx++)
										{
											CentDedEki* pCentDedEkiTarget = rosenNew.getCentDedEkiCont()->getMuPtr()->get(
												iEkiIndexBrunchLoop[idx]);
											iOuterTerminalIndex = pCentDedEkiTarget->addOuterTerminalEkimei(aOuterTerminal);
										}
									}

									//aCentDedRessyaTrackNewɍƂݒA
									//Ԃ̏IwVARessyaTrackset܂

									CentDedAfterOperation	aOperationNewOuter(
										CentDedAfterOperation::AOperation_Outer,
										iOuterTerminalIndex,
										pRessya->getCentDedEkiJikoku(ord).getHatsujikoku(true),
										aJikoku);

									pRessya->setSyuuchakuEki(ord);
									CentDedAfterOperationCont* pAfterOperationCont = pRessya->getCentDedEkiJikokuCont()
										->getMuPtr()->get(ord)->getCentDedAfterOperationCont();
									if (pRessya->getLastOperation().isLastOperation())
									{
										pAfterOperationCont->set(aOperationNewOuter, INT_MAX);
									}
									else
									{
										pAfterOperationCont->insert(aOperationNewOuter);
									};
								//}
								break;
							}
						}
					}
				}
			}

		}
	}
	/*	
	(1)@VHt@ĆA
	wݕҏWĂHt@CxA
	w肳ꂽ͈͈ȊỎw폜̂ɂȂ܂B
	폜wAwEN_wƂAwݒEݒ͉܂
	*/
	{
		for (int idx = iEkiIndex; idx < iEkiIndex + iEkiCount; idx++)
		{
			CentDedEki* pCentDedEki = rosenNew.getCentDedEkiCont()->getMuPtr()->get(idx);
			if (pCentDedEki->getBrunchCoreEkiIndex() < iEkiIndex ||
				pCentDedEki->getBrunchCoreEkiIndex() >= iEkiIndex + iEkiCount)
			{
				pCentDedEki->setBrunchCoreEkiIndex(-1);
			}
			if (pCentDedEki->getLoopOriginEkiIndex() < iEkiIndex)
			{
				pCentDedEki->setLoopOriginEkiIndex(-1);
			}
		}
		//	wVHt@Cx̏I_̉w폜
		rosenNew.getCentDedEkiCont()->erase( iEkiIndex + iEkiCount , INT_MAX ) ;
		//	wVHt@Cx̋N_̉w폜
		rosenNew.getCentDedEkiCont()->erase( 0 , iEkiIndex ) ;
		//@wVHt@Cx̖̉ẃAuw܂ł̋v܂B
		CentDedEki* pCentDedEkiBottom = rosenNew.getCentDedEkiCont()->getMuPtr()->get(INT_MAX);
		pCentDedEkiBottom->setNextEkiDistance(0);
	}
	/*
	(2)@VH^]ԂɊ܂܂ȂԂ́A폜܂B
	*/
	{
		Mu<CentDedDia*>* muCentDedDia = rosenNew.getCentDedDiaCont()->getMuPtr() ;

		for ( int idxDia = 0 ; idxDia < muCentDedDia->size() ; idxDia ++ )
		{
			CentDedDia* pCentDedDia = muCentDedDia->get( idxDia ) ;
			//pCentDedDia = ΏۂƂȂ_C

			//ԁ
			for ( int idxRessyahoukou = (int)Ressyahoukou_Kudari ;
				idxRessyahoukou <= (int)Ressyahoukou_Nobori ;
				idxRessyahoukou ++ )
			{
				ERessyahoukou eRessyahoukou = (ERessyahoukou)idxRessyahoukou ;
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;

				for ( int idxRessya = 0 ; idxRessya < pCentDedRessyaCont->size() ; idxRessya ++ )
				{
					bool bErase = false ;
					CentDedRessya* pRessya = pCentDedRessyaCont->getMuPtr()->get( idxRessya ) ;

					//	Ԃ^sĂԂȂԂ́A
					//	폜܂B
					if ( !bErase )
					{

						//	Ԃ^sĂԂ̍ŏ̉wOrder
						//	܂B
						int iEkiOrder = 0 ;
						for ( iEkiOrder = 0 ; 
							iEkiOrder < pRessya->getCentDedEkiJikokuCount() ;
							iEkiOrder ++ )
						{
							if ( pRessya->isRunBetweenNextEki( iEkiOrder ) )
							{
								break ;
							}
						}
						//iEkiOrder = Ԃ^sĂԂ̍ŏ̉wOrder
						//	Ȃꍇ́A
						//	pRessya->getCentDedEkiJikokuCount() ƓȂ܂B
						if ( iEkiOrder == pRessya->getCentDedEkiJikokuCount() )
						{
							bErase = true ;	
						}
					}


					//	Ԃ폜
					if ( bErase )
					{
						pCentDedRessyaCont->erase( idxRessya ) ;
						idxRessya -- ;
					}
				}
			}

		}
	}


	return rosenNew ;
}

void CentDedRosen::adjustByEkijikokukeisiki( int iEkiIndex ) 
{
	//S_C̃[v
	for ( int idxDia = 0 ; idxDia < m_CentDedDiaCont.size() ; idxDia ++ )
	{
		CentDedDia* pCentDedDia = m_CentDedDiaCont.getMuPtr()->get( idxDia ) ;
		pCentDedDia->adjustByEkijikokukeisiki(
			&m_CentDedEkiCont ,
			iEkiIndex ) ;
	}
}

void CentDedRosen::invert()
{
	//(0)@HIuWFNg̃Rs[쐬
	CentDedRosen	aRosenBefore = *this ;


	//(1)@Ht@C̉w̏̕яtɂ܂B
	//	ŏ̏Ԃ̘Ht@C̃Rs[AwRs[܂B
	{
		for ( int idxEki = 0 ;idxEki < m_CentDedEkiCont.size() ; idxEki ++ )
		{
			CentDedEki	aEki = aRosenBefore.getCentDedEkiCont()->get( 
				m_CentDedEkiCont.size() - idxEki - 1 ) ;

			m_CentDedEkiCont.set( aEki , idxEki ) ;
		}
	}
	//(2)@w̃vpeB́Aȉ̕ϊs܂B
	//y⑫z
	//	this ̉w̑ύXƁA܂܂ĂԂ̒E
	//	wnwEIw̉w`ύXɔAȄCx
	//	ɂAwύX܂B
	//	aRosenBefore ́A̕ύX󂯂Ỏwێ܂B
	{
		vector<int> iLoopOrigin(m_CentDedEkiCont.size(), -1);
		for ( int idxEki = 0 ; idxEki < m_CentDedEkiCont.size() ; idxEki ++ )  
		{
			CentDedEki*	pEki = m_CentDedEkiCont.getMuPtr()->get( idxEki ) ;

			//(2.1)w͂̂܂

			//(2.2)w`
			//	- 蒅蒅
			//	- 蒅蒅
			//	- 蔭蔭 17.4.14 add_by_d_mania
			//	- 蔭蔭 17.4.14 add_by_d_mania
			{
				CentDedEki::EEkijikokukeisiki eEkijikokukeisiki = pEki->getEkijikokukeisiki() ;
				if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_KudariChaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_NoboriChaku ;
				}
				else if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_NoboriChaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_KudariChaku ;
				}
				else if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_KudariHatsuchaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_NoboriHatsuchaku ;
				}
				else if ( eEkijikokukeisiki == CentDedEki::Jikokukeisiki_NoboriHatsuchaku )
				{
					eEkijikokukeisiki = CentDedEki::Jikokukeisiki_KudariHatsuchaku ;
				}
				pEki->setEkijikokukeisiki( eEkijikokukeisiki ) ;
			}

			//(2.4)_COԏ
			//	  ̓eƏ̓eւ܂B
			{
				CentDedEki::EDiagramRessyajouhouHyouji eRessyajouhouHyoujiKudari = pEki->getDiagramRessyajouhouHyoujiKudari() ;
				CentDedEki::EDiagramRessyajouhouHyouji eRessyajouhouHyoujiNobori = pEki->getDiagramRessyajouhouHyoujiNobori() ;
				pEki->setDiagramRessyajouhouHyoujiKudari( eRessyajouhouHyoujiNobori ) ;
				pEki->setDiagramRessyajouhouHyoujiNobori( eRessyajouhouHyoujiKudari ) ;
			}

			//(2.5)wEݒ
			//BrunchCoreIndex0ȏ̏ꍇA]IndexɕύX܂
			//LoopOriginIndex0ȏ̏ꍇẢw-1ɂAN_wwẢwɑ΂ݒ肵܂
			//̍Ƃ͑̉w̕ύXȂ̂ŁASɍs
			//iLoopOriginźA[VȏI_w]ԖڂɁA[VȋN_w]IndexĂA
			//xSw[vIĂAēx̃[vŐݒ肵܂B
			{

				if (pEki->getBrunchCoreEkiIndex() >= 0)
				{
					pEki->setBrunchCoreEkiIndex(m_CentDedEkiCont.size() - pEki->getBrunchCoreEkiIndex() - 1);
				}
				if (pEki->getLoopOriginEkiIndex() >= 0)
				{
					//VȏI_wIndex́AȑŐN_wIndex̔]ɂȂ܂B
					//VȋN_wIndex́AT̉wIndex(idxEki)̂܂܎g܂B
					iLoopOrigin[m_CentDedEkiCont.size() - pEki->getLoopOriginEkiIndex() - 1]
						= idxEki;
					//T̉wLoopOriginEkiIndex́A-1ɃZbgĂ܂
					pEki->setLoopOriginEkiIndex(-1);
				}
			}
			//(2.6){ݒ
			//Ə̎{ւ܂
			{
				int iDownMain = pEki->getDownMain();
				int iUpMain = pEki->getUpMain();
				pEki->setDownMain(iUpMain);
				pEki->setUpMain(iDownMain);
			}
			//(2.7)JX^\[h\ݒ
			//Ə̕\Lւ܂
			{
				bool bTempKudari = pEki->getJikokuhyouChakuJikokuDisplayKudari();
				bool bTempNobori = pEki->getJikokuhyouChakuJikokuDisplayNobori();
				pEki->setJikokuhyouChakuJikokuDisplayKudari(bTempNobori);
				pEki->setJikokuhyouChakuJikokuDisplayNobori(bTempKudari);
				bTempKudari = pEki->getJikokuhyouHatsuJikokuDisplayKudari();
				bTempNobori = pEki->getJikokuhyouHatsuJikokuDisplayNobori();
				pEki->setJikokuhyouHatsuJikokuDisplayKudari(bTempNobori);
				pEki->setJikokuhyouHatsuJikokuDisplayNobori(bTempKudari);
				bTempKudari = pEki->getJikokuhyouTrackDisplayKudari();
				bTempNobori = pEki->getJikokuhyouTrackDisplayNobori();
				pEki->setJikokuhyouTrackDisplayKudari(bTempNobori);
				pEki->setJikokuhyouTrackDisplayNobori(bTempKudari);

				int iTempKudari = pEki->getJikokuhyouRessyabangouDisplayKudari();
				int iTempNobori = pEki->getJikokuhyouRessyabangouDisplayNobori();
				pEki->setJikokuhyouRessyabangouDisplayKudari(iTempNobori);
				pEki->setJikokuhyouRessyabangouDisplayNobori(iTempKudari); 
				iTempKudari = pEki->getJikokuhyouOperationNumberDisplayKudari();
				iTempNobori = pEki->getJikokuhyouOperationNumberDisplayNobori();
				pEki->setJikokuhyouOperationNumberDisplayKudari(iTempNobori);
				pEki->setJikokuhyouOperationNumberDisplayNobori(iTempKudari);
				iTempKudari = pEki->getJikokuhyouRessyaSyubetsuDisplayKudari();
				iTempNobori = pEki->getJikokuhyouRessyaSyubetsuDisplayNobori();
				pEki->setJikokuhyouRessyaSyubetsuDisplayKudari(iTempNobori);
				pEki->setJikokuhyouRessyaSyubetsuDisplayNobori(iTempKudari);
				iTempKudari = pEki->getJikokuhyouRessyameiDisplayKudari();
				iTempNobori = pEki->getJikokuhyouRessyameiDisplayNobori();
				pEki->setJikokuhyouRessyameiDisplayKudari(iTempNobori);
				pEki->setJikokuhyouRessyameiDisplayNobori(iTempKudari);
			}
			//(2.8)
			//̉w܂ł̋A]ň̉wRs[܂B
			//()A-B-C̘HƂƁAA-BԂ̋AwAB-CԂ̋BwێĂA
			//CwɂĺAɈӖ̂Ȃ̂ƂȂ܂B
			//]́AA-BԂ̋BwAB-CԂ̋CwێKv邽߁A
			//Bw̒lCwɁAAw̒lBwɃRs[܂B
			//Aw̒ĺÂ܂܂łȂłAh~̂0ɂ܂B
			if (idxEki == m_CentDedEkiCont.size() - 1)
			{
				pEki->setNextEkiDistance(0);
			}
			else
			{
				const CentDedEki*	pEkiNext = m_CentDedEkiCont.getMuPtr()->get(idxEki + 1);

				pEki->setNextEkiDistance(pEkiNext->getNextEkiDistance());
			}
			//(2.9)Ԑ̉藪́E藪̂̓ւ
			{
				CentDedEkiTrack2Cont* pEkiTrack2Cont = pEki->getEkiTrack2Cont();
				for (int iEkiTrack2Index = 0; iEkiTrack2Index < pEkiTrack2Cont->size(); iEkiTrack2Index++)
				{
					//藪̂̏ꍇ́Aւs܂B
					CentDedEkiTrack2Cont* pEkiTrack2Cont = pEki->getEkiTrack2Cont();
					CentDedEkiTrack2* pEkiTrack2 = pEkiTrack2Cont->getMuPtr()->get(iEkiTrack2Index);
					if (!pEkiTrack2->getTrackNoboriRyakusyou().empty())
					{
						tstring strKudariRyakusyou = pEkiTrack2->getTrackRyakusyou();
						tstring strNoboriRyakusyou = pEkiTrack2->getTrackNoboriRyakusyou();

						pEkiTrack2->setTrackRyakusyou(strNoboriRyakusyou);
						pEkiTrack2->setTrackNoboriRyakusyou(strKudariRyakusyou);
					}
				}
			}
			//(2.10)Oƕ\̓ւ
			{
				int iOperationOrigin = pEki->getJikokuhyouOperationOrigin();
				int iOperationTerminal = pEki->getJikokuhyouOperationTerminal();
				pEki->setJikokuhyouOperationOrigin(iOperationTerminal);
				pEki->setJikokuhyouOperationTerminal(iOperationOrigin);
			}
		}
		for (int idxEki = 0; idxEki < m_CentDedEkiCont.size(); idxEki++)
		{
			if (iLoopOrigin[idxEki] >= 0)
			{
				CentDedEki*	pEki = m_CentDedEkiCont.getMuPtr()->get(idxEki);
				pEki->setLoopOriginEkiIndex(iLoopOrigin[idxEki]);
			}
		}
	}

	//(3)ׂẴ_CɂāAԂƏԂւ܂B
	//	̂ƂAԂUɂŁA
	//	ŏ̏(w̏̓ւsO)̘HIuWFNg̃Rs[
	//	Ԃ}܂BlłB
	//y⑫z
	//	this ̉w̑ύXƁA܂܂ĂԂ̒E
	//	wnwEIw̉w`ύXɔAȄCx
	//	ɂAwύX܂B
	//	aRosenBefore ́A̕ύX󂯂Ỏwێ܂B
	//	Rs[Ƃ邱ƂɂAw̕ύX邱Ƃł܂B
	{
		for ( int idxDia = 0 ; idxDia < m_CentDedDiaCont.size() ; idxDia ++ )
		{
			CentDedDia* pDia = m_CentDedDiaCont.getMuPtr()->get( idxDia ) ;

			//	E̗ԃReiɃA_v^t
			CaMui<CentDedRessya>	aRessyaContKudariAdapter( pDia->getCentDedRessyaCont( Ressyahoukou_Kudari ) ) ;
			CaMui<CentDedRessya>	aRessyaContNoboriAdapter( pDia->getCentDedRessyaCont( Ressyahoukou_Nobori ) ) ;

			//	ԃRei̓e폜A
			//	Ă̏Ԃ̃Rs[ǉ
			aRessyaContKudariAdapter.getAdaptee()->erase( 0 , INT_MAX ) ;
			aRessyaContKudariAdapter.insert( 
				aRosenBefore.getCentDedDiaCont()->getMuPtr()->get( idxDia )->getCentDedRessyaCont( Ressyahoukou_Nobori ) );

			//	ԃRei̓e폜A
			//	Ă̏Ԃ̃Rs[ǉ
			aRessyaContNoboriAdapter.getAdaptee()->erase( 0 , INT_MAX ) ;
			aRessyaContNoboriAdapter.insert( 
				aRosenBefore.getCentDedDiaCont()->getMuPtr()->get( idxDia )->getCentDedRessyaCont( Ressyahoukou_Kudari ) );

		}
	}

	//E_Cʖւ܂
	{
		setKudariDiaAlias(aRosenBefore.getNoboriDiaAlias());
		setNoboriDiaAlias(aRosenBefore.getKudariDiaAlias());
	}


}
int CentDedRosen::swapRessyasyubetsu( int iRessyasyubetsuIndexA ,
		int iRessyasyubetsuIndexB ) 
{
	int iRv = 0 ;
	// --------------------------------
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexA == INT_MAX ){
			iRessyasyubetsuIndexA = m_CentDedRessyasyubetsuCont.size() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndexA && 
				iRessyasyubetsuIndexA < m_CentDedRessyasyubetsuCont.size() ) ){
			iRv = -1 ;	//	CfNXs

		}
	}
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexB == INT_MAX ){
			iRessyasyubetsuIndexB = m_CentDedRessyasyubetsuCont.size() - 1 ;
		}
		if ( !( 0 <= iRessyasyubetsuIndexB && 
				iRessyasyubetsuIndexB < m_CentDedRessyasyubetsuCont.size() ) ){
			iRv = -1 ;	//	CfNXs

		}
	}
	if ( iRv >= 0 ){
		if ( iRessyasyubetsuIndexA == iRessyasyubetsuIndexB ){
			iRv = -1 ;	//	CfNXs
		}
	}
	// --------------------------------
	//m_CentDedRessyasyubetsuCont ̓ւ
	if ( iRv >= 0 ){
		Mu<CentDedRessyasyubetsu*>*	pIfContGet = m_CentDedRessyasyubetsuCont.getMuPtr() ;
		CentDedRessyasyubetsu	aCentDedRessyasyubetsuA = 
			*pIfContGet->get( iRessyasyubetsuIndexA ) ;
		CentDedRessyasyubetsu	aCentDedRessyasyubetsuB = 
			*pIfContGet->get( iRessyasyubetsuIndexB ) ;
		*pIfContGet->get( iRessyasyubetsuIndexA )  = 
			aCentDedRessyasyubetsuB ; 
		*pIfContGet->get( iRessyasyubetsuIndexB )  = 
			aCentDedRessyasyubetsuA ; 
		//ParentSyubetsuIndex̏CBParentSyubetsuIndexiRessyasyubetsuIndexAiRessyasyubetsuIndexBցA
		//iRessyasyubetsuIndexBiRessyasyubetsuIndexA֕ύX
		for (int idx = 0; idx < pIfContGet->size(); idx++)
		{
			CentDedRessyasyubetsu* pCentDedRessyasyubetsu = pIfContGet->get(idx);
			if (pCentDedRessyasyubetsu->getParentSyubetsuIndex() == iRessyasyubetsuIndexA)
			{
				pCentDedRessyasyubetsu->setParentSyubetsuIndex(iRessyasyubetsuIndexB);
			}
			else if (pCentDedRessyasyubetsu->getParentSyubetsuIndex() == iRessyasyubetsuIndexB)
			{
				pCentDedRessyasyubetsu->setParentSyubetsuIndex(iRessyasyubetsuIndexA);
			}
		}
		// --------------------------------
		//	Ԃ̓ւ
		// --------------------------------
		int iDiaIndex ;
		for ( iDiaIndex = 0 ; iDiaIndex < m_CentDedDiaCont.size() ; iDiaIndex ++ ){
			CentDedDia*	pCentDedDia = m_CentDedDiaCont.getMuPtr()->get( iDiaIndex ) ;
			int iRessyahoukou = 0 ;
			for ( iRessyahoukou = Ressyahoukou_Kudari ; 
					iRessyahoukou <= Ressyahoukou_Nobori ; 
					iRessyahoukou ++ ){
				ERessyahoukou	eRessyahoukou = (ERessyahoukou)iRessyahoukou ;
				
				CentDedRessyaCont* pCentDedRessyaCont = pCentDedDia->getCentDedRessyaCont( eRessyahoukou ) ;
				Mu< CentDedRessya* >* pCentDedRessyaContGet = pCentDedRessyaCont->getMuPtr() ;

				int iRessyaCount = pCentDedRessyaContGet->size() ;

				int iRessyaIndex ;

				//	iRessyasyubetsuIndexA -> iRessyasyubetsuIndexB
				//	iRessyasyubetsuIndexB -> iRessyasyubetsuIndexA 
				for ( iRessyaIndex = 0 ; 
						iRessyaIndex < iRessyaCount ; 
						iRessyaIndex ++ ){
					CentDedRessya*	pCentDedRessya = pCentDedRessyaContGet->get( iRessyaIndex ) ;
					
					int iRessyasyubetsuIndexCurr = pCentDedRessya->getRessyasyubetsuIndex() ;
					if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndexA ){
						iRessyasyubetsuIndexCurr = iRessyasyubetsuIndexB ;	
					}	else if ( iRessyasyubetsuIndexCurr == iRessyasyubetsuIndexB ){
						iRessyasyubetsuIndexCurr = iRessyasyubetsuIndexA ;
					}
					pCentDedRessya->setRessyasyubetsuIndex( iRessyasyubetsuIndexCurr ) ;	
				}
			}
		}
	}

	return ( iRv ) ;
}


void CentDedRosen::adjustOperation()
{
	//S_C̃[v
	for (int idxDia = 0; idxDia < m_CentDedDiaCont.size(); idxDia++)
	{
		CentDedDia* pCentDedDia = m_CentDedDiaCont.getMuPtr()->get(idxDia);
		pCentDedDia->adjustOperation(
			&m_CentDedEkiCont);
	}
}

void CentDedRosen::clear()
{
	m_strName.erase() ;
	m_jikokuKitenJikoku.setTime( 0 , 0 , 0 ) ;
	m_strComment.erase() ;
	m_strKudariDiaAlias.erase();
	m_strNoboriDiaAlias.erase();
	m_bOperationNumberReverse = false;

	m_CentDedDiaCont.erase( 0 , INT_MAX ) ;
	m_CentDedRessyasyubetsuCont.erase( 1 , INT_MAX ) ;
	m_CentDedEkiCont.erase( 0 , INT_MAX ) ;

	// --------------------------------
	{
		//	wԎʁx́AȂƂ݂͑ȂĂ͂Ȃ܂B
		m_CentDedRessyasyubetsuCont.set( 
			CentDedRessyasyubetsu( nameRessyasyubetsuDefault , _T("")  ) , 0 ) ;
	}
};


	// ********************************
	//@name CentDedRosen-qIuWFNg̑̒ʒm
	// ********************************

void CentDedRosen::onEkiInsert( int iEkiIndex ,const vector<int>& iMainTrack)
{
	m_CentDedDiaCont.onEkiInsert( iEkiIndex , iMainTrack) ;
	m_CentDedEkiCont.onEkiInsert(iEkiIndex);
}
void CentDedRosen::onEkiErase( int iEkiIndex  )
{
	m_CentDedDiaCont.onEkiErase( iEkiIndex ) ;
	m_CentDedEkiCont.onEkiErase(iEkiIndex);
}

void CentDedRosen::onRessyasyubetsuInsert( int iRessyasyubetsuIndex )
{
	m_CentDedDiaCont.onRessyasyubetsuInsert( iRessyasyubetsuIndex ) ;
}

void CentDedRosen::onRessyasyubetsuErase( int iRessyasyubetsuIndex )
{
	m_CentDedDiaCont.onRessyasyubetsuErase( iRessyasyubetsuIndex ) ;
}

void CentDedRosen::adjustBrunchLoopByBrunchEdit(
	int iEkiIndex, int iBrunchCoreEkiIndex)
{
	//Ԑ̓
	deque<int> iEkiIndexBrunchOriginSide;
	deque<int> iEkiIndexLoop;
	deque<int> iEkiIndexBrunchTerminalSide;
	vector<int> iOuterTerminalEkimeiMap;

	bool bOriginSide = m_CentDedEkiCont.adjustBrunchLoopByBrunchEdit(
		iEkiIndex, iBrunchCoreEkiIndex,
		iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
		iOuterTerminalEkimeiMap);

	//ԑ̒
	m_CentDedDiaCont.adjustBrunchLoopByBrunchEdit(
		iEkiIndex, bOriginSide,iEkiIndexBrunchOriginSide,
		iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
		iOuterTerminalEkimeiMap);
}

void CentDedRosen::adjustBrunchLoopByLoopEdit(
	int iEkiIndex, int iLoopOriginEkiIndex)
{
	//Ԑ̓
	deque<int> iEkiIndexBrunchOriginSide;
	deque<int> iEkiIndexLoop;
	deque<int> iEkiIndexBrunchTerminalSide;;
	vector<int> iOuterTerminalEkimeiMap;

	int iPosition = m_CentDedEkiCont.adjustBrunchLoopByLoopEdit(
		iEkiIndex, iLoopOriginEkiIndex,
		iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
		iOuterTerminalEkimeiMap);

	//ԑ̒
	m_CentDedDiaCont.adjustBrunchLoopByLoopEdit(
		iEkiIndex, iPosition, iEkiIndexBrunchOriginSide,
		iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
		iOuterTerminalEkimeiMap);
}

void CentDedRosen::OperationConnect(int iDiaIndex)
{
	if (getEnableOperation()>0)
	{
		CDedOperationConnecter aCDedOperationConnecter(
			this,
			getCentDedDiaCont()->getMuPtr()->get(iDiaIndex));
		getCentDedDiaCont()->getMuPtr()->get(iDiaIndex)->setWaitOperationUpdate(false);
	}
	else
	{
		getCentDedDiaCont()->getMuPtr()->get(iDiaIndex)->omitInvalidRessyaFromCustomizeRessyaIndex();
		//getCentDedDiaCont()->getMuPtr()->get(iDiaIndex)->clearCustomizeRessyaIndex();
	}
}

void CentDedRosen::StandardRessyaTrackIndexSearch(
	const int iRessyasyubetsuIndex,
	const ERessyahoukou eRessyahoukou,
	const int iEkiOrder, 
	int iRessyaTrackIndex[])const
{
	//Ver2.0 ԑ̎{ݒPpɔAŏɉw{擾悤ɕύX
	const CentDedEki aEki = getCentDedEkiCont()->get(getCentDedEkiCont()
		->EkiIndexOfEkiOrder(eRessyahoukou, iEkiOrder));
	iRessyaTrackIndex[0] = aEki.getMainTrack(eRessyahoukou);
	iRessyaTrackIndex[1] = aEki.getMainTrack(eRessyahoukou);
	int iKijunDiaIndex = getCentDedDiaCont()->findCentDedDiaByName(_T("^]"));
	if (iKijunDiaIndex < 0)
	{
		return;
	}

	const CentDedRessyaCont* pKijunCentDedRessyaCont =
		getCentDedDiaCont()->getMuPtr()->get(iKijunDiaIndex)
		->getCentDedRessyaCont(eRessyahoukou);

	bool bFoundTeisya = false;
	bool bFoundTsuuka = false;

	//ΏۗԂƓʂŒT
	for (int iKijunRessyaIndex = 0;
		iKijunRessyaIndex < pKijunCentDedRessyaCont->size() && (!bFoundTeisya || !bFoundTsuuka);
		iKijunRessyaIndex++)
	{
		//ΏۗԂƓʂǂmF
		if (pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex)->getRessyasyubetsuIndex() != iRessyasyubetsuIndex)
		{
			continue; //ԂɈڍs
		}
		//
		//ԃRei擾
		const CentDedRessya* pCentDedRessyaStandard = pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex);
		
		const CentDedEkiJikoku aCentDedEkiJikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(iEkiOrder);
		if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Teisya && !bFoundTeisya)
		{
			iRessyaTrackIndex[0] = pCentDedRessyaStandard->getCentDedEkiJikoku(iEkiOrder).getRessyaTrackIndex();
			bFoundTeisya = true;
		}
		else if (aCentDedEkiJikoku.getEkiatsukai() == CentDedEkiJikoku::Ekiatsukai_Tsuuka && !bFoundTsuuka)
		{
			iRessyaTrackIndex[1] = pCentDedRessyaStandard->getCentDedEkiJikoku(iEkiOrder).getRessyaTrackIndex();
			bFoundTsuuka = true;
		}
	}
}

void CentDedRosen::StandardShuntTrackIndexSearch(
	const int iRessyasyubetsuIndex,
	const ERessyahoukou eRessyahoukou,
	const int iChakuEkiOrder,
	const int iHatsuEkiOrder,
	int iShuntTrackIndex[])const
{
	iShuntTrackIndex[0] = 0;
	iShuntTrackIndex[1] = 0;
	int iKijunDiaIndex = getCentDedDiaCont()->findCentDedDiaByName(_T("^]"));
	if (iKijunDiaIndex < 0)
	{
		return;
	}

	const CentDedRessyaCont* pKijunCentDedRessyaCont =
		getCentDedDiaCont()->getMuPtr()->get(iKijunDiaIndex)
		->getCentDedRessyaCont(eRessyahoukou);

	bool bFoundBefore = false;
	bool bFoundAfter = false;

	//ΏۗԂƓʂŒT
	for (int iKijunRessyaIndex = 0;
		iKijunRessyaIndex < pKijunCentDedRessyaCont->size() && (!bFoundBefore || !bFoundAfter);
		iKijunRessyaIndex++)
	{
		//ΏۗԂƓʂǂmF
		if (pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex)->getRessyasyubetsuIndex() != iRessyasyubetsuIndex)
		{
			continue; //ԂɈڍs
		}
		//
		//ԃRei擾
		const CentDedRessya* pCentDedRessyaStandard = pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex);

		/**
			OƂiChakuEkiOrder擾̂́AiHatsuEkiOrder-1̂ƂALIwiChakuEkiOrdervꍇA
				iChakuEkiOrderAiHatsuEkiOrderƂ-1ȊȌꍇ
			OƂiHatsuEkiOrder擾̂́AiChakuEkiOrder-1̂ƂALnwiHatsuEkiOrdervꍇ
		*/
		if (!bFoundBefore)
		{
			if (iChakuEkiOrder != -1 && 
				(iHatsuEkiOrder != -1 || (iHatsuEkiOrder == -1 && iChakuEkiOrder == pCentDedRessyaStandard->getValidSyuuchakuEki())))
			{
				const CentDedEkiJikoku aCentDedEkiJikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(iChakuEkiOrder);
				const CentDedBeforeOperationCont* pBeforeOperationCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
				for (int idx = pBeforeOperationCont->size() - 1; idx >= 0 && !bFoundBefore; idx--)
				{
					const CentDedBeforeOperation aBeforeOperation = pBeforeOperationCont->get(idx);
					if (aBeforeOperation.getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
					{
						iShuntTrackIndex[0] = aBeforeOperation.getShuntTrackIndex();
						bFoundBefore = true;
					}
				}
			}

			if (iChakuEkiOrder == -1 && iHatsuEkiOrder != -1 && iHatsuEkiOrder == pCentDedRessyaStandard->getValidSihatsuEki())
			{
				const CentDedEkiJikoku aCentDedEkiJikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(iHatsuEkiOrder);
				const CentDedBeforeOperationCont* pBeforeOperationCont = aCentDedEkiJikoku.getCentDedBeforeOperationCont();
				for (int idx = pBeforeOperationCont->size() - 1; idx >= 0 && !bFoundBefore; idx--)
				{
					const CentDedBeforeOperation aBeforeOperation = pBeforeOperationCont->get(idx);
					if (aBeforeOperation.getBOperation() == CentDedBeforeOperation::BOperation_Shunt)
					{
						iShuntTrackIndex[0] = aBeforeOperation.getShuntTrackIndex();
						bFoundBefore = true;
					}
				}
			}
		}
		/**
			ƂiHatsuEkiOrder擾̂́AiChakuEkiOrder-1̂ƂALnwiHatsuEkiOrdervꍇA
				iChakuEkiOrderAiHatsuEkiOrderƂ-1ȊȌꍇ
			ƂiHatsuEkiOrder擾̂́AiHatsuEkiOrder-1̂ƂALIwiChakuEkiOrdervꍇ
		*/
		if (!bFoundAfter)
		{
			if (iHatsuEkiOrder != -1 &&
				(iChakuEkiOrder != -1 || (iChakuEkiOrder == -1 && iHatsuEkiOrder == pCentDedRessyaStandard->getValidSihatsuEki())))
			{
				const CentDedEkiJikoku aCentDedEkiJikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(iHatsuEkiOrder);
				const CentDedAfterOperationCont* pAfterOperationCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
				for (int idx = 0; idx < pAfterOperationCont->size() && !bFoundAfter; idx++)
				{
					const CentDedAfterOperation aAfterOperation = pAfterOperationCont->get(idx);
					if (aAfterOperation.getAOperation() == CentDedAfterOperation::AOperation_Shunt)
					{
						iShuntTrackIndex[1] = aAfterOperation.getShuntTrackIndex();
						bFoundAfter = true;
					}
				}
			}

			if (iHatsuEkiOrder == -1 && iChakuEkiOrder != -1 && iChakuEkiOrder == pCentDedRessyaStandard->getValidSyuuchakuEki())
			{
				const CentDedEkiJikoku aCentDedEkiJikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(iChakuEkiOrder);
				const CentDedAfterOperationCont* pAfterOperationCont = aCentDedEkiJikoku.getCentDedAfterOperationCont();
				for (int idx = 0; idx < pAfterOperationCont->size() && !bFoundAfter; idx++)
				{
					const CentDedAfterOperation aAfterOperation = pAfterOperationCont->get(idx);
					if (aAfterOperation.getAOperation() == CentDedAfterOperation::AOperation_Shunt)
					{
						iShuntTrackIndex[1] = aAfterOperation.getShuntTrackIndex();
						bFoundAfter = true;
					}
				}
			}
		}
	}
}

void CentDedRosen::StandardOuterTerminalJikanSearch(
	const int iRessyasyubetsuIndex,
	const ERessyahoukou eRessyahoukou,
	const int iChakuEkiOrder,
	const int iHatsuEkiOrder,
	vector<vector<int>>& iOuterTerminalJikan)const
{
	if (iChakuEkiOrder != -1 && iHatsuEkiOrder != -1)
	{
		if (!getCentDedEkiCont()->isSameBrunchLoopGroup(iChakuEkiOrder, iHatsuEkiOrder, eRessyahoukou))
		{
			return;
		}
	}
	vector<bool> bFound;
	if (iChakuEkiOrder != -1)
	{
		int iCount = getCentDedEkiCont()->get(getCentDedEkiCont()
			->EkiIndexOfEkiOrder(eRessyahoukou, iChakuEkiOrder)).getOuterTerminalEkimeiCount();
		iOuterTerminalJikan.assign(iCount, { 0,0 });
		bFound.assign(iCount, false);
	}
	else if (iHatsuEkiOrder != -1)
	{
		int iCount = getCentDedEkiCont()->get(getCentDedEkiCont()
			->EkiIndexOfEkiOrder(eRessyahoukou, iHatsuEkiOrder)).getOuterTerminalEkimeiCount();
		iOuterTerminalJikan.assign(iCount, { 0,0 });
		bFound.assign(iCount, false);
	}
	else
	{
		return;
	}

	int iKijunDiaIndex = getCentDedDiaCont()->findCentDedDiaByName(_T("^]"));
	if (iKijunDiaIndex < 0)
	{
		return;
	}

	const CentDedRessyaCont* pKijunCentDedRessyaCont =
		getCentDedDiaCont()->getMuPtr()->get(iKijunDiaIndex)
		->getCentDedRessyaCont(eRessyahoukou);

	//ΏۗԂƓʂŒT
	for (int iKijunRessyaIndex = 0;
		iKijunRessyaIndex < pKijunCentDedRessyaCont->size();
		iKijunRessyaIndex++)
	{
		//ΏۗԂƓʂǂmF
		if (pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex)->getRessyasyubetsuIndex() != iRessyasyubetsuIndex)
		{
			continue; //ԂɈڍs
		}
		//
		//ԃRei擾
		const CentDedRessya* pCentDedRessyaStandard = pKijunCentDedRessyaCont->getMuPtr()->get(iKijunRessyaIndex);

		if (iHatsuEkiOrder != -1 &&
			iHatsuEkiOrder == pCentDedRessyaStandard->getValidSihatsuEki())
		{
			const CentDedBeforeOperation aBeforeOperation = pCentDedRessyaStandard->getFirstOperation();
			if (aBeforeOperation.getBOperation() == CentDedBeforeOperation::BOperation_Outer)
			{
				CdDedJikoku aHatsujikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(pCentDedRessyaStandard->getValidSihatsuEki()).getHatsujikoku();
				iOuterTerminalJikan[aBeforeOperation.getOuterShihatsuekiIndex()][0] =
					aHatsujikoku.subJikoku(aBeforeOperation.getOuterShihatsuJikoku());
				iOuterTerminalJikan[aBeforeOperation.getOuterShihatsuekiIndex()][1] =
					aHatsujikoku.subJikoku(aBeforeOperation.getChakuJikoku());
				bFound[aBeforeOperation.getOuterShihatsuekiIndex()] = true;
			}
		}

		if (iChakuEkiOrder != -1 &&
			iChakuEkiOrder == pCentDedRessyaStandard->getValidSyuuchakuEki())
		{
			const CentDedAfterOperation aAfterOperation = pCentDedRessyaStandard->getLastOperation();
			if (aAfterOperation.getAOperation() == CentDedAfterOperation::AOperation_Outer)
			{
				CdDedJikoku aChakujikoku = pCentDedRessyaStandard->getCentDedEkiJikoku(pCentDedRessyaStandard->getValidSyuuchakuEki()).getChakujikoku();
				iOuterTerminalJikan[aAfterOperation.getOuterShuchakuekiIndex()][0] =
					aAfterOperation.getOuterShuchakuJikoku().subJikoku(aChakujikoku);
				iOuterTerminalJikan[aAfterOperation.getOuterShuchakuekiIndex()][1] =
					aAfterOperation.getHatsuJikoku().subJikoku(aChakujikoku);
				bFound[aAfterOperation.getOuterShuchakuekiIndex()] = true;
			}
		}

		bool bAllFound = true;
		for (int idxb = 0; idxb < (int)bFound.size() && bAllFound; idxb++)
		{
			if (!bFound[idxb])
			{
				bAllFound = false;
			}
		}
		if (bAllFound)
		{
			return;
		}
	}
}

void CentDedRosen::adjustBrunchLoopEkiTrack2OuterTerminal(
	const int iEkiIndex, 
	const deque<int>& iEkiIndexBrunchLoopOld,
	const vector<int>& iEkiTrack2Map,
	const vector<int>& iOuterTerminalEkimeiMap)
{
	/**
		iEkiIndexBrunchLoopNew(iEkiIndexƓꈵwQ)߂܂B
		ɁAiEkiIndexBrunchLoopOld(wҏWsÓAiEkiIndexƓꈵwQ)Ƌʂ̂A
		iEkiIndexBrunchLoopɎ߂܂B
	*/
	deque<int> iEkiIndexBrunchLoopNew;
	deque<int> iEkiIndexBrunchLoop;
	int iSize = m_CentDedEkiCont.getEkiIndexBrunchLoop(
		iEkiIndex,
		iEkiIndexBrunchLoopNew);
	for (int idxo = 0; idxo < (int)iEkiIndexBrunchLoopOld.size(); idxo++)
	{
		for (int idxn = 0; idxn < iSize; idxn++)
		{
			if (iEkiIndexBrunchLoopOld[idxo] == iEkiIndexBrunchLoopNew[idxn])
			{
				iEkiIndexBrunchLoop.push_back(iEkiIndexBrunchLoopOld[idxo]);
				break;
			}
		}
	}
	//iEkiIndexBrunchLoopɂ͎gIndexyсAwҏWOアłEݒ肪qĂwIndex
	if ((int)iEkiIndexBrunchLoop.size() > 1)
	{
		/**
			wԐ̕ҏWs܂B
			iEkiIndexōsꂽҏW(wԐ̕ύXE{̕ύXEHOw̕ύX)
			iEkiIndexBrunchLoopɎ߂ĂAw̉wQɓKp܂B
			̍Ƃ́AiEkiIndexBrunchLoop̃TCY2ȏ
			(iEkiIndexȊỎw܂܂Ă)ꍇ̂ݎs܂B
		*/
		m_CentDedEkiCont.adjustBrunchLoopEkiTrack2OuterTerminal(
			iEkiIndex,
			iEkiIndexBrunchLoop);

	}
	if ((int)iEkiIndexBrunchLoop.size() > 0)
	{
		//iEkiTrack2Map̒mFAevf̒lidxƈقȂ̂łꍇ(-1=폜)́A
		//m_CentDedDiaCont.adjustBrunchLoopEkiTrack2sB
		bool bDoAdjust = false;
		for (int idx = 0; idx < (int)iEkiTrack2Map.size(); idx++)
		{
			if (iEkiTrack2Map[idx] != idx &&
				iEkiTrack2Map[idx] != -1)
			{
				bDoAdjust = true;
				break;
			}
		}
		if (bDoAdjust)
		{
			m_CentDedDiaCont.adjustBrunchLoopEkiTrack2(
				iEkiIndexBrunchLoop,
				iEkiTrack2Map);
		}
		//iOuterTerminalEkimeiMapmFAlɊevf̒lidxƈقȂ̂łꍇ(-1=폜)́A
		//m_CentDedDiaCont.adjustBrunchLoopOuterEkimeisB
		bDoAdjust = false;
		for (int idx = 0; idx < (int)iOuterTerminalEkimeiMap.size(); idx++)
		{
			if (iOuterTerminalEkimeiMap[idx] != idx &&
				iOuterTerminalEkimeiMap[idx] != -1)
			{
				bDoAdjust = true;
				break;
			}
		}
		if (bDoAdjust)
		{
			m_CentDedDiaCont.adjustBrunchLoopOuterTerminal(
				iEkiIndexBrunchLoop,
				iOuterTerminalEkimeiMap);
		}
	}
}

void CentDedRosen::mergeOuterTerminal()
{
	vector<bool> bChecked;
	bChecked.resize(m_CentDedEkiCont.size(), false);
	for (int idxEki = 0; idxEki < m_CentDedEkiCont.size(); idxEki++)
	{
		if (bChecked[idxEki])
		{
			continue;
		}
		deque<int> iEkiIndexBrunchOriginSide;
		deque<int> iEkiIndexLoop;
		deque<int> iEkiIndexBrunchTerminalSide;
		int iPosition = m_CentDedEkiCont.getEkiIndexBrunchLoop(
			idxEki,
			iEkiIndexBrunchOriginSide,
			iEkiIndexLoop,
			iEkiIndexBrunchTerminalSide);
		if (iPosition == -1)
		{
			bChecked[idxEki] = true;
		}
		else
		{
			vector<vector<int>> iOuterTerminalMapCont;
			iOuterTerminalMapCont.resize(m_CentDedEkiCont.size());
			/**
				iPosition=0̉wƂāAHOw܂Ƃ߂ĂB
				(1)loop->origin->terminal̏ɁAwƔrĂA
					܂ArΏۉwԖڂiOuterTerminalMapContA
					rĎwɂȂ̂玲wɒǉĂB
				(2)wȊOɘHOwRs[
				(3)iOuterTerminalMapContƂɍƂ̏Cs
			*/
			m_CentDedEkiCont.mergeOuterTerminal(
				iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
				iOuterTerminalMapCont);

			m_CentDedDiaCont.mergeOuterTerminal(
				iEkiIndexBrunchOriginSide, iEkiIndexLoop, iEkiIndexBrunchTerminalSide,
				iOuterTerminalMapCont);

		}
	}
}

} //namespace entDed
